package com.pwt.common.utils;

import java.net.Socket;

public class ProxyUtils {
    public static byte[] hexStringToByteArray(String s) {
        s = s.replaceAll(" ", "");  // 移除所有空格
        int len = s.length();
        byte[] data = new byte[len / 2];
        for (int i = 0; i < len; i += 2) {
            data[i / 2] = (byte) ((Character.digit(s.charAt(i), 16) << 4)
                    + Character.digit(s.charAt(i+1), 16));
        }
        return data;
    }

    public static String bytesToHex(byte[] bytes) {
        StringBuilder sb = new StringBuilder();
        for (byte b : bytes) {
            sb.append(String.format("%02X ", b));  // 将字节转换为两位十六进制表示并加上空格
        }
        return sb.toString().trim();  // 去掉最后一个多余的空格
    }

    public static Boolean isServerClose(Socket socket){
        try{
            socket.sendUrgentData(0xFF);//发送1个字节的紧急数据，默认情况下，服务器端没有开启紧急数据处理，不影响正常通信
            return false;
        }catch(Exception se){
            return true;
        }
    }
}
