package com.pwt.netty.common.test;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

public class DateTimeConverter {
  public static String encodeDatetime(String datetime) throws ParseException {
//     datetime = "2024-2-2 14:46:26";
    SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
    Date date = dateFormat.parse(datetime);
    Calendar calendar = Calendar.getInstance();
    calendar.setTime(date);
    String[] year = Integer.toString(calendar.get(Calendar.YEAR)).split("");

    int month = calendar.get(Calendar.MONTH) + 1;
    int day = calendar.get(Calendar.DAY_OF_MONTH);
    int hour = calendar.get(Calendar.HOUR_OF_DAY);
    int minute = calendar.get(Calendar.MINUTE);
    int second = calendar.get(Calendar.SECOND);


    String hexString = String.format("%02X ", Integer.parseInt(year[0] + year[1]))
        + String.format("%02X ", Integer.parseInt(year[2] + year[3]))
        + String.format("%02X ", month)
        + String.format("%02X ", day)
        + String.format("%02X ", hour)
        + String.format("%02X ", minute)
        + String.format("%02X ", second)
        + "00";

    return hexString;
  }

  public static String decodeDatetime(String hex) {
//     hex = "14 15 06 0B 16 1D 1B 00";
    String[] hexArr = hex.split(" ");
    int[] timeArr = new int[hexArr.length];
    for (int i = 0; i < hexArr.length; i++) {
      timeArr[i] = Integer.parseInt(hexArr[i], 16);
    }

    int year = Integer.parseInt(Integer.toString(timeArr[0]) + Integer.toString(timeArr[1]));
    int month = timeArr[2];
    int day = timeArr[3];
    int hour = timeArr[4];
    int minute = timeArr[5];
    int second = timeArr[6];
    String datetime = String.format("%d-%d-%d %d:%d:%d", year, month, day, hour, minute, second);
    return datetime;
  }

  public static void main(String[] args) throws ParseException {
    String encodedHex = encodeDatetime("2024-02-04 17:35:30.470");
    System.out.println(encodedHex);

    String decodedDatetime = decodeDatetime("02 08 0F 35 02 00 02 00");
    System.out.println(decodedDatetime);
  }
}
