/*
 Navicat Premium Data Transfer

 Source Server         : zk_wx
 Source Server Type    : MySQL
 Source Server Version : 80012
 Source Host           : localhost:3306
 Source Schema         : zk_gz

 Target Server Type    : MySQL
 Target Server Version : 80012
 File Encoding         : 65001

 Date: 11/05/2024 14:18:38
*/

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for gen_table
-- ----------------------------
DROP TABLE IF EXISTS `gen_table`;
CREATE TABLE `gen_table`  (
  `table_id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '编号',
  `table_name` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '表名称',
  `table_comment` varchar(500) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '表描述',
  `sub_table_name` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '关联子表的表名',
  `sub_table_fk_name` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '子表关联的外键名',
  `class_name` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '实体类名称',
  `tpl_category` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT 'crud' COMMENT '使用的模板（crud单表操作 tree树表操作）',
  `package_name` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '生成包路径',
  `module_name` varchar(30) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '生成模块名',
  `business_name` varchar(30) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '生成业务名',
  `function_name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '生成功能名',
  `function_author` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '生成功能作者',
  `gen_type` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '0' COMMENT '生成代码方式（0zip压缩包 1自定义路径）',
  `gen_path` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '/' COMMENT '生成路径（不填默认项目路径）',
  `options` varchar(1000) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '其它生成选项',
  `create_by` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '创建者',
  `create_time` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `update_by` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '更新者',
  `update_time` datetime(0) NULL DEFAULT NULL COMMENT '更新时间',
  `remark` varchar(500) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '备注',
  PRIMARY KEY (`table_id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 3 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci COMMENT = '代码生成业务表' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of gen_table
-- ----------------------------
INSERT INTO `gen_table` VALUES (2, 'pwt_config', '系统配置', NULL, NULL, 'PwtConfig', 'crud', 'com.pwt.system', 'system', 'pwtConfig', '系统配置', 'linyun', '0', '/', '{\"parentMenuId\":1}', 'admin', '2022-11-21 10:36:51', '', '2022-11-21 10:38:02', NULL);
INSERT INTO `gen_table` VALUES (3, 'pwt_robot_fault', '机器人故障信息', NULL, NULL, 'PwtRobotFault', 'crud', 'com.pwt.web', 'web', 'robotFault', '机器人故障信息', 'pwt', '0', '/', '{}', 'admin', '2022-11-23 18:01:00', '', '2022-11-23 18:02:47', NULL);

-- ----------------------------
-- Table structure for gen_table_column
-- ----------------------------
DROP TABLE IF EXISTS `gen_table_column`;
CREATE TABLE `gen_table_column`  (
  `column_id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '编号',
  `table_id` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '归属表编号',
  `column_name` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '列名称',
  `column_comment` varchar(500) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '列描述',
  `column_type` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '列类型',
  `java_type` varchar(500) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT 'JAVA类型',
  `java_field` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT 'JAVA字段名',
  `is_pk` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '是否主键（1是）',
  `is_increment` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '是否自增（1是）',
  `is_required` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '是否必填（1是）',
  `is_insert` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '是否为插入字段（1是）',
  `is_edit` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '是否编辑字段（1是）',
  `is_list` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '是否列表字段（1是）',
  `is_query` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '是否查询字段（1是）',
  `query_type` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT 'EQ' COMMENT '查询方式（等于、不等于、大于、小于、范围）',
  `html_type` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '显示类型（文本框、文本域、下拉框、复选框、单选框、日期控件）',
  `dict_type` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '字典类型',
  `sort` int(11) NULL DEFAULT NULL COMMENT '排序',
  `create_by` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '创建者',
  `create_time` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `update_by` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '更新者',
  `update_time` datetime(0) NULL DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`column_id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 47 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci COMMENT = '代码生成业务表字段' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of gen_table_column
-- ----------------------------
INSERT INTO `gen_table_column` VALUES (15, '2', 'id', '主键id', 'bigint(20)', 'Long', 'id', '1', '1', NULL, '0', NULL, NULL, NULL, 'EQ', 'input', '', 1, 'admin', '2022-11-21 10:36:51', '', '2022-11-21 10:38:02');
INSERT INTO `gen_table_column` VALUES (16, '2', 'system_name', '系统名称', 'varchar(100)', 'String', 'systemName', '0', '0', NULL, '1', '1', '1', '1', 'LIKE', 'input', '', 2, 'admin', '2022-11-21 10:36:51', '', '2022-11-21 10:38:02');
INSERT INTO `gen_table_column` VALUES (17, '2', 'charge_soc', '充电soc', 'decimal(11,2)', 'BigDecimal', 'chargeSoc', '0', '0', NULL, '1', '1', '1', '0', 'EQ', 'input', '', 3, 'admin', '2022-11-21 10:36:52', '', '2022-11-21 10:38:02');
INSERT INTO `gen_table_column` VALUES (18, '2', 'cloud_enabled', '云平台开关', 'char(1)', 'String', 'cloudEnabled', '0', '0', NULL, '1', '1', '1', '0', 'EQ', 'input', '', 4, 'admin', '2022-11-21 10:36:52', '', '2022-11-21 10:38:02');
INSERT INTO `gen_table_column` VALUES (19, '2', 'cloud_address', '云平台地址', 'varchar(100)', 'String', 'cloudAddress', '0', '0', NULL, '1', '1', '1', '0', 'EQ', 'input', '', 5, 'admin', '2022-11-21 10:36:52', '', '2022-11-21 10:38:02');
INSERT INTO `gen_table_column` VALUES (20, '2', 'agreement_type', '协议类型', 'char(1)', 'String', 'agreementType', '0', '0', NULL, '1', '1', '1', '0', 'EQ', 'select', '', 6, 'admin', '2022-11-21 10:36:52', '', '2022-11-21 10:38:02');
INSERT INTO `gen_table_column` VALUES (21, '2', 'robot_ip', '换电机器人ip', 'char(100)', 'String', 'robotIp', '0', '0', NULL, '1', '1', '1', '0', 'EQ', 'input', '', 7, 'admin', '2022-11-21 10:36:52', '', '2022-11-21 10:38:02');
INSERT INTO `gen_table_column` VALUES (22, '2', 'robot_port', '换电机器人端口', 'int(10)', 'Integer', 'robotPort', '0', '0', NULL, '1', '1', '1', '0', 'EQ', 'input', '', 8, 'admin', '2022-11-21 10:36:52', '', '2022-11-21 10:38:02');
INSERT INTO `gen_table_column` VALUES (23, '2', 'scanner_ip', '扫码器ip', 'varchar(100)', 'String', 'scannerIp', '0', '0', NULL, '1', '1', '1', '0', 'EQ', 'input', '', 9, 'admin', '2022-11-21 10:36:52', '', '2022-11-21 10:38:02');
INSERT INTO `gen_table_column` VALUES (24, '2', 'scanner_port', '扫码器端口', 'int(10)', 'Integer', 'scannerPort', '0', '0', NULL, '1', '1', '1', '0', 'EQ', 'input', '', 10, 'admin', '2022-11-21 10:36:52', '', '2022-11-21 10:38:02');
INSERT INTO `gen_table_column` VALUES (25, '2', 'rfid_ip', 'rfid ip', 'varchar(100)', 'String', 'rfidIp', '0', '0', NULL, '1', '1', '1', '0', 'EQ', 'input', '', 11, 'admin', '2022-11-21 10:36:52', '', '2022-11-21 10:38:02');
INSERT INTO `gen_table_column` VALUES (26, '2', 'rfid_port', 'rfid_port', 'int(10)', 'Integer', 'rfidPort', '0', '0', NULL, '1', '1', '1', '0', 'EQ', 'input', '', 12, 'admin', '2022-11-21 10:36:52', '', '2022-11-21 10:38:02');
INSERT INTO `gen_table_column` VALUES (27, '2', 'charger1_ip', '#1充电机ip', 'varchar(100)', 'String', 'charger1Ip', '0', '0', NULL, '1', '1', '1', '0', 'EQ', 'input', '', 13, 'admin', '2022-11-21 10:36:52', '', '2022-11-21 10:38:02');
INSERT INTO `gen_table_column` VALUES (28, '2', 'charger1_port', '#1充电机端口', 'int(10)', 'Integer', 'charger1Port', '0', '0', NULL, '1', '1', '1', '0', 'EQ', 'input', '', 14, 'admin', '2022-11-21 10:36:52', '', '2022-11-21 10:38:02');
INSERT INTO `gen_table_column` VALUES (29, '2', 'charger2_ip', '#2充电机ip', 'varchar(100)', 'String', 'charger2Ip', '0', '0', NULL, '1', '1', '1', '0', 'EQ', 'input', '', 15, 'admin', '2022-11-21 10:36:52', '', '2022-11-21 10:38:02');
INSERT INTO `gen_table_column` VALUES (30, '2', 'charger2_port', '#2充电机端口', 'int(10)', 'Integer', 'charger2Port', '0', '0', NULL, '1', '1', '1', '0', 'EQ', 'input', '', 16, 'admin', '2022-11-21 10:36:52', '', '2022-11-21 10:38:02');
INSERT INTO `gen_table_column` VALUES (31, '2', 'charger3_ip', '#3充电机ip', 'varchar(100)', 'String', 'charger3Ip', '0', '0', NULL, '1', '1', '1', '0', 'EQ', 'input', '', 17, 'admin', '2022-11-21 10:36:52', '', '2022-11-21 10:38:02');
INSERT INTO `gen_table_column` VALUES (32, '2', 'charger3_port', '#3充电机端口', 'int(10)', 'Integer', 'charger3Port', '0', '0', NULL, '1', '1', '1', '0', 'EQ', 'input', '', 18, 'admin', '2022-11-21 10:36:52', '', '2022-11-21 10:38:02');
INSERT INTO `gen_table_column` VALUES (33, '2', 'charger4_ip', '#4充电机ip', 'varchar(100)', 'String', 'charger4Ip', '0', '0', NULL, '1', '1', '1', '0', 'EQ', 'input', '', 19, 'admin', '2022-11-21 10:36:52', '', '2022-11-21 10:38:02');
INSERT INTO `gen_table_column` VALUES (34, '2', 'charger4_port', '#4充电机端口', 'int(10)', 'Integer', 'charger4Port', '0', '0', NULL, '1', '1', '1', '0', 'EQ', 'input', '', 20, 'admin', '2022-11-21 10:36:52', '', '2022-11-21 10:38:02');
INSERT INTO `gen_table_column` VALUES (35, '2', 'charger5_ip', '#5充电机ip', 'varchar(100)', 'String', 'charger5Ip', '0', '0', NULL, '1', '1', '1', '0', 'EQ', 'input', '', 21, 'admin', '2022-11-21 10:36:52', '', '2022-11-21 10:38:02');
INSERT INTO `gen_table_column` VALUES (36, '2', 'charger5_port', '#5充电机端口', 'int(10)', 'Integer', 'charger5Port', '0', '0', NULL, '1', '1', '1', '0', 'EQ', 'input', '', 22, 'admin', '2022-11-21 10:36:52', '', '2022-11-21 10:38:02');
INSERT INTO `gen_table_column` VALUES (37, '2', 'charger6_ip', '#6充电机ip', 'varchar(100)', 'String', 'charger6Ip', '0', '0', NULL, '1', '1', '1', '0', 'EQ', 'input', '', 23, 'admin', '2022-11-21 10:36:52', '', '2022-11-21 10:38:02');
INSERT INTO `gen_table_column` VALUES (38, '2', 'charger6_port', '#6充电机端口', 'int(10)', 'Integer', 'charger6Port', '0', '0', NULL, '1', '1', '1', '0', 'EQ', 'input', '', 24, 'admin', '2022-11-21 10:36:52', '', '2022-11-21 10:38:02');
INSERT INTO `gen_table_column` VALUES (39, '2', 'charger7_ip', '#7充电机ip', 'varchar(100)', 'String', 'charger7Ip', '0', '0', NULL, '1', '1', '1', '0', 'EQ', 'input', '', 25, 'admin', '2022-11-21 10:36:52', '', '2022-11-21 10:38:02');
INSERT INTO `gen_table_column` VALUES (40, '2', 'charger7_port', '#7充电机端口', 'int(10)', 'Integer', 'charger7Port', '0', '0', NULL, '1', '1', '1', '0', 'EQ', 'input', '', 26, 'admin', '2022-11-21 10:36:52', '', '2022-11-21 10:38:02');
INSERT INTO `gen_table_column` VALUES (41, '2', 'charger8_ip', '#8充电机ip', 'varchar(100)', 'String', 'charger8Ip', '0', '0', NULL, '1', '1', '1', '0', 'EQ', 'input', '', 27, 'admin', '2022-11-21 10:36:52', '', '2022-11-21 10:38:02');
INSERT INTO `gen_table_column` VALUES (42, '2', 'charger8_port', '#8充电机端口', 'int(10)', 'Integer', 'charger8Port', '0', '0', NULL, '1', '1', '1', '0', 'EQ', 'input', '', 28, 'admin', '2022-11-21 10:36:52', '', '2022-11-21 10:38:03');
INSERT INTO `gen_table_column` VALUES (43, '3', 'id', '主键id', 'bigint(20)', 'Long', 'id', '1', '1', NULL, '1', NULL, NULL, NULL, 'EQ', 'input', '', 1, 'admin', '2022-11-23 18:01:00', '', '2022-11-23 18:02:47');
INSERT INTO `gen_table_column` VALUES (44, '3', 'index', '下标', 'int(4)', 'Integer', 'index', '0', '0', NULL, '1', '1', '1', '1', 'EQ', 'input', '', 2, 'admin', '2022-11-23 18:01:00', '', '2022-11-23 18:02:47');
INSERT INTO `gen_table_column` VALUES (45, '3', 'fault', '故障信息', 'varchar(100)', 'String', 'fault', '0', '0', NULL, '1', '1', '1', '1', 'EQ', 'input', '', 3, 'admin', '2022-11-23 18:01:01', '', '2022-11-23 18:02:47');
INSERT INTO `gen_table_column` VALUES (46, '3', 'level', '故障等级', 'tinyint(1)', 'Integer', 'level', '0', '0', NULL, '1', '1', '1', '1', 'EQ', 'input', '', 4, 'admin', '2022-11-23 18:01:01', '', '2022-11-23 18:02:47');
INSERT INTO `gen_table_column` VALUES (47, '3', 'enabled', '是否启用(0:未启用 1:已启用)', 'tinyint(1)', 'Integer', 'enabled', '0', '0', NULL, '1', '1', '1', '1', 'EQ', 'input', '', 5, 'admin', '2022-11-23 18:01:01', '', '2022-11-23 18:02:47');

-- ----------------------------
-- Table structure for pwt_alarm_record
-- ----------------------------
DROP TABLE IF EXISTS `pwt_alarm_record`;
CREATE TABLE `pwt_alarm_record`  (
  `record_id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '主键id',
  `alarm_time` datetime(0) NULL DEFAULT NULL COMMENT '发生时间',
  `source_device_id` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL COMMENT '来源设备',
  `create_time` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `source_device_type` int(11) NOT NULL,
  `code` varchar(20) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  PRIMARY KEY (`record_id`) USING BTREE,
  INDEX `pwt_alarm_record_code_index`(`code`) USING BTREE,
  INDEX `pwt_alarm_record_source_device_type_index`(`source_device_type`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1239 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci COMMENT = '告警记录' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of pwt_alarm_record
-- ----------------------------

-- ----------------------------
-- Table structure for pwt_battery
-- ----------------------------
DROP TABLE IF EXISTS `pwt_battery`;
CREATE TABLE `pwt_battery`  (
  `battery_id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '电池id',
  `battery_name` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '名称',
  `battery_type` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '电池类型',
  `battery_factory` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '电池厂商',
  `battery_serial` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '电池组序号',
  `production_time` datetime(0) NULL DEFAULT NULL COMMENT '生产日期',
  `vin` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT 'vin',
  PRIMARY KEY (`battery_id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 5 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci COMMENT = '电池管理' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of pwt_battery
-- ----------------------------
INSERT INTO `pwt_battery` VALUES (1, '先锋', '锂电池', '某某', '01000', '2022-11-29 00:00:00', NULL);
INSERT INTO `pwt_battery` VALUES (2, '超威', '锂电池', '广州某某', '20221205001', '2022-12-05 00:00:00', NULL);
INSERT INTO `pwt_battery` VALUES (3, '超威', '锂电池', '广州某某', '20221205001', '2022-12-05 00:00:00', NULL);
INSERT INTO `pwt_battery` VALUES (4, '超威', '锂电池', '广州某某', '20221205001', '2022-12-05 00:00:00', NULL);
INSERT INTO `pwt_battery` VALUES (5, '超威', '锂电池', '广州某某', '20221205001', '2022-12-05 00:00:00', '111111111');

-- ----------------------------
-- Table structure for pwt_change_battery_record
-- ----------------------------
DROP TABLE IF EXISTS `pwt_change_battery_record`;
CREATE TABLE `pwt_change_battery_record`  (
  `record_id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '主键id',
  `vehicle_no` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '车牌号',
  `vin` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT 'vin',
  `change_battery_sn` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '换下电池SN',
  `change_battery_power` decimal(11, 2) NULL DEFAULT NULL COMMENT '换下电池电量',
  `place_battery_compartment_no` int(2) NULL DEFAULT NULL COMMENT '放置电池仓号',
  `exchange_battery_sn` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '换取电池SN',
  `exchange_battery_power` decimal(11, 2) NULL DEFAULT NULL COMMENT '换取电池电量',
  `take_battery_compartment_no` int(2) NULL DEFAULT NULL COMMENT '取电池仓格号',
  `change_start_time` datetime(0) NULL DEFAULT NULL COMMENT '换电开始时间',
  `change_end_time` datetime(0) NULL DEFAULT NULL COMMENT '换电结束时间',
  PRIMARY KEY (`record_id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 9399 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci COMMENT = '换电记录' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of pwt_change_battery_record
-- ----------------------------

-- ----------------------------
-- Table structure for pwt_charge_record
-- ----------------------------
DROP TABLE IF EXISTS `pwt_charge_record`;
CREATE TABLE `pwt_charge_record`  (
  `record_id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '主键id',
  `vehicle_no` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '车辆编号',
  `charger_no` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '充电机编号',
  `battery_sn` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '电池SN',
  `charge_quantity` decimal(11, 2) NULL DEFAULT NULL COMMENT '充电电量',
  `charge_begin_time` datetime(0) NULL DEFAULT NULL COMMENT '充电开始时间',
  `charge_end_time` datetime(0) NULL DEFAULT NULL COMMENT '充电结束时间',
  `charge_duration` int(11) NULL DEFAULT NULL COMMENT '充电时长',
  `start_soc` int(11) NULL DEFAULT NULL COMMENT '开始SOC',
  `end_soc` int(11) NULL DEFAULT NULL COMMENT '结束soc',
  `stop_reason` int(11) NULL DEFAULT NULL COMMENT '停机原因',
  `charge_mode` int(11) NULL DEFAULT NULL COMMENT '充电模式',
  `create_time` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  PRIMARY KEY (`record_id`) USING BTREE,
  INDEX `pwt_charge_record_charger_no_index`(`charger_no`) USING BTREE,
  INDEX `pwt_charge_record_vehicle_no_index`(`vehicle_no`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 6050 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci COMMENT = '充电记录' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of pwt_charge_record
-- ----------------------------

-- ----------------------------
-- Table structure for pwt_charge_stop_reason
-- ----------------------------
DROP TABLE IF EXISTS `pwt_charge_stop_reason`;
CREATE TABLE `pwt_charge_stop_reason`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `description` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 12 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of pwt_charge_stop_reason
-- ----------------------------
INSERT INTO `pwt_charge_stop_reason` VALUES (1, '报警');
INSERT INTO `pwt_charge_stop_reason` VALUES (2, '正常停止');
INSERT INTO `pwt_charge_stop_reason` VALUES (3, '异常停止');
INSERT INTO `pwt_charge_stop_reason` VALUES (4, '急停停止');
INSERT INTO `pwt_charge_stop_reason` VALUES (5, '时间充满停止');
INSERT INTO `pwt_charge_stop_reason` VALUES (6, '金额充满停止');
INSERT INTO `pwt_charge_stop_reason` VALUES (7, '电量充满停止');
INSERT INTO `pwt_charge_stop_reason` VALUES (8, '远程停止');
INSERT INTO `pwt_charge_stop_reason` VALUES (9, '在线模式本地停止');
INSERT INTO `pwt_charge_stop_reason` VALUES (10, '远程停止');
INSERT INTO `pwt_charge_stop_reason` VALUES (11, '手动停止');
INSERT INTO `pwt_charge_stop_reason` VALUES (12, '自动充满停止');

-- ----------------------------
-- Table structure for pwt_config
-- ----------------------------
DROP TABLE IF EXISTS `pwt_config`;
CREATE TABLE `pwt_config`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '主键id',
  `website_enabled` tinyint(1) NULL DEFAULT NULL COMMENT '站点开关',
  `system_name` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '系统名称',
  `system_ip` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '站控系统ip',
  `system_port` int(11) NULL DEFAULT NULL COMMENT '站控系统端口',
  `admin_expire_time` bigint(20) NULL DEFAULT NULL COMMENT '管理员token有效期(分钟)',
  `last_backup_time` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '上次备份时间',
  `charge_soc` decimal(11, 2) NULL DEFAULT NULL COMMENT '充电soc',
  `cloud_enabled` tinyint(1) NULL DEFAULT NULL COMMENT '云平台开关',
  `cloud_address` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '云平台地址',
  `cloud_account` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '云平台账号',
  `cloud_password` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '云平台密码',
  `agreement_type` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '协议类型',
  `vehicle_cidr` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '车载cidr',
  `robot_ip` char(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '换电机器人ip',
  `robot_port` int(11) NULL DEFAULT NULL COMMENT '换电机器人端口',
  `robot_no` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '换电机器人编号',
  `scanner_ip` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '扫码器ip',
  `scanner_port` int(11) NULL DEFAULT NULL COMMENT '扫码器端口',
  `rfid_ip` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT 'rfid ip',
  `rfid_port` int(11) NULL DEFAULT NULL COMMENT 'rfid_port',
  `charger1_ip` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '#1充电机ip',
  `charger1_port` int(11) NULL DEFAULT NULL COMMENT '#1充电机端口',
  `charger1_no` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '#1充电机编号',
  `charger1_time` datetime(0) NULL DEFAULT NULL COMMENT '#1充电机定时充电时间',
  `charger1_emg` tinyint(1) NULL DEFAULT NULL,
  `charger2_ip` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '#2充电机ip',
  `charger2_port` int(11) NULL DEFAULT NULL COMMENT '#2充电机端口',
  `charger2_no` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '#2充电机编号',
  `charger2_time` datetime(0) NULL DEFAULT NULL COMMENT '#2充电机定时充电时间',
  `charger2_emg` tinyint(1) NULL DEFAULT NULL,
  `charger3_ip` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '#3充电机ip',
  `charger3_port` int(11) NULL DEFAULT NULL COMMENT '#3充电机端口',
  `charger3_no` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '#3充电机编号',
  `charger3_time` datetime(0) NULL DEFAULT NULL COMMENT '#3充电机定时充电时间',
  `charger3_emg` tinyint(1) NULL DEFAULT NULL,
  `charger4_ip` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '#4充电机ip',
  `charger4_port` int(11) NULL DEFAULT NULL COMMENT '#4充电机端口',
  `charger4_no` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '#4充电机编号',
  `charger4_time` datetime(0) NULL DEFAULT NULL COMMENT '#4充电机定时充电时间',
  `charger4_emg` tinyint(1) NULL DEFAULT NULL,
  `charger5_ip` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '#5充电机ip',
  `charger5_port` int(11) NULL DEFAULT NULL COMMENT '#5充电机端口',
  `charger5_no` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '#5充电机编号',
  `charger5_time` datetime(0) NULL DEFAULT NULL COMMENT '#5充电机定时充电时间',
  `charger5_emg` tinyint(1) NULL DEFAULT NULL,
  `charger6_ip` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '#6充电机ip',
  `charger6_port` int(11) NULL DEFAULT NULL COMMENT '#6充电机端口',
  `charger6_no` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '#6充电机编号',
  `charger6_time` datetime(0) NULL DEFAULT NULL COMMENT '#6充电机定时充电时间',
  `charger6_emg` tinyint(1) NULL DEFAULT NULL,
  `charger7_ip` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '#7充电机ip',
  `charger7_port` int(11) NULL DEFAULT NULL COMMENT '#7充电机端口',
  `charger7_no` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '#7充电机编号',
  `charger7_time` datetime(0) NULL DEFAULT NULL COMMENT '#7充电机定时充电时间',
  `charger7_emg` tinyint(1) NULL DEFAULT NULL,
  `charger8_ip` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '#8充电机ip',
  `charger8_port` int(11) NULL DEFAULT NULL COMMENT '#8充电机端口',
  `charger8_no` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '#8充电机编号',
  `charger8_time` datetime(0) NULL DEFAULT NULL COMMENT '#8充电机定时充电时间',
  `charger8_emg` tinyint(1) NULL DEFAULT NULL,
  `is_auto_change_warehouse` bit(1) NULL DEFAULT NULL COMMENT '是否开启自动换仓',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci COMMENT = '系统配置' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of pwt_config
-- ----------------------------
INSERT INTO `pwt_config` VALUES (1, 1, '帕沃特', '127.0.0.1', 3000, 100, '2023年10月17日10点29分31秒', 80.00, 0, 'http://chd.mukucloud.com:8000', 'test', 'test', 'A', '127.0.0.1', '19.168.0.1', 2000, 'Robbot_001', '192.168.0.2', 3000, '192.168.0.3', 2000, '192.168.3.41', 8080, '11111111111113', '2023-08-04 11:00:00', 0, '192.168.3.42', 8080, '22222222222221', '2023-01-13 10:17:23', 1, '192.168.3.43', 8088, '11111111111111', '2023-08-02 14:51:26', 0, '192.168.3.44', 8088, '0', '2023-01-14 00:00:00', 0, '192.168.3.45', 8088, '0', '2023-01-13 12:00:00', 0, '192.168.3.46', 8088, '0', '2023-01-13 10:20:06', 0, '192.168.3.47', 8088, '0', '2023-01-13 10:22:17', 0, '192.168.3.48', 8088, '0', '2023-01-13 10:19:23', 0, b'1');

-- ----------------------------
-- Table structure for pwt_device_type
-- ----------------------------
DROP TABLE IF EXISTS `pwt_device_type`;
CREATE TABLE `pwt_device_type`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `device_type_name` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 5 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci COMMENT = '设备类型表' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of pwt_device_type
-- ----------------------------
INSERT INTO `pwt_device_type` VALUES (1, '站控');
INSERT INTO `pwt_device_type` VALUES (2, '机器人');
INSERT INTO `pwt_device_type` VALUES (3, '充电枪');
INSERT INTO `pwt_device_type` VALUES (4, '电池仓');
INSERT INTO `pwt_device_type` VALUES (5, '车辆');

-- ----------------------------
-- Table structure for pwt_holder_battery_state_cache
-- ----------------------------
DROP TABLE IF EXISTS `pwt_holder_battery_state_cache`;
CREATE TABLE `pwt_holder_battery_state_cache`  (
  `holder_id` int(11) NOT NULL AUTO_INCREMENT,
  `battery_sn` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '电池sn',
  `rated_capacity` int(11) NULL DEFAULT NULL COMMENT '额定容量',
  `soc` int(11) NULL DEFAULT NULL,
  `update_time` datetime(0) NULL DEFAULT NULL,
  PRIMARY KEY (`holder_id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 12 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci COMMENT = '仓位电池状态缓存' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of pwt_holder_battery_state_cache
-- ----------------------------
INSERT INTO `pwt_holder_battery_state_cache` VALUES (1, 'Y232352T0017', 350, 100, '2024-03-07 05:29:52');
INSERT INTO `pwt_holder_battery_state_cache` VALUES (2, 'Y232342J0006', 0, 0, '2024-03-05 11:26:33');
INSERT INTO `pwt_holder_battery_state_cache` VALUES (3, 'Y232342J0001', 350, 100, '2024-02-29 17:55:43');
INSERT INTO `pwt_holder_battery_state_cache` VALUES (4, NULL, NULL, NULL, NULL);
INSERT INTO `pwt_holder_battery_state_cache` VALUES (5, NULL, NULL, NULL, NULL);
INSERT INTO `pwt_holder_battery_state_cache` VALUES (6, NULL, NULL, NULL, NULL);
INSERT INTO `pwt_holder_battery_state_cache` VALUES (7, NULL, NULL, NULL, NULL);
INSERT INTO `pwt_holder_battery_state_cache` VALUES (8, NULL, NULL, NULL, NULL);
INSERT INTO `pwt_holder_battery_state_cache` VALUES (9, NULL, NULL, NULL, NULL);
INSERT INTO `pwt_holder_battery_state_cache` VALUES (10, NULL, NULL, NULL, NULL);
INSERT INTO `pwt_holder_battery_state_cache` VALUES (11, NULL, NULL, NULL, NULL);
INSERT INTO `pwt_holder_battery_state_cache` VALUES (12, NULL, NULL, NULL, NULL);

-- ----------------------------
-- Table structure for pwt_holder_charge
-- ----------------------------
DROP TABLE IF EXISTS `pwt_holder_charge`;
CREATE TABLE `pwt_holder_charge`  (
  `id` bigint(20) NOT NULL COMMENT 'id',
  `holder_no` int(11) NULL DEFAULT NULL COMMENT '仓位',
  `charge_no` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '枪号',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci COMMENT = '仓位和枪号关系表' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of pwt_holder_charge
-- ----------------------------
INSERT INTO `pwt_holder_charge` VALUES (1, 3, '11111111111111');
INSERT INTO `pwt_holder_charge` VALUES (2, 1, '11111111111113');
INSERT INTO `pwt_holder_charge` VALUES (3, 2, '22222222222221');

-- ----------------------------
-- Table structure for pwt_robot_fault
-- ----------------------------
DROP TABLE IF EXISTS `pwt_robot_fault`;
CREATE TABLE `pwt_robot_fault`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '主键id',
  `subscript` int(11) NULL DEFAULT NULL COMMENT '下标',
  `fault` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '故障信息',
  `fault_level` tinyint(1) NULL DEFAULT NULL COMMENT '故障等级',
  `enabled` tinyint(1) NULL DEFAULT NULL COMMENT '是否启用(0:未启用 1:已启用)',
  `code` varchar(20) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL COMMENT '故障代码',
  `source_device_type` int(11) NOT NULL COMMENT '来源设备类型',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 399 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci COMMENT = '机器人故障信息' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of pwt_robot_fault
-- ----------------------------
INSERT INTO `pwt_robot_fault` VALUES (1, 0, '#1电池仓正在充电不能换电', 2, 1, '1000', 2);
INSERT INTO `pwt_robot_fault` VALUES (2, 1, '#2电池仓正在充电不能换电', 2, 1, '1001', 2);
INSERT INTO `pwt_robot_fault` VALUES (3, 2, '#3电池仓正在充电不能换电', 2, 1, '1002', 2);
INSERT INTO `pwt_robot_fault` VALUES (4, 3, '#4电池仓正在充电不能换电', 2, 1, '1003', 2);
INSERT INTO `pwt_robot_fault` VALUES (5, 4, '#5电池仓正在充电不能换电', 2, 1, '1004', 2);
INSERT INTO `pwt_robot_fault` VALUES (6, 5, '#6电池仓正在充电不能换电', 2, 1, '1005', 2);
INSERT INTO `pwt_robot_fault` VALUES (7, 6, '#7电池仓正在充电不能换电', 2, 1, '1006', 2);
INSERT INTO `pwt_robot_fault` VALUES (8, 7, '#8电池仓正在充电不能换电', 2, 1, '1007', 2);
INSERT INTO `pwt_robot_fault` VALUES (9, 8, '#9电池仓正在充电不能换电', 2, 1, '1008', 2);
INSERT INTO `pwt_robot_fault` VALUES (10, 9, '#10电池仓正在充电不能换电', 2, 1, '1009', 2);
INSERT INTO `pwt_robot_fault` VALUES (11, 10, '#11电池仓正在充电不能换电', 2, 1, '1010', 2);
INSERT INTO `pwt_robot_fault` VALUES (12, 11, '#12电池仓正在充电不能换电', 2, 1, '1011', 2);
INSERT INTO `pwt_robot_fault` VALUES (13, 12, '车道急停1报警', 1, 1, '1012', 2);
INSERT INTO `pwt_robot_fault` VALUES (14, 13, '车道急停2报警', 1, 1, '1013', 2);
INSERT INTO `pwt_robot_fault` VALUES (15, 14, '仓位急停1报警', 1, 1, '1014', 2);
INSERT INTO `pwt_robot_fault` VALUES (16, 15, '仓位急停2报警', 1, 1, '1015', 2);
INSERT INTO `pwt_robot_fault` VALUES (17, 16, '换电过程中切换到手动状态停止换电报警', 2, 1, '1016', 2);
INSERT INTO `pwt_robot_fault` VALUES (18, 17, '换电过程中从远程切换到本地状态停止换电报警', 2, 1, '1017', 2);
INSERT INTO `pwt_robot_fault` VALUES (19, 18, '换电过程中从本地切换到远程状态停止换电报警', 2, 1, '1018', 2);
INSERT INTO `pwt_robot_fault` VALUES (20, 19, '车辆已上锁或未连接上，停止换电', 2, 1, '1019', 2);
INSERT INTO `pwt_robot_fault` VALUES (21, 20, '停车位置错误', 2, 1, '1020', 2);
INSERT INTO `pwt_robot_fault` VALUES (22, 21, '大车给定位置错误', 2, 1, '1021', 2);
INSERT INTO `pwt_robot_fault` VALUES (23, 22, '小车给定位置错误', 2, 1, '1022', 2);
INSERT INTO `pwt_robot_fault` VALUES (24, 23, '升降给定位置错误', 2, 1, '1023', 2);
INSERT INTO `pwt_robot_fault` VALUES (25, 24, '起升过热', 2, 1, '1024', 2);
INSERT INTO `pwt_robot_fault` VALUES (26, 25, '升降上限位报警', 2, 1, '1025', 2);
INSERT INTO `pwt_robot_fault` VALUES (27, 26, '升降下限位报警', 2, 1, '1026', 2);
INSERT INTO `pwt_robot_fault` VALUES (28, 27, '小车前限位报警', 2, 1, '1027', 2);
INSERT INTO `pwt_robot_fault` VALUES (29, 28, '小车后限位报警', 2, 1, '1028', 2);
INSERT INTO `pwt_robot_fault` VALUES (30, 29, '大车前限位报警', 2, 1, '1029', 2);
INSERT INTO `pwt_robot_fault` VALUES (31, 30, '大车后限位报警', 2, 1, '1030', 2);
INSERT INTO `pwt_robot_fault` VALUES (32, 31, '仓位下降高度报警', 2, 1, '1031', 2);
INSERT INTO `pwt_robot_fault` VALUES (33, 32, '就地仓位设置超限错误', 2, 1, '1032', 2);
INSERT INTO `pwt_robot_fault` VALUES (34, 33, '远程仓位设置超限错误', 3, 1, '1033', 2);
INSERT INTO `pwt_robot_fault` VALUES (35, 34, '取电池仓位上没有电池错误', 2, 1, '1034', 2);
INSERT INTO `pwt_robot_fault` VALUES (36, 35, '放电池仓位上有电池错误', 2, 1, '1035', 2);
INSERT INTO `pwt_robot_fault` VALUES (37, 36, 'X方向测量超出报错', 2, 1, '1036', 2);
INSERT INTO `pwt_robot_fault` VALUES (38, 37, 'Y方向测量超出报错', 2, 1, '1037', 2);
INSERT INTO `pwt_robot_fault` VALUES (39, 38, 'Z方向测量超出报错', 2, 1, '1038', 2);
INSERT INTO `pwt_robot_fault` VALUES (40, 39, '初始换电状态爪上有电池不能换电报警', 2, 1, '1039', 2);
INSERT INTO `pwt_robot_fault` VALUES (41, 40, '初始换电状态吊具电池检测1亮不能换电报警', 2, 1, '1040', 2);
INSERT INTO `pwt_robot_fault` VALUES (42, 41, '初始换电状态吊具电池检测2亮不能换电报警', 2, 1, '1041', 2);
INSERT INTO `pwt_robot_fault` VALUES (43, 42, '初始换电状态下夹具没有关闭不能换电报警', 2, 1, '1042', 2);
INSERT INTO `pwt_robot_fault` VALUES (44, 43, '车位下降高度报警', 2, 1, '1043', 2);
INSERT INTO `pwt_robot_fault` VALUES (45, 44, '火警报警', 1, 1, '1044', 2);
INSERT INTO `pwt_robot_fault` VALUES (46, 45, '', NULL, NULL, '1045', 2);
INSERT INTO `pwt_robot_fault` VALUES (47, 46, '', NULL, NULL, '1046', 2);
INSERT INTO `pwt_robot_fault` VALUES (48, 47, '', NULL, NULL, '1047', 2);
INSERT INTO `pwt_robot_fault` VALUES (49, 48, '行走方向上1#电池仓未归位报警', 2, 1, '1048', 2);
INSERT INTO `pwt_robot_fault` VALUES (50, 49, '行走方向上2#电池仓未归位报警', 2, 1, '1049', 2);
INSERT INTO `pwt_robot_fault` VALUES (51, 50, '行走方向上3#电池仓未归位报警', 2, 1, '1050', 2);
INSERT INTO `pwt_robot_fault` VALUES (52, 51, '行走方向上4#电池仓未归位报警', 2, 1, '1051', 2);
INSERT INTO `pwt_robot_fault` VALUES (53, 52, '行走方向上5#电池仓未归位报警', 2, 1, '1052', 2);
INSERT INTO `pwt_robot_fault` VALUES (54, 53, '行走方向上6#电池仓未归位报警', 2, 1, '1053', 2);
INSERT INTO `pwt_robot_fault` VALUES (55, 54, '行走方向上7#电池仓未归位报警', 2, 1, '1054', 2);
INSERT INTO `pwt_robot_fault` VALUES (56, 55, '行走方向上8#电池仓未归位报警', 2, 1, '1055', 2);
INSERT INTO `pwt_robot_fault` VALUES (57, 56, '行走方向上9#电池仓未归位报警', 2, 1, '1056', 2);
INSERT INTO `pwt_robot_fault` VALUES (58, 57, '行走方向上10#电池仓未归位报警', 2, 1, '1057', 2);
INSERT INTO `pwt_robot_fault` VALUES (59, 58, '行走方向上11#电池仓未归位报警', 2, 1, '1058', 2);
INSERT INTO `pwt_robot_fault` VALUES (60, 59, '行走方向上12#电池仓未归位报警', 2, 1, '1059', 2);
INSERT INTO `pwt_robot_fault` VALUES (61, 60, '', NULL, NULL, '1060', 2);
INSERT INTO `pwt_robot_fault` VALUES (62, 61, '', NULL, NULL, '1061', 2);
INSERT INTO `pwt_robot_fault` VALUES (63, 62, '', NULL, NULL, '1062', 2);
INSERT INTO `pwt_robot_fault` VALUES (64, 63, '', NULL, NULL, '1063', 2);
INSERT INTO `pwt_robot_fault` VALUES (65, 64, '起升变频器驱动器过热', 2, 1, '1064', 2);
INSERT INTO `pwt_robot_fault` VALUES (66, 65, '起升电机过载', 2, 1, '1065', 2);
INSERT INTO `pwt_robot_fault` VALUES (67, 66, '起升电机供应电源过电压', 2, 1, '1066', 2);
INSERT INTO `pwt_robot_fault` VALUES (68, 67, '起升供应电源欠电压', 2, 1, '1067', 2);
INSERT INTO `pwt_robot_fault` VALUES (69, 68, '小车变频器驱动器过热', 2, 1, '1068', 2);
INSERT INTO `pwt_robot_fault` VALUES (70, 69, '小车电机供应电源过电压', 2, 1, '1069', 2);
INSERT INTO `pwt_robot_fault` VALUES (71, 70, '小车变频器过载', 2, 1, '1070', 2);
INSERT INTO `pwt_robot_fault` VALUES (72, 71, '小车供应电源欠电压', 2, 1, '1071', 2);
INSERT INTO `pwt_robot_fault` VALUES (73, 72, '起升电机热保护', 2, 1, '1072', 2);
INSERT INTO `pwt_robot_fault` VALUES (74, 73, '起升上限位', 2, 1, '1073', 2);
INSERT INTO `pwt_robot_fault` VALUES (75, 74, '起升下限位', 2, 1, '1074', 2);
INSERT INTO `pwt_robot_fault` VALUES (76, 75, '小车前限位', 2, 1, '1075', 2);
INSERT INTO `pwt_robot_fault` VALUES (77, 76, '小车后限位', 2, 1, '1076', 2);
INSERT INTO `pwt_robot_fault` VALUES (78, 77, '小车读码头错误', 2, 1, '1077', 2);
INSERT INTO `pwt_robot_fault` VALUES (79, 78, '触摸屏急停报警', 2, 1, '1078', 2);
INSERT INTO `pwt_robot_fault` VALUES (80, 79, '现场急停报警', 2, 1, '1079', 2);
INSERT INTO `pwt_robot_fault` VALUES (81, 80, 'Z轴初始化错误', 2, 1, '1080', 2);
INSERT INTO `pwt_robot_fault` VALUES (82, 81, 'X轴初始化错误', 2, 1, '1081', 2);
INSERT INTO `pwt_robot_fault` VALUES (83, 82, 'Z轴伺服故障', 2, 1, '1082', 2);
INSERT INTO `pwt_robot_fault` VALUES (84, 83, 'X轴伺服故障', 2, 1, '1083', 2);
INSERT INTO `pwt_robot_fault` VALUES (85, 84, 'XZ轴定位失败', 2, 1, '1084', 2);
INSERT INTO `pwt_robot_fault` VALUES (86, 85, '设备在手动状态，不能进行自动操作', 2, 1, '1085', 2);
INSERT INTO `pwt_robot_fault` VALUES (87, 86, '设备在自动状态，不能进行手动操作', 2, 1, '1086', 2);
INSERT INTO `pwt_robot_fault` VALUES (88, 87, '设备在远程状态，不能进行就地操作', 2, 1, '1087', 2);
INSERT INTO `pwt_robot_fault` VALUES (89, 88, '大车变频器驱动器过热', 2, 1, '1088', 2);
INSERT INTO `pwt_robot_fault` VALUES (90, 89, '大车变频器过载', 2, 1, '1089', 2);
INSERT INTO `pwt_robot_fault` VALUES (91, 90, '大车变频器供应电源过电压', 2, 1, '1090', 2);
INSERT INTO `pwt_robot_fault` VALUES (92, 91, '大车变频器供应电源欠电压', 2, 1, '1091', 2);
INSERT INTO `pwt_robot_fault` VALUES (93, 92, '大车前限位', 2, 1, '1092', 2);
INSERT INTO `pwt_robot_fault` VALUES (94, 93, '大车后限位', 2, 1, '1093', 2);
INSERT INTO `pwt_robot_fault` VALUES (95, 94, '大车读码头错误', 2, 1, '1094', 2);
INSERT INTO `pwt_robot_fault` VALUES (96, 95, '', NULL, NULL, '1095', 2);
INSERT INTO `pwt_robot_fault` VALUES (97, 96, '夹具打开超时报警', 2, 1, '1096', 2);
INSERT INTO `pwt_robot_fault` VALUES (98, 97, '夹具关闭超时报警', 2, 1, '1097', 2);
INSERT INTO `pwt_robot_fault` VALUES (99, 98, '爪上有电池左着箱限位1打开夹具报警', 2, 1, '1098', 2);
INSERT INTO `pwt_robot_fault` VALUES (100, 99, '爪上有电池左着箱限位2关闭夹具报警', 2, 1, '1099', 2);
INSERT INTO `pwt_robot_fault` VALUES (101, 100, '爪上有电池右着箱限位3打开夹具报警', 2, 1, '1100', 2);
INSERT INTO `pwt_robot_fault` VALUES (102, 101, '爪上有电池右着箱限位4关闭夹具报警', 2, 1, '1101', 2);
INSERT INTO `pwt_robot_fault` VALUES (103, 102, '吊具1位置超上限报警', 2, 1, '1102', 2);
INSERT INTO `pwt_robot_fault` VALUES (104, 103, '吊具1位置超下限报警', 2, 1, '1103', 2);
INSERT INTO `pwt_robot_fault` VALUES (105, 104, '吊车上软限位报警', 2, 1, '1104', 2);
INSERT INTO `pwt_robot_fault` VALUES (106, 105, '吊车下软限位报警', 2, 1, '1105', 2);
INSERT INTO `pwt_robot_fault` VALUES (107, 106, '小车北软限位报警', 2, 1, '1106', 2);
INSERT INTO `pwt_robot_fault` VALUES (108, 107, '小车南软限位报警', 2, 1, '1107', 2);
INSERT INTO `pwt_robot_fault` VALUES (109, 108, '吊具过载报警', 2, 1, '1108', 2);
INSERT INTO `pwt_robot_fault` VALUES (110, 109, '大车东软限位报警', 2, 1, '1109', 2);
INSERT INTO `pwt_robot_fault` VALUES (111, 110, '大车西软限位报警', 2, 1, '1110', 2);
INSERT INTO `pwt_robot_fault` VALUES (112, 111, '', NULL, NULL, '1111', 2);
INSERT INTO `pwt_robot_fault` VALUES (113, 112, '1#电池仓通讯错误', 2, 1, '1112', 2);
INSERT INTO `pwt_robot_fault` VALUES (114, 113, '2#电池仓通讯错误', 2, 1, '1113', 2);
INSERT INTO `pwt_robot_fault` VALUES (115, 114, '3#电池仓通讯错误', 2, 1, '1114', 2);
INSERT INTO `pwt_robot_fault` VALUES (116, 115, '4#电池仓通讯错误', 2, 1, '1115', 2);
INSERT INTO `pwt_robot_fault` VALUES (117, 116, '5#电池仓通讯错误', 2, 1, '1116', 2);
INSERT INTO `pwt_robot_fault` VALUES (118, 117, '6#电池仓通讯错误', 2, 1, '1117', 2);
INSERT INTO `pwt_robot_fault` VALUES (119, 118, '7#电池仓通讯错误', 2, 1, '1118', 2);
INSERT INTO `pwt_robot_fault` VALUES (120, 119, '8#电池仓通讯错误', 2, 1, '1119', 2);
INSERT INTO `pwt_robot_fault` VALUES (121, 120, '9#电池仓通讯错误', 2, 1, '1120', 2);
INSERT INTO `pwt_robot_fault` VALUES (122, 121, '10#电池仓通讯错误', 2, 1, '1121', 2);
INSERT INTO `pwt_robot_fault` VALUES (123, 122, '11#电池仓通讯错误', 2, 1, '1122', 2);
INSERT INTO `pwt_robot_fault` VALUES (124, 123, '12#电池仓通讯错误', 2, 1, '1123', 2);
INSERT INTO `pwt_robot_fault` VALUES (125, 124, '仓位安全门警告', 2, 1, '1124', 2);
INSERT INTO `pwt_robot_fault` VALUES (126, 125, '维修台安全门警告', 2, 1, '1125', 2);
INSERT INTO `pwt_robot_fault` VALUES (127, 126, '行车运行中人员检测1警告', 6, 1, '1126', 2);
INSERT INTO `pwt_robot_fault` VALUES (128, 127, '行车运行中人员检测2警告', 6, 1, '1127', 2);
INSERT INTO `pwt_robot_fault` VALUES (129, 128, '小车已行走但是读码尺未输出', 2, 1, '1128', 2);
INSERT INTO `pwt_robot_fault` VALUES (130, 129, '大车已行走但是读码尺未输出', 2, 1, '1129', 2);
INSERT INTO `pwt_robot_fault` VALUES (131, 130, '吊具未升到顶行车不能移动', 2, 1, '1130', 2);
INSERT INTO `pwt_robot_fault` VALUES (132, 131, '吊具抓上未检测到电池', 2, 1, '1131', 2);
INSERT INTO `pwt_robot_fault` VALUES (133, 132, '编码器通讯故障', 2, 1, '1132', 2);
INSERT INTO `pwt_robot_fault` VALUES (134, 133, '大车读码头通讯故障', 2, 1, '1133', 2);
INSERT INTO `pwt_robot_fault` VALUES (135, 134, '起升变频器嵌入式以太网通讯中断', 2, 1, '1134', 2);
INSERT INTO `pwt_robot_fault` VALUES (136, 135, '小车变频器嵌入式以太网通讯中断', 2, 1, '1135', 2);
INSERT INTO `pwt_robot_fault` VALUES (137, 136, '大车变频器嵌入式以太网通讯中断', 2, 1, '1136', 2);
INSERT INTO `pwt_robot_fault` VALUES (138, 137, '起升电机变频器错误', 2, 1, '1137', 2);
INSERT INTO `pwt_robot_fault` VALUES (139, 138, '小车电机变频器错误', 2, 1, '1138', 2);
INSERT INTO `pwt_robot_fault` VALUES (140, 139, '大车电机变频器错误', 2, 1, '1139', 2);
INSERT INTO `pwt_robot_fault` VALUES (141, 140, '换仓结束后空仓没有电池报警', 2, 1, '1140', 2);
INSERT INTO `pwt_robot_fault` VALUES (142, 141, '升降已下降但是编码器未输出', 2, 1, '1141', 2);
INSERT INTO `pwt_robot_fault` VALUES (143, 142, '', NULL, NULL, '1142', 2);
INSERT INTO `pwt_robot_fault` VALUES (144, 143, '', NULL, NULL, '1143', 2);
INSERT INTO `pwt_robot_fault` VALUES (145, 144, '换电前满仓没有电池报警', 2, 1, '1144', 2);
INSERT INTO `pwt_robot_fault` VALUES (146, 145, '换电结束后满仓还有电池报警', 2, 1, '1145', 2);
INSERT INTO `pwt_robot_fault` VALUES (147, 146, '换电前空仓有电池报警', 2, 1, '1146', 2);
INSERT INTO `pwt_robot_fault` VALUES (148, 147, '换电结束后空仓没有电池报警', 2, 1, '1147', 2);
INSERT INTO `pwt_robot_fault` VALUES (149, 148, '换仓结束后满电池仓未回归报警', 2, 1, '1148', 2);
INSERT INTO `pwt_robot_fault` VALUES (150, 149, '换仓结束后空电池仓未回归报警', 2, 1, '1149', 2);
INSERT INTO `pwt_robot_fault` VALUES (151, 150, '换电结束后满电池仓未回归报警', 2, 1, '1150', 2);
INSERT INTO `pwt_robot_fault` VALUES (152, 151, '换电结束后空电池仓未回归报警', 2, 1, '1151', 2);
INSERT INTO `pwt_robot_fault` VALUES (153, 152, '地面柜通讯故障', 2, 1, '1152', 2);
INSERT INTO `pwt_robot_fault` VALUES (154, 153, '小车读码头通讯故障', 2, 1, '1153', 2);
INSERT INTO `pwt_robot_fault` VALUES (155, 154, '吊具通讯故障', 2, 1, '1154', 2);
INSERT INTO `pwt_robot_fault` VALUES (156, 155, '仓位室从站1通讯故障', 2, 1, '1155', 2);
INSERT INTO `pwt_robot_fault` VALUES (157, 156, '仓位室从站2通讯故障', 2, 1, '1156', 2);
INSERT INTO `pwt_robot_fault` VALUES (158, 157, '', NULL, NULL, '1157', 2);
INSERT INTO `pwt_robot_fault` VALUES (159, 158, '', NULL, NULL, '1158', 2);
INSERT INTO `pwt_robot_fault` VALUES (160, 159, '', NULL, NULL, '1159', 2);
INSERT INTO `pwt_robot_fault` VALUES (161, 160, '1#仓位 Alarm', 2, 1, '1160', 2);
INSERT INTO `pwt_robot_fault` VALUES (162, 161, '1#仓位 GK01 推出到位减速开关故障', 2, 0, '1161', 2);
INSERT INTO `pwt_robot_fault` VALUES (163, 162, '1#仓位 GK03 缩回到位减速开关故障', 2, 0, '1162', 2);
INSERT INTO `pwt_robot_fault` VALUES (164, 163, '1#仓位 移动台推出未离开监控位置', 2, 0, '1163', 2);
INSERT INTO `pwt_robot_fault` VALUES (165, 164, '1#仓位 移动台推出未离开监控位置', 2, 0, '1164', 2);
INSERT INTO `pwt_robot_fault` VALUES (166, 165, '1#仓位 推出互锁信号缺失', 2, 0, '1165', 2);
INSERT INTO `pwt_robot_fault` VALUES (167, 166, '1#仓位 缩回互锁信号缺失', 2, 0, '1166', 2);
INSERT INTO `pwt_robot_fault` VALUES (168, 167, '1#仓位 电池检测1传感器故障', 2, 1, '1167', 2);
INSERT INTO `pwt_robot_fault` VALUES (169, 168, '1#仓位 电池检测2传感器故障', 2, 1, '1168', 2);
INSERT INTO `pwt_robot_fault` VALUES (170, 169, '1#仓位 电池检测1屏蔽', 2, 1, '1169', 2);
INSERT INTO `pwt_robot_fault` VALUES (171, 170, '1#仓位 电池检测2屏蔽', 2, 1, '1170', 2);
INSERT INTO `pwt_robot_fault` VALUES (172, 171, '1#仓位 变频器报错', 2, 0, '1171', 2);
INSERT INTO `pwt_robot_fault` VALUES (173, 172, '1#仓位 仓位屏蔽', 2, 1, '1172', 2);
INSERT INTO `pwt_robot_fault` VALUES (174, 173, '1#仓位 电池检测1屏蔽', 2, 1, '1173', 2);
INSERT INTO `pwt_robot_fault` VALUES (175, 174, '1#仓位 电池检测2屏蔽', 2, 1, '1174', 2);
INSERT INTO `pwt_robot_fault` VALUES (176, 175, '', NULL, NULL, '1175', 2);
INSERT INTO `pwt_robot_fault` VALUES (177, 176, '2#仓位 Alarm', 2, 1, '1176', 2);
INSERT INTO `pwt_robot_fault` VALUES (178, 177, '2#仓位 GK01 推出到位减速开关故障', 2, 0, '1177', 2);
INSERT INTO `pwt_robot_fault` VALUES (179, 178, '2#仓位 GK03 缩回到位减速开关故障', 2, 0, '1178', 2);
INSERT INTO `pwt_robot_fault` VALUES (180, 179, '2#仓位 移动台推出未离开监控位置', 2, 0, '1179', 2);
INSERT INTO `pwt_robot_fault` VALUES (181, 180, '2#仓位 移动台推出未离开监控位置', 2, 0, '1180', 2);
INSERT INTO `pwt_robot_fault` VALUES (182, 181, '2#仓位 推出互锁信号缺失', 2, 0, '1181', 2);
INSERT INTO `pwt_robot_fault` VALUES (183, 182, '2#仓位 缩回互锁信号缺失', 2, 0, '1182', 2);
INSERT INTO `pwt_robot_fault` VALUES (184, 183, '2#仓位 电池检测1传感器故障', 2, 1, '1183', 2);
INSERT INTO `pwt_robot_fault` VALUES (185, 184, '2#仓位 电池检测2传感器故障', 2, 1, '1184', 2);
INSERT INTO `pwt_robot_fault` VALUES (186, 185, '2#仓位 电池检测1屏蔽', 2, 1, '1185', 2);
INSERT INTO `pwt_robot_fault` VALUES (187, 186, '2#仓位 电池检测2屏蔽', 2, 1, '1186', 2);
INSERT INTO `pwt_robot_fault` VALUES (188, 187, '2#仓位 变频器报错', 2, 0, '1187', 2);
INSERT INTO `pwt_robot_fault` VALUES (189, 188, '2#仓位 仓位屏蔽', 2, 1, '1188', 2);
INSERT INTO `pwt_robot_fault` VALUES (190, 189, '2#仓位 电池检测1屏蔽', 2, 1, '1189', 2);
INSERT INTO `pwt_robot_fault` VALUES (191, 190, '2#仓位 电池检测2屏蔽', 2, 1, '1190', 2);
INSERT INTO `pwt_robot_fault` VALUES (192, 191, '', NULL, NULL, '1191', 2);
INSERT INTO `pwt_robot_fault` VALUES (193, 192, '3#仓位 Alarm', 2, 1, '1192', 2);
INSERT INTO `pwt_robot_fault` VALUES (194, 193, '3#仓位 GK01 推出到位减速开关故障', 2, 0, '1193', 2);
INSERT INTO `pwt_robot_fault` VALUES (195, 194, '3#仓位 GK03 缩回到位减速开关故障', 2, 0, '1194', 2);
INSERT INTO `pwt_robot_fault` VALUES (196, 195, '3#仓位 移动台推出未离开监控位置', 2, 0, '1195', 2);
INSERT INTO `pwt_robot_fault` VALUES (197, 196, '3#仓位 移动台推出未离开监控位置', 2, 0, '1196', 2);
INSERT INTO `pwt_robot_fault` VALUES (198, 197, '3#仓位 推出互锁信号缺失', 2, 0, '1197', 2);
INSERT INTO `pwt_robot_fault` VALUES (199, 198, '3#仓位 缩回互锁信号缺失', 2, 0, '1198', 2);
INSERT INTO `pwt_robot_fault` VALUES (200, 199, '3#仓位 电池检测1传感器故障', 2, 1, '1199', 2);
INSERT INTO `pwt_robot_fault` VALUES (201, 200, '3#仓位 电池检测2传感器故障', 2, 1, '1200', 2);
INSERT INTO `pwt_robot_fault` VALUES (202, 201, '3#仓位 电池检测1屏蔽', 2, 1, '1201', 2);
INSERT INTO `pwt_robot_fault` VALUES (203, 202, '3#仓位 电池检测2屏蔽', 2, 1, '1202', 2);
INSERT INTO `pwt_robot_fault` VALUES (204, 203, '3#仓位 变频器报错', 2, 0, '1203', 2);
INSERT INTO `pwt_robot_fault` VALUES (205, 204, '3#仓位 仓位屏蔽', 2, 1, '1204', 2);
INSERT INTO `pwt_robot_fault` VALUES (206, 205, '3#仓位 电池检测1屏蔽', 2, 1, '1205', 2);
INSERT INTO `pwt_robot_fault` VALUES (207, 206, '3#仓位 电池检测2屏蔽', 2, 1, '1206', 2);
INSERT INTO `pwt_robot_fault` VALUES (208, 207, '', NULL, NULL, '1207', 2);
INSERT INTO `pwt_robot_fault` VALUES (209, 208, '4#仓位 Alarm', 2, 1, '1208', 2);
INSERT INTO `pwt_robot_fault` VALUES (210, 209, '4#仓位 GK01 推出到位减速开关故障', 2, 0, '1209', 2);
INSERT INTO `pwt_robot_fault` VALUES (211, 210, '4#仓位 GK03 缩回到位减速开关故障', 2, 0, '1210', 2);
INSERT INTO `pwt_robot_fault` VALUES (212, 211, '4#仓位 移动台推出未离开监控位置', 2, 0, '1211', 2);
INSERT INTO `pwt_robot_fault` VALUES (213, 212, '4#仓位 移动台推出未离开监控位置', 2, 0, '1212', 2);
INSERT INTO `pwt_robot_fault` VALUES (214, 213, '4#仓位 推出互锁信号缺失', 2, 0, '1213', 2);
INSERT INTO `pwt_robot_fault` VALUES (215, 214, '4#仓位 缩回互锁信号缺失', 2, 0, '1214', 2);
INSERT INTO `pwt_robot_fault` VALUES (216, 215, '4#仓位 电池检测1传感器故障', 2, 1, '1215', 2);
INSERT INTO `pwt_robot_fault` VALUES (217, 216, '4#仓位 电池检测2传感器故障', 2, 1, '1216', 2);
INSERT INTO `pwt_robot_fault` VALUES (218, 217, '4#仓位 电池检测1屏蔽', 2, 1, '1217', 2);
INSERT INTO `pwt_robot_fault` VALUES (219, 218, '4#仓位 电池检测2屏蔽', 2, 1, '1218', 2);
INSERT INTO `pwt_robot_fault` VALUES (220, 219, '4#仓位 变频器报错', 2, 0, '1219', 2);
INSERT INTO `pwt_robot_fault` VALUES (221, 220, '4#仓位 仓位屏蔽', 2, 1, '1220', 2);
INSERT INTO `pwt_robot_fault` VALUES (222, 221, '4#仓位 电池检测1屏蔽', 2, 1, '1221', 2);
INSERT INTO `pwt_robot_fault` VALUES (223, 222, '4#仓位 电池检测2屏蔽', 2, 1, '1222', 2);
INSERT INTO `pwt_robot_fault` VALUES (224, 223, '', NULL, NULL, '1223', 2);
INSERT INTO `pwt_robot_fault` VALUES (225, 224, '5#仓位 Alarm', 2, 1, '1224', 2);
INSERT INTO `pwt_robot_fault` VALUES (226, 225, '5#仓位 GK01 推出到位减速开关故障', 2, 0, '1225', 2);
INSERT INTO `pwt_robot_fault` VALUES (227, 226, '5#仓位 GK03 缩回到位减速开关故障', 2, 0, '1226', 2);
INSERT INTO `pwt_robot_fault` VALUES (228, 227, '5#仓位 移动台推出未离开监控位置', 2, 0, '1227', 2);
INSERT INTO `pwt_robot_fault` VALUES (229, 228, '5#仓位 移动台推出未离开监控位置', 2, 0, '1228', 2);
INSERT INTO `pwt_robot_fault` VALUES (230, 229, '5#仓位 推出互锁信号缺失', 2, 0, '1229', 2);
INSERT INTO `pwt_robot_fault` VALUES (231, 230, '5#仓位 缩回互锁信号缺失', 2, 0, '1230', 2);
INSERT INTO `pwt_robot_fault` VALUES (232, 231, '5#仓位 电池检测1传感器故障', 2, 1, '1231', 2);
INSERT INTO `pwt_robot_fault` VALUES (233, 232, '5#仓位 电池检测2传感器故障', 2, 1, '1232', 2);
INSERT INTO `pwt_robot_fault` VALUES (234, 233, '5#仓位 电池检测1屏蔽', 2, 1, '1233', 2);
INSERT INTO `pwt_robot_fault` VALUES (235, 234, '5#仓位 电池检测2屏蔽', 2, 1, '1234', 2);
INSERT INTO `pwt_robot_fault` VALUES (236, 235, '5#仓位 变频器报错', 2, 0, '1235', 2);
INSERT INTO `pwt_robot_fault` VALUES (237, 236, '5#仓位 仓位屏蔽', 2, 1, '1236', 2);
INSERT INTO `pwt_robot_fault` VALUES (238, 237, '5#仓位 电池检测1屏蔽', 2, 1, '1237', 2);
INSERT INTO `pwt_robot_fault` VALUES (239, 238, '5#仓位 电池检测2屏蔽', 2, 1, '1238', 2);
INSERT INTO `pwt_robot_fault` VALUES (240, 239, '', NULL, NULL, '1239', 2);
INSERT INTO `pwt_robot_fault` VALUES (241, 240, '6#仓位 Alarm', 2, 1, '1240', 2);
INSERT INTO `pwt_robot_fault` VALUES (242, 241, '6#仓位 GK01 推出到位减速开关故障', 2, 0, '1241', 2);
INSERT INTO `pwt_robot_fault` VALUES (243, 242, '6#仓位 GK03 缩回到位减速开关故障', 2, 0, '1242', 2);
INSERT INTO `pwt_robot_fault` VALUES (244, 243, '6#仓位 移动台推出未离开监控位置', 2, 0, '1243', 2);
INSERT INTO `pwt_robot_fault` VALUES (245, 244, '6#仓位 移动台推出未离开监控位置', 2, 0, '1244', 2);
INSERT INTO `pwt_robot_fault` VALUES (246, 245, '6#仓位 推出互锁信号缺失', 2, 0, '1245', 2);
INSERT INTO `pwt_robot_fault` VALUES (247, 246, '6#仓位 缩回互锁信号缺失', 2, 0, '1246', 2);
INSERT INTO `pwt_robot_fault` VALUES (248, 247, '6#仓位 电池检测1传感器故障', 2, 1, '1247', 2);
INSERT INTO `pwt_robot_fault` VALUES (249, 248, '6#仓位 电池检测2传感器故障', 2, 1, '1248', 2);
INSERT INTO `pwt_robot_fault` VALUES (250, 249, '6#仓位 电池检测1屏蔽', 2, 1, '1249', 2);
INSERT INTO `pwt_robot_fault` VALUES (251, 250, '6#仓位 电池检测2屏蔽', 2, 1, '1250', 2);
INSERT INTO `pwt_robot_fault` VALUES (252, 251, '6#仓位 变频器报错', 2, 0, '1251', 2);
INSERT INTO `pwt_robot_fault` VALUES (253, 252, '6#仓位 仓位屏蔽', 2, 1, '1252', 2);
INSERT INTO `pwt_robot_fault` VALUES (254, 253, '6#仓位 电池检测1屏蔽', 2, 1, '1253', 2);
INSERT INTO `pwt_robot_fault` VALUES (255, 254, '6#仓位 电池检测2屏蔽', 2, 1, '1254', 2);
INSERT INTO `pwt_robot_fault` VALUES (256, 255, '', NULL, NULL, '1255', 2);
INSERT INTO `pwt_robot_fault` VALUES (257, 256, '7#仓位 Alarm', 2, 1, '1256', 2);
INSERT INTO `pwt_robot_fault` VALUES (258, 257, '7#仓位 GK01 推出到位减速开关故障', 2, 0, '1257', 2);
INSERT INTO `pwt_robot_fault` VALUES (259, 258, '7#仓位 GK03 缩回到位减速开关故障', 2, 0, '1258', 2);
INSERT INTO `pwt_robot_fault` VALUES (260, 259, '7#仓位 移动台推出未离开监控位置', 2, 0, '1259', 2);
INSERT INTO `pwt_robot_fault` VALUES (261, 260, '7#仓位 移动台推出未离开监控位置', 2, 0, '1260', 2);
INSERT INTO `pwt_robot_fault` VALUES (262, 261, '7#仓位 推出互锁信号缺失', 2, 0, '1261', 2);
INSERT INTO `pwt_robot_fault` VALUES (263, 262, '7#仓位 缩回互锁信号缺失', 2, 0, '1262', 2);
INSERT INTO `pwt_robot_fault` VALUES (264, 263, '7#仓位 电池检测1传感器故障', 2, 1, '1263', 2);
INSERT INTO `pwt_robot_fault` VALUES (265, 264, '7#仓位 电池检测2传感器故障', 2, 1, '1264', 2);
INSERT INTO `pwt_robot_fault` VALUES (266, 265, '7#仓位 电池检测1屏蔽', 2, 1, '1265', 2);
INSERT INTO `pwt_robot_fault` VALUES (267, 266, '7#仓位 电池检测2屏蔽', 2, 1, '1266', 2);
INSERT INTO `pwt_robot_fault` VALUES (268, 267, '7#仓位 变频器报错', 2, 0, '1267', 2);
INSERT INTO `pwt_robot_fault` VALUES (269, 268, '7#仓位 仓位屏蔽', 2, 1, '1268', 2);
INSERT INTO `pwt_robot_fault` VALUES (270, 269, '7#仓位 电池检测1屏蔽', 2, 1, '1269', 2);
INSERT INTO `pwt_robot_fault` VALUES (271, 270, '7#仓位 电池检测2屏蔽', 2, 1, '1270', 2);
INSERT INTO `pwt_robot_fault` VALUES (272, 271, '', NULL, NULL, '1271', 2);
INSERT INTO `pwt_robot_fault` VALUES (273, 272, '8#仓位 Alarm', 2, 1, '1272', 2);
INSERT INTO `pwt_robot_fault` VALUES (274, 273, '8#仓位 GK01 推出到位减速开关故障', 2, 0, '1273', 2);
INSERT INTO `pwt_robot_fault` VALUES (275, 274, '8#仓位 GK03 缩回到位减速开关故障', 2, 0, '1274', 2);
INSERT INTO `pwt_robot_fault` VALUES (276, 275, '8#仓位 移动台推出未离开监控位置', 2, 0, '1275', 2);
INSERT INTO `pwt_robot_fault` VALUES (277, 276, '8#仓位 移动台推出未离开监控位置', 2, 0, '1276', 2);
INSERT INTO `pwt_robot_fault` VALUES (278, 277, '8#仓位 推出互锁信号缺失', 2, 0, '1277', 2);
INSERT INTO `pwt_robot_fault` VALUES (279, 278, '8#仓位 缩回互锁信号缺失', 2, 0, '1278', 2);
INSERT INTO `pwt_robot_fault` VALUES (280, 279, '8#仓位 电池检测1传感器故障', 2, 1, '1279', 2);
INSERT INTO `pwt_robot_fault` VALUES (281, 280, '8#仓位 电池检测2传感器故障', 2, 1, '1280', 2);
INSERT INTO `pwt_robot_fault` VALUES (282, 281, '8#仓位 电池检测1屏蔽', 2, 1, '1281', 2);
INSERT INTO `pwt_robot_fault` VALUES (283, 282, '8#仓位 电池检测2屏蔽', 2, 1, '1282', 2);
INSERT INTO `pwt_robot_fault` VALUES (284, 283, '8#仓位 变频器报错', 2, 0, '1283', 2);
INSERT INTO `pwt_robot_fault` VALUES (285, 284, '8#仓位 仓位屏蔽', 2, 1, '1284', 2);
INSERT INTO `pwt_robot_fault` VALUES (286, 285, '8#仓位 电池检测1屏蔽', 2, 1, '1285', 2);
INSERT INTO `pwt_robot_fault` VALUES (287, 286, '8#仓位 电池检测2屏蔽', 2, 1, '1286', 2);
INSERT INTO `pwt_robot_fault` VALUES (288, 287, '', NULL, NULL, '1287', 2);
INSERT INTO `pwt_robot_fault` VALUES (289, 288, '9#仓位 Alarm', 2, 1, '1288', 2);
INSERT INTO `pwt_robot_fault` VALUES (290, 289, '9#仓位 GK01 推出到位减速开关故障', 2, 0, '1289', 2);
INSERT INTO `pwt_robot_fault` VALUES (291, 290, '9#仓位 GK03 缩回到位减速开关故障', 2, 0, '1290', 2);
INSERT INTO `pwt_robot_fault` VALUES (292, 291, '9#仓位 移动台推出未离开监控位置', 2, 0, '1291', 2);
INSERT INTO `pwt_robot_fault` VALUES (293, 292, '9#仓位 移动台推出未离开监控位置', 2, 0, '1292', 2);
INSERT INTO `pwt_robot_fault` VALUES (294, 293, '9#仓位 推出互锁信号缺失', 2, 0, '1293', 2);
INSERT INTO `pwt_robot_fault` VALUES (295, 294, '9#仓位 缩回互锁信号缺失', 2, 0, '1294', 2);
INSERT INTO `pwt_robot_fault` VALUES (296, 295, '9#仓位 电池检测1传感器故障', 2, 1, '1295', 2);
INSERT INTO `pwt_robot_fault` VALUES (297, 296, '9#仓位 电池检测2传感器故障', 2, 1, '1296', 2);
INSERT INTO `pwt_robot_fault` VALUES (298, 297, '9#仓位 电池检测1屏蔽', 2, 1, '1297', 2);
INSERT INTO `pwt_robot_fault` VALUES (299, 298, '9#仓位 电池检测2屏蔽', 2, 1, '1298', 2);
INSERT INTO `pwt_robot_fault` VALUES (300, 299, '9#仓位 变频器报错', 2, 0, '1299', 2);
INSERT INTO `pwt_robot_fault` VALUES (301, 300, '9#仓位 仓位屏蔽', 2, 1, '1300', 2);
INSERT INTO `pwt_robot_fault` VALUES (302, 301, '9#仓位 电池检测1屏蔽', 2, 1, '1301', 2);
INSERT INTO `pwt_robot_fault` VALUES (303, 302, '9#仓位 电池检测2屏蔽', 2, 1, '1302', 2);
INSERT INTO `pwt_robot_fault` VALUES (304, 303, '', NULL, NULL, '1303', 2);
INSERT INTO `pwt_robot_fault` VALUES (305, 304, '10#仓位 Alarm', 2, 1, '1304', 2);
INSERT INTO `pwt_robot_fault` VALUES (306, 305, '10#仓位 GK01 推出到位减速开关故障', 2, 0, '1305', 2);
INSERT INTO `pwt_robot_fault` VALUES (307, 306, '10#仓位 GK03 缩回到位减速开关故障', 2, 0, '1306', 2);
INSERT INTO `pwt_robot_fault` VALUES (308, 307, '10#仓位 移动台推出未离开监控位置', 2, 0, '1307', 2);
INSERT INTO `pwt_robot_fault` VALUES (309, 308, '10#仓位 移动台推出未离开监控位置', 2, 0, '1308', 2);
INSERT INTO `pwt_robot_fault` VALUES (310, 309, '10#仓位 推出互锁信号缺失', 2, 0, '1309', 2);
INSERT INTO `pwt_robot_fault` VALUES (311, 310, '10#仓位 缩回互锁信号缺失', 2, 0, '1310', 2);
INSERT INTO `pwt_robot_fault` VALUES (312, 311, '10#仓位 电池检测1传感器故障', 2, 1, '1311', 2);
INSERT INTO `pwt_robot_fault` VALUES (313, 312, '10#仓位 电池检测2传感器故障', 2, 1, '1312', 2);
INSERT INTO `pwt_robot_fault` VALUES (314, 313, '10#仓位 电池检测1屏蔽', 2, 1, '1313', 2);
INSERT INTO `pwt_robot_fault` VALUES (315, 314, '10#仓位 电池检测2屏蔽', 2, 1, '1314', 2);
INSERT INTO `pwt_robot_fault` VALUES (316, 315, '10#仓位 变频器报错', 2, 0, '1315', 2);
INSERT INTO `pwt_robot_fault` VALUES (317, 316, '10#仓位 仓位屏蔽', 2, 1, '1316', 2);
INSERT INTO `pwt_robot_fault` VALUES (318, 317, '10#仓位 电池检测1屏蔽', 2, 1, '1317', 2);
INSERT INTO `pwt_robot_fault` VALUES (319, 318, '10#仓位 电池检测2屏蔽', 2, 1, '1318', 2);
INSERT INTO `pwt_robot_fault` VALUES (320, 319, '', NULL, NULL, '1319', 2);
INSERT INTO `pwt_robot_fault` VALUES (321, 320, '11#仓位 Alarm', 2, 1, '1320', 2);
INSERT INTO `pwt_robot_fault` VALUES (322, 321, '11#仓位 GK01 推出到位减速开关故障', 2, 0, '1321', 2);
INSERT INTO `pwt_robot_fault` VALUES (323, 322, '11#仓位 GK03 缩回到位减速开关故障', 2, 0, '1322', 2);
INSERT INTO `pwt_robot_fault` VALUES (324, 323, '11#仓位 移动台推出未离开监控位置', 2, 0, '1323', 2);
INSERT INTO `pwt_robot_fault` VALUES (325, 324, '11#仓位 移动台推出未离开监控位置', 2, 0, '1324', 2);
INSERT INTO `pwt_robot_fault` VALUES (326, 325, '11#仓位 推出互锁信号缺失', 2, 0, '1325', 2);
INSERT INTO `pwt_robot_fault` VALUES (327, 326, '11#仓位 缩回互锁信号缺失', 2, 0, '1326', 2);
INSERT INTO `pwt_robot_fault` VALUES (328, 327, '11#仓位 电池检测1传感器故障', 2, 1, '1327', 2);
INSERT INTO `pwt_robot_fault` VALUES (329, 328, '11#仓位 电池检测2传感器故障', 2, 1, '1328', 2);
INSERT INTO `pwt_robot_fault` VALUES (330, 329, '11#仓位 电池检测1屏蔽', 2, 1, '1329', 2);
INSERT INTO `pwt_robot_fault` VALUES (331, 330, '11#仓位 电池检测2屏蔽', 2, 1, '1330', 2);
INSERT INTO `pwt_robot_fault` VALUES (332, 331, '11#仓位 变频器报错', 2, 0, '1331', 2);
INSERT INTO `pwt_robot_fault` VALUES (333, 332, '11#仓位 仓位屏蔽', 2, 1, '1332', 2);
INSERT INTO `pwt_robot_fault` VALUES (334, 333, '11#仓位 电池检测1屏蔽', 2, 1, '1333', 2);
INSERT INTO `pwt_robot_fault` VALUES (335, 334, '11#仓位 电池检测2屏蔽', 2, 1, '1334', 2);
INSERT INTO `pwt_robot_fault` VALUES (336, 335, '', NULL, NULL, '1335', 2);
INSERT INTO `pwt_robot_fault` VALUES (337, 336, '12#仓位 Alarm', 2, 1, '1336', 2);
INSERT INTO `pwt_robot_fault` VALUES (338, 337, '12#仓位 GK01 推出到位减速开关故障', 2, 0, '1337', 2);
INSERT INTO `pwt_robot_fault` VALUES (339, 338, '12#仓位 GK03 缩回到位减速开关故障', 2, 0, '1338', 2);
INSERT INTO `pwt_robot_fault` VALUES (340, 339, '12#仓位 移动台推出未离开监控位置', 2, 0, '1339', 2);
INSERT INTO `pwt_robot_fault` VALUES (341, 340, '12#仓位 移动台推出未离开监控位置', 2, 0, '1340', 2);
INSERT INTO `pwt_robot_fault` VALUES (342, 341, '12#仓位 推出互锁信号缺失', 2, 0, '1341', 2);
INSERT INTO `pwt_robot_fault` VALUES (343, 342, '12#仓位 缩回互锁信号缺失', 2, 0, '1342', 2);
INSERT INTO `pwt_robot_fault` VALUES (344, 343, '12#仓位 电池检测1传感器故障', 2, 1, '1343', 2);
INSERT INTO `pwt_robot_fault` VALUES (345, 344, '12#仓位 电池检测2传感器故障', 2, 1, '1344', 2);
INSERT INTO `pwt_robot_fault` VALUES (346, 345, '12#仓位 电池检测1屏蔽', 2, 1, '1345', 2);
INSERT INTO `pwt_robot_fault` VALUES (347, 346, '12#仓位 电池检测2屏蔽', 2, 1, '1346', 2);
INSERT INTO `pwt_robot_fault` VALUES (348, 347, '12#仓位 变频器报错', 2, 0, '1347', 2);
INSERT INTO `pwt_robot_fault` VALUES (349, 348, '12#仓位 仓位屏蔽', 2, 1, '1348', 2);
INSERT INTO `pwt_robot_fault` VALUES (350, 349, '12#仓位 电池检测1屏蔽', 2, 1, '1349', 2);
INSERT INTO `pwt_robot_fault` VALUES (351, 350, '12#仓位 电池检测2屏蔽', 2, 1, '1350', 2);
INSERT INTO `pwt_robot_fault` VALUES (352, 351, '', NULL, NULL, '1351', 2);
INSERT INTO `pwt_robot_fault` VALUES (353, 0, 'CC1故障', 4, 1, '3001', 3);
INSERT INTO `pwt_robot_fault` VALUES (354, 1, 'BMS故障', 4, 1, '3002', 3);
INSERT INTO `pwt_robot_fault` VALUES (355, 2, 'BMS错误', 4, 1, '3003', 3);
INSERT INTO `pwt_robot_fault` VALUES (356, 3, '单体电压过高', 4, 1, '3004', 3);
INSERT INTO `pwt_robot_fault` VALUES (357, 4, '单体温度过高', 4, 1, '3005', 3);
INSERT INTO `pwt_robot_fault` VALUES (358, 5, '输入过压', 4, 1, '3006', 3);
INSERT INTO `pwt_robot_fault` VALUES (359, 6, '输入欠压', 4, 1, '3007', 3);
INSERT INTO `pwt_robot_fault` VALUES (360, 7, '输入短路', 4, 1, '3008', 3);
INSERT INTO `pwt_robot_fault` VALUES (361, 8, '充电机内部故障', 4, 1, '3009', 3);
INSERT INTO `pwt_robot_fault` VALUES (362, 9, '输出过压', 4, 1, '3010', 3);
INSERT INTO `pwt_robot_fault` VALUES (363, 10, '直流输出断路', 4, 1, '3011', 3);
INSERT INTO `pwt_robot_fault` VALUES (364, 11, '系统故障', 4, 1, '3012', 3);
INSERT INTO `pwt_robot_fault` VALUES (365, 12, '充电机系统故障', 4, 1, '3013', 3);
INSERT INTO `pwt_robot_fault` VALUES (366, 13, '模块故障', 4, 1, '3014', 3);
INSERT INTO `pwt_robot_fault` VALUES (367, 14, '电池故障', 4, 1, '3015', 3);
INSERT INTO `pwt_robot_fault` VALUES (368, 15, '绝缘不通过', 4, 1, '3016', 3);
INSERT INTO `pwt_robot_fault` VALUES (369, 16, '绝缘条件不满足', 4, 1, '3017', 3);
INSERT INTO `pwt_robot_fault` VALUES (370, 17, '触摸屏故障', 4, 1, '3018', 3);
INSERT INTO `pwt_robot_fault` VALUES (371, 18, '读卡器故障', 4, 1, '3019', 3);
INSERT INTO `pwt_robot_fault` VALUES (372, 19, '急停故障', 4, 1, '3020', 3);
INSERT INTO `pwt_robot_fault` VALUES (373, 20, '充电桩电表故障', 4, 1, '3021', 3);
INSERT INTO `pwt_robot_fault` VALUES (374, 21, '绝缘检测故障', 4, 1, '3022', 3);
INSERT INTO `pwt_robot_fault` VALUES (375, 22, '整流模块故障', 4, 1, '3023', 3);
INSERT INTO `pwt_robot_fault` VALUES (376, 23, '网络模块故障', 4, 1, '3024', 3);
INSERT INTO `pwt_robot_fault` VALUES (377, 24, '单体动力蓄电池电压过高、过低', 4, 1, '3025', 3);
INSERT INTO `pwt_robot_fault` VALUES (378, 25, '高压继电器故障', 4, 1, '3026', 3);
INSERT INTO `pwt_robot_fault` VALUES (379, 26, '接收BRM超时', 4, 1, '3027', 3);
INSERT INTO `pwt_robot_fault` VALUES (380, 27, '接收BCP超时', 4, 1, '3028', 3);
INSERT INTO `pwt_robot_fault` VALUES (381, 28, '接收BRO超时', 4, 1, '3029', 3);
INSERT INTO `pwt_robot_fault` VALUES (382, 29, '接收BCS超时', 4, 1, '3030', 3);
INSERT INTO `pwt_robot_fault` VALUES (383, 30, '接收BCL超时', 4, 1, '3031', 3);
INSERT INTO `pwt_robot_fault` VALUES (384, 31, '接收BST超时', 4, 1, '3032', 3);
INSERT INTO `pwt_robot_fault` VALUES (385, 32, '接收BSD超时', 4, 1, '3033', 3);
INSERT INTO `pwt_robot_fault` VALUES (386, 33, '接收CRM超时', 4, 1, '3034', 3);
INSERT INTO `pwt_robot_fault` VALUES (387, 34, '接收CML超时', 4, 1, '3035', 3);
INSERT INTO `pwt_robot_fault` VALUES (388, 35, '接收CRO超时', 4, 1, '3036', 3);
INSERT INTO `pwt_robot_fault` VALUES (389, 36, '接收CCS超时', 4, 1, '3037', 3);
INSERT INTO `pwt_robot_fault` VALUES (390, 37, '接收CST超时', 4, 1, '3039', 3);
INSERT INTO `pwt_robot_fault` VALUES (391, 38, '接收CSD超时', 4, 1, '3040', 3);
INSERT INTO `pwt_robot_fault` VALUES (392, 39, '接收BSM超时', 4, 1, '3041', 3);
INSERT INTO `pwt_robot_fault` VALUES (393, 40, '其他故障', 4, 1, '3042', 3);
INSERT INTO `pwt_robot_fault` VALUES (394, 0, '单体动力蓄电池电压过低', 5, 1, '4000', 4);
INSERT INTO `pwt_robot_fault` VALUES (395, 1, '单体动力蓄电池电压过高', 5, 1, '4001', 4);
INSERT INTO `pwt_robot_fault` VALUES (396, 2, '整车动力蓄电池荷电状态SOC过低', 5, 1, '4002', 4);
INSERT INTO `pwt_robot_fault` VALUES (397, 3, '整车动力蓄电池荷电状态SOC过高', 5, 1, '4003', 4);
INSERT INTO `pwt_robot_fault` VALUES (398, 4, '动力蓄电池充电过流', 5, 1, '4004', 4);
INSERT INTO `pwt_robot_fault` VALUES (399, 5, '动力蓄电池绝缘状态不正常', 5, 1, '4005', 4);

-- ----------------------------
-- Table structure for pwt_vehicle
-- ----------------------------
DROP TABLE IF EXISTS `pwt_vehicle`;
CREATE TABLE `pwt_vehicle`  (
  `vehicle_id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '车辆id',
  `vehicle_name` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '名称',
  `vehicle_no` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '车牌号',
  `vin` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT 'vin',
  `rfid` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT 'rfid',
  `create_time` datetime(0) NULL DEFAULT NULL COMMENT '添加时间',
  PRIMARY KEY (`vehicle_id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 20 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci COMMENT = '车辆管理' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of pwt_vehicle
-- ----------------------------

-- ----------------------------
-- Table structure for qrtz_blob_triggers
-- ----------------------------
DROP TABLE IF EXISTS `qrtz_blob_triggers`;
CREATE TABLE `qrtz_blob_triggers`  (
  `sched_name` varchar(120) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '调度名称',
  `trigger_name` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'qrtz_triggers表trigger_name的外键',
  `trigger_group` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'qrtz_triggers表trigger_group的外键',
  `blob_data` blob NULL COMMENT '存放持久化Trigger对象',
  PRIMARY KEY (`sched_name`, `trigger_name`, `trigger_group`) USING BTREE,
  CONSTRAINT `qrtz_blob_triggers_ibfk_1` FOREIGN KEY (`sched_name`, `trigger_name`, `trigger_group`) REFERENCES `qrtz_triggers` (`sched_name`, `trigger_name`, `trigger_group`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci COMMENT = 'Blob类型的触发器表' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of qrtz_blob_triggers
-- ----------------------------

-- ----------------------------
-- Table structure for qrtz_calendars
-- ----------------------------
DROP TABLE IF EXISTS `qrtz_calendars`;
CREATE TABLE `qrtz_calendars`  (
  `sched_name` varchar(120) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '调度名称',
  `calendar_name` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '日历名称',
  `calendar` blob NOT NULL COMMENT '存放持久化calendar对象',
  PRIMARY KEY (`sched_name`, `calendar_name`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '日历信息表' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of qrtz_calendars
-- ----------------------------

-- ----------------------------
-- Table structure for qrtz_cron_triggers
-- ----------------------------
DROP TABLE IF EXISTS `qrtz_cron_triggers`;
CREATE TABLE `qrtz_cron_triggers`  (
  `sched_name` varchar(120) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '调度名称',
  `trigger_name` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'qrtz_triggers表trigger_name的外键',
  `trigger_group` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'qrtz_triggers表trigger_group的外键',
  `cron_expression` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'cron表达式',
  `time_zone_id` varchar(80) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '时区',
  PRIMARY KEY (`sched_name`, `trigger_name`, `trigger_group`) USING BTREE,
  CONSTRAINT `qrtz_cron_triggers_ibfk_1` FOREIGN KEY (`sched_name`, `trigger_name`, `trigger_group`) REFERENCES `qrtz_triggers` (`sched_name`, `trigger_name`, `trigger_group`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = 'Cron类型的触发器表' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of qrtz_cron_triggers
-- ----------------------------

-- ----------------------------
-- Table structure for qrtz_fired_triggers
-- ----------------------------
DROP TABLE IF EXISTS `qrtz_fired_triggers`;
CREATE TABLE `qrtz_fired_triggers`  (
  `sched_name` varchar(120) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '调度名称',
  `entry_id` varchar(95) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '调度器实例id',
  `trigger_name` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'qrtz_triggers表trigger_name的外键',
  `trigger_group` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'qrtz_triggers表trigger_group的外键',
  `instance_name` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '调度器实例名',
  `fired_time` bigint(20) NOT NULL COMMENT '触发的时间',
  `sched_time` bigint(20) NOT NULL COMMENT '定时器制定的时间',
  `priority` int(11) NOT NULL COMMENT '优先级',
  `state` varchar(16) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '状态',
  `job_name` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '任务名称',
  `job_group` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '任务组名',
  `is_nonconcurrent` varchar(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '是否并发',
  `requests_recovery` varchar(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '是否接受恢复执行',
  PRIMARY KEY (`sched_name`, `entry_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '已触发的触发器表' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of qrtz_fired_triggers
-- ----------------------------

-- ----------------------------
-- Table structure for qrtz_job_details
-- ----------------------------
DROP TABLE IF EXISTS `qrtz_job_details`;
CREATE TABLE `qrtz_job_details`  (
  `sched_name` varchar(120) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '调度名称',
  `job_name` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '任务名称',
  `job_group` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '任务组名',
  `description` varchar(250) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '相关介绍',
  `job_class_name` varchar(250) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '执行任务类名称',
  `is_durable` varchar(1) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '是否持久化',
  `is_nonconcurrent` varchar(1) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '是否并发',
  `is_update_data` varchar(1) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '是否更新数据',
  `requests_recovery` varchar(1) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '是否接受恢复执行',
  `job_data` blob NULL COMMENT '存放持久化job对象',
  PRIMARY KEY (`sched_name`, `job_name`, `job_group`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '任务详细信息表' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of qrtz_job_details
-- ----------------------------

-- ----------------------------
-- Table structure for qrtz_locks
-- ----------------------------
DROP TABLE IF EXISTS `qrtz_locks`;
CREATE TABLE `qrtz_locks`  (
  `sched_name` varchar(120) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '调度名称',
  `lock_name` varchar(40) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '悲观锁名称',
  PRIMARY KEY (`sched_name`, `lock_name`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '存储的悲观锁信息表' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of qrtz_locks
-- ----------------------------
INSERT INTO `qrtz_locks` VALUES ('RuoyiScheduler', 'STATE_ACCESS');
INSERT INTO `qrtz_locks` VALUES ('RuoyiScheduler', 'TRIGGER_ACCESS');

-- ----------------------------
-- Table structure for qrtz_paused_trigger_grps
-- ----------------------------
DROP TABLE IF EXISTS `qrtz_paused_trigger_grps`;
CREATE TABLE `qrtz_paused_trigger_grps`  (
  `sched_name` varchar(120) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '调度名称',
  `trigger_group` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'qrtz_triggers表trigger_group的外键',
  PRIMARY KEY (`sched_name`, `trigger_group`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '暂停的触发器表' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of qrtz_paused_trigger_grps
-- ----------------------------

-- ----------------------------
-- Table structure for qrtz_scheduler_state
-- ----------------------------
DROP TABLE IF EXISTS `qrtz_scheduler_state`;
CREATE TABLE `qrtz_scheduler_state`  (
  `sched_name` varchar(120) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '调度名称',
  `instance_name` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '实例名称',
  `last_checkin_time` bigint(20) NOT NULL COMMENT '上次检查时间',
  `checkin_interval` bigint(20) NOT NULL COMMENT '检查间隔时间',
  PRIMARY KEY (`sched_name`, `instance_name`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '调度器状态表' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of qrtz_scheduler_state
-- ----------------------------
INSERT INTO `qrtz_scheduler_state` VALUES ('RuoyiScheduler', 'LAPTOP-0D8JBETQ1690527614115', 1690527706557, 15000);

-- ----------------------------
-- Table structure for qrtz_simple_triggers
-- ----------------------------
DROP TABLE IF EXISTS `qrtz_simple_triggers`;
CREATE TABLE `qrtz_simple_triggers`  (
  `sched_name` varchar(120) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '调度名称',
  `trigger_name` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'qrtz_triggers表trigger_name的外键',
  `trigger_group` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'qrtz_triggers表trigger_group的外键',
  `repeat_count` bigint(20) NOT NULL COMMENT '重复的次数统计',
  `repeat_interval` bigint(20) NOT NULL COMMENT '重复的间隔时间',
  `times_triggered` bigint(20) NOT NULL COMMENT '已经触发的次数',
  PRIMARY KEY (`sched_name`, `trigger_name`, `trigger_group`) USING BTREE,
  CONSTRAINT `qrtz_simple_triggers_ibfk_1` FOREIGN KEY (`sched_name`, `trigger_name`, `trigger_group`) REFERENCES `qrtz_triggers` (`sched_name`, `trigger_name`, `trigger_group`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '简单触发器的信息表' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of qrtz_simple_triggers
-- ----------------------------

-- ----------------------------
-- Table structure for qrtz_simprop_triggers
-- ----------------------------
DROP TABLE IF EXISTS `qrtz_simprop_triggers`;
CREATE TABLE `qrtz_simprop_triggers`  (
  `sched_name` varchar(120) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '调度名称',
  `trigger_name` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'qrtz_triggers表trigger_name的外键',
  `trigger_group` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'qrtz_triggers表trigger_group的外键',
  `str_prop_1` varchar(512) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT 'String类型的trigger的第一个参数',
  `str_prop_2` varchar(512) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT 'String类型的trigger的第二个参数',
  `str_prop_3` varchar(512) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT 'String类型的trigger的第三个参数',
  `int_prop_1` int(11) NULL DEFAULT NULL COMMENT 'int类型的trigger的第一个参数',
  `int_prop_2` int(11) NULL DEFAULT NULL COMMENT 'int类型的trigger的第二个参数',
  `long_prop_1` bigint(20) NULL DEFAULT NULL COMMENT 'long类型的trigger的第一个参数',
  `long_prop_2` bigint(20) NULL DEFAULT NULL COMMENT 'long类型的trigger的第二个参数',
  `dec_prop_1` decimal(13, 4) NULL DEFAULT NULL COMMENT 'decimal类型的trigger的第一个参数',
  `dec_prop_2` decimal(13, 4) NULL DEFAULT NULL COMMENT 'decimal类型的trigger的第二个参数',
  `bool_prop_1` varchar(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT 'Boolean类型的trigger的第一个参数',
  `bool_prop_2` varchar(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT 'Boolean类型的trigger的第二个参数',
  PRIMARY KEY (`sched_name`, `trigger_name`, `trigger_group`) USING BTREE,
  CONSTRAINT `qrtz_simprop_triggers_ibfk_1` FOREIGN KEY (`sched_name`, `trigger_name`, `trigger_group`) REFERENCES `qrtz_triggers` (`sched_name`, `trigger_name`, `trigger_group`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '同步机制的行锁表' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of qrtz_simprop_triggers
-- ----------------------------

-- ----------------------------
-- Table structure for qrtz_triggers
-- ----------------------------
DROP TABLE IF EXISTS `qrtz_triggers`;
CREATE TABLE `qrtz_triggers`  (
  `sched_name` varchar(120) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '调度名称',
  `trigger_name` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '触发器的名字',
  `trigger_group` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '触发器所属组的名字',
  `job_name` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'qrtz_job_details表job_name的外键',
  `job_group` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'qrtz_job_details表job_group的外键',
  `description` varchar(250) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '相关介绍',
  `next_fire_time` bigint(20) NULL DEFAULT NULL COMMENT '上一次触发时间（毫秒）',
  `prev_fire_time` bigint(20) NULL DEFAULT NULL COMMENT '下一次触发时间（默认为-1表示不触发）',
  `priority` int(11) NULL DEFAULT NULL COMMENT '优先级',
  `trigger_state` varchar(16) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '触发器状态',
  `trigger_type` varchar(8) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '触发器的类型',
  `start_time` bigint(20) NOT NULL COMMENT '开始时间',
  `end_time` bigint(20) NULL DEFAULT NULL COMMENT '结束时间',
  `calendar_name` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '日程表名称',
  `misfire_instr` smallint(6) NULL DEFAULT NULL COMMENT '补偿执行的策略',
  `job_data` blob NULL COMMENT '存放持久化job对象',
  PRIMARY KEY (`sched_name`, `trigger_name`, `trigger_group`) USING BTREE,
  INDEX `sched_name`(`sched_name`, `job_name`, `job_group`) USING BTREE,
  CONSTRAINT `qrtz_triggers_ibfk_1` FOREIGN KEY (`sched_name`, `job_name`, `job_group`) REFERENCES `qrtz_job_details` (`sched_name`, `job_name`, `job_group`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '触发器详细信息表' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of qrtz_triggers
-- ----------------------------

-- ----------------------------
-- Table structure for sys_config
-- ----------------------------
DROP TABLE IF EXISTS `sys_config`;
CREATE TABLE `sys_config`  (
  `config_id` int(11) NOT NULL AUTO_INCREMENT COMMENT '参数主键',
  `config_name` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '参数名称',
  `config_key` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '参数键名',
  `config_value` varchar(500) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '参数键值',
  `config_type` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT 'N' COMMENT '系统内置（Y是 N否）',
  `create_by` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '创建者',
  `create_time` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `update_by` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '更新者',
  `update_time` datetime(0) NULL DEFAULT NULL COMMENT '更新时间',
  `remark` varchar(500) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '备注',
  PRIMARY KEY (`config_id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 5 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '参数配置表' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of sys_config
-- ----------------------------
INSERT INTO `sys_config` VALUES (1, '主框架页-默认皮肤样式名称', 'sys.index.skinName', 'skin-blue', 'Y', 'admin', '2022-11-01 10:16:46', '', NULL, '蓝色 skin-blue、绿色 skin-green、紫色 skin-purple、红色 skin-red、黄色 skin-yellow');
INSERT INTO `sys_config` VALUES (2, '用户管理-账号初始密码', 'sys.user.initPassword', '123456', 'Y', 'admin', '2022-11-01 10:16:46', '', NULL, '初始化密码 123456');
INSERT INTO `sys_config` VALUES (3, '主框架页-侧边栏主题', 'sys.index.sideTheme', 'theme-dark', 'Y', 'admin', '2022-11-01 10:16:46', '', NULL, '深色主题theme-dark，浅色主题theme-light');
INSERT INTO `sys_config` VALUES (4, '账号自助-验证码开关', 'sys.account.captchaEnabled', 'false', 'Y', 'admin', '2022-11-01 10:16:46', 'admin', '2022-11-01 10:45:32', '是否开启验证码功能（true开启，false关闭）');
INSERT INTO `sys_config` VALUES (5, '账号自助-是否开启用户注册功能', 'sys.account.registerUser', 'false', 'Y', 'admin', '2022-11-01 10:16:46', '', NULL, '是否开启注册用户功能（true开启，false关闭）');

-- ----------------------------
-- Table structure for sys_dict_data
-- ----------------------------
DROP TABLE IF EXISTS `sys_dict_data`;
CREATE TABLE `sys_dict_data`  (
  `dict_code` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '字典编码',
  `dict_sort` int(11) NULL DEFAULT 0 COMMENT '字典排序',
  `dict_label` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '字典标签',
  `dict_value` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '字典键值',
  `dict_type` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '字典类型',
  `css_class` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '样式属性（其他样式扩展）',
  `list_class` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '表格回显样式',
  `is_default` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT 'N' COMMENT '是否默认（Y是 N否）',
  `status` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '0' COMMENT '状态（0正常 1停用）',
  `create_by` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '创建者',
  `create_time` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `update_by` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '更新者',
  `update_time` datetime(0) NULL DEFAULT NULL COMMENT '更新时间',
  `remark` varchar(500) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '备注',
  PRIMARY KEY (`dict_code`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 29 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '字典数据表' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of sys_dict_data
-- ----------------------------
INSERT INTO `sys_dict_data` VALUES (1, 1, '男', '0', 'sys_user_sex', '', '', 'Y', '0', 'admin', '2022-11-01 10:16:44', '', NULL, '性别男');
INSERT INTO `sys_dict_data` VALUES (2, 2, '女', '1', 'sys_user_sex', '', '', 'N', '0', 'admin', '2022-11-01 10:16:44', '', NULL, '性别女');
INSERT INTO `sys_dict_data` VALUES (3, 3, '未知', '2', 'sys_user_sex', '', '', 'N', '0', 'admin', '2022-11-01 10:16:44', '', NULL, '性别未知');
INSERT INTO `sys_dict_data` VALUES (4, 1, '显示', '0', 'sys_show_hide', '', 'primary', 'Y', '0', 'admin', '2022-11-01 10:16:44', '', NULL, '显示菜单');
INSERT INTO `sys_dict_data` VALUES (5, 2, '隐藏', '1', 'sys_show_hide', '', 'danger', 'N', '0', 'admin', '2022-11-01 10:16:44', '', NULL, '隐藏菜单');
INSERT INTO `sys_dict_data` VALUES (6, 1, '正常', '0', 'sys_normal_disable', '', 'primary', 'Y', '0', 'admin', '2022-11-01 10:16:44', '', NULL, '正常状态');
INSERT INTO `sys_dict_data` VALUES (7, 2, '停用', '1', 'sys_normal_disable', '', 'danger', 'N', '0', 'admin', '2022-11-01 10:16:44', '', NULL, '停用状态');
INSERT INTO `sys_dict_data` VALUES (8, 1, '正常', '0', 'sys_job_status', '', 'primary', 'Y', '0', 'admin', '2022-11-01 10:16:44', '', NULL, '正常状态');
INSERT INTO `sys_dict_data` VALUES (9, 2, '暂停', '1', 'sys_job_status', '', 'danger', 'N', '0', 'admin', '2022-11-01 10:16:44', '', NULL, '停用状态');
INSERT INTO `sys_dict_data` VALUES (10, 1, '默认', 'DEFAULT', 'sys_job_group', '', '', 'Y', '0', 'admin', '2022-11-01 10:16:44', '', NULL, '默认分组');
INSERT INTO `sys_dict_data` VALUES (11, 2, '系统', 'SYSTEM', 'sys_job_group', '', '', 'N', '0', 'admin', '2022-11-01 10:16:44', '', NULL, '系统分组');
INSERT INTO `sys_dict_data` VALUES (12, 1, '是', 'Y', 'sys_yes_no', '', 'primary', 'Y', '0', 'admin', '2022-11-01 10:16:44', '', NULL, '系统默认是');
INSERT INTO `sys_dict_data` VALUES (13, 2, '否', 'N', 'sys_yes_no', '', 'danger', 'N', '0', 'admin', '2022-11-01 10:16:44', '', NULL, '系统默认否');
INSERT INTO `sys_dict_data` VALUES (14, 1, '通知', '1', 'sys_notice_type', '', 'warning', 'Y', '0', 'admin', '2022-11-01 10:16:44', '', NULL, '通知');
INSERT INTO `sys_dict_data` VALUES (15, 2, '公告', '2', 'sys_notice_type', '', 'success', 'N', '0', 'admin', '2022-11-01 10:16:44', '', NULL, '公告');
INSERT INTO `sys_dict_data` VALUES (16, 1, '正常', '0', 'sys_notice_status', '', 'primary', 'Y', '0', 'admin', '2022-11-01 10:16:44', '', NULL, '正常状态');
INSERT INTO `sys_dict_data` VALUES (17, 2, '关闭', '1', 'sys_notice_status', '', 'danger', 'N', '0', 'admin', '2022-11-01 10:16:45', '', NULL, '关闭状态');
INSERT INTO `sys_dict_data` VALUES (18, 99, '其他', '0', 'sys_oper_type', '', 'info', 'N', '0', 'admin', '2022-11-01 10:16:45', '', NULL, '其他操作');
INSERT INTO `sys_dict_data` VALUES (19, 1, '新增', '1', 'sys_oper_type', '', 'info', 'N', '0', 'admin', '2022-11-01 10:16:45', '', NULL, '新增操作');
INSERT INTO `sys_dict_data` VALUES (20, 2, '修改', '2', 'sys_oper_type', '', 'info', 'N', '0', 'admin', '2022-11-01 10:16:45', '', NULL, '修改操作');
INSERT INTO `sys_dict_data` VALUES (21, 3, '删除', '3', 'sys_oper_type', '', 'danger', 'N', '0', 'admin', '2022-11-01 10:16:45', '', NULL, '删除操作');
INSERT INTO `sys_dict_data` VALUES (22, 4, '授权', '4', 'sys_oper_type', '', 'primary', 'N', '0', 'admin', '2022-11-01 10:16:45', '', NULL, '授权操作');
INSERT INTO `sys_dict_data` VALUES (23, 5, '导出', '5', 'sys_oper_type', '', 'warning', 'N', '0', 'admin', '2022-11-01 10:16:45', '', NULL, '导出操作');
INSERT INTO `sys_dict_data` VALUES (24, 6, '导入', '6', 'sys_oper_type', '', 'warning', 'N', '0', 'admin', '2022-11-01 10:16:45', '', NULL, '导入操作');
INSERT INTO `sys_dict_data` VALUES (25, 7, '强退', '7', 'sys_oper_type', '', 'danger', 'N', '0', 'admin', '2022-11-01 10:16:45', '', NULL, '强退操作');
INSERT INTO `sys_dict_data` VALUES (26, 8, '生成代码', '8', 'sys_oper_type', '', 'warning', 'N', '0', 'admin', '2022-11-01 10:16:45', '', NULL, '生成操作');
INSERT INTO `sys_dict_data` VALUES (27, 9, '清空数据', '9', 'sys_oper_type', '', 'danger', 'N', '0', 'admin', '2022-11-01 10:16:45', '', NULL, '清空操作');
INSERT INTO `sys_dict_data` VALUES (28, 1, '成功', '0', 'sys_common_status', '', 'primary', 'N', '0', 'admin', '2022-11-01 10:16:45', '', NULL, '正常状态');
INSERT INTO `sys_dict_data` VALUES (29, 2, '失败', '1', 'sys_common_status', '', 'danger', 'N', '0', 'admin', '2022-11-01 10:16:45', '', NULL, '停用状态');

-- ----------------------------
-- Table structure for sys_dict_type
-- ----------------------------
DROP TABLE IF EXISTS `sys_dict_type`;
CREATE TABLE `sys_dict_type`  (
  `dict_id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '字典主键',
  `dict_name` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '字典名称',
  `dict_type` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '字典类型',
  `status` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '0' COMMENT '状态（0正常 1停用）',
  `create_by` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '创建者',
  `create_time` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `update_by` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '更新者',
  `update_time` datetime(0) NULL DEFAULT NULL COMMENT '更新时间',
  `remark` varchar(500) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '备注',
  PRIMARY KEY (`dict_id`) USING BTREE,
  UNIQUE INDEX `dict_type`(`dict_type`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 10 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '字典类型表' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of sys_dict_type
-- ----------------------------
INSERT INTO `sys_dict_type` VALUES (1, '用户性别', 'sys_user_sex', '0', 'admin', '2022-11-01 10:16:43', '', NULL, '用户性别列表');
INSERT INTO `sys_dict_type` VALUES (2, '菜单状态', 'sys_show_hide', '0', 'admin', '2022-11-01 10:16:43', '', NULL, '菜单状态列表');
INSERT INTO `sys_dict_type` VALUES (3, '系统开关', 'sys_normal_disable', '0', 'admin', '2022-11-01 10:16:43', '', NULL, '系统开关列表');
INSERT INTO `sys_dict_type` VALUES (4, '任务状态', 'sys_job_status', '0', 'admin', '2022-11-01 10:16:43', '', NULL, '任务状态列表');
INSERT INTO `sys_dict_type` VALUES (5, '任务分组', 'sys_job_group', '0', 'admin', '2022-11-01 10:16:43', '', NULL, '任务分组列表');
INSERT INTO `sys_dict_type` VALUES (6, '系统是否', 'sys_yes_no', '0', 'admin', '2022-11-01 10:16:43', '', NULL, '系统是否列表');
INSERT INTO `sys_dict_type` VALUES (7, '通知类型', 'sys_notice_type', '0', 'admin', '2022-11-01 10:16:43', '', NULL, '通知类型列表');
INSERT INTO `sys_dict_type` VALUES (8, '通知状态', 'sys_notice_status', '0', 'admin', '2022-11-01 10:16:43', '', NULL, '通知状态列表');
INSERT INTO `sys_dict_type` VALUES (9, '操作类型', 'sys_oper_type', '0', 'admin', '2022-11-01 10:16:43', '', NULL, '操作类型列表');
INSERT INTO `sys_dict_type` VALUES (10, '系统状态', 'sys_common_status', '0', 'admin', '2022-11-01 10:16:43', '', NULL, '登录状态列表');

-- ----------------------------
-- Table structure for sys_job
-- ----------------------------
DROP TABLE IF EXISTS `sys_job`;
CREATE TABLE `sys_job`  (
  `job_id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '任务ID',
  `job_name` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '任务名称',
  `job_group` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT 'DEFAULT' COMMENT '任务组名',
  `invoke_target` varchar(500) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '调用目标字符串',
  `cron_expression` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT 'cron执行表达式',
  `misfire_policy` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '3' COMMENT '计划执行错误策略（1立即执行 2执行一次 3放弃执行）',
  `concurrent` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '1' COMMENT '是否并发执行（0允许 1禁止）',
  `status` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '0' COMMENT '状态（0正常 1暂停）',
  `create_by` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '创建者',
  `create_time` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `update_by` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '更新者',
  `update_time` datetime(0) NULL DEFAULT NULL COMMENT '更新时间',
  `remark` varchar(500) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '备注信息',
  PRIMARY KEY (`job_id`, `job_name`, `job_group`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 104 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '定时任务调度表' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of sys_job
-- ----------------------------
INSERT INTO `sys_job` VALUES (1, '#1充电机定时充电', 'DEFAULT', 'ryTask.charger1', '00 00 11 04 08 ? 2023', '3', '1', '0', 'admin', '2022-11-01 10:16:48', '', '2023-08-04 09:54:10', '');
INSERT INTO `sys_job` VALUES (2, '#2充电机定时充电', 'DEFAULT', 'ryTask.charger2', '23 17 10 13 01 ? 2023', '3', '1', '0', 'admin', '2022-11-01 10:16:48', '', '2023-01-13 10:17:20', '');
INSERT INTO `sys_job` VALUES (3, '#3充电机定时充电', 'DEFAULT', 'ryTask.charger3', '26 51 14 02 08 ? 2023', '3', '1', '0', 'admin', '2022-11-01 10:16:48', '', '2023-08-02 14:50:34', '');
INSERT INTO `sys_job` VALUES (100, '#4充电机定时充电', 'DEFAULT', 'ryTask.charger4', '00 00 00 14 01 ? 2023', '3', '1', '0', 'admin', '2022-12-29 13:16:48', '', '2023-01-13 10:17:49', '');
INSERT INTO `sys_job` VALUES (101, '#5充电机定时充电', 'DEFAULT', 'ryTask.charger5', '00 00 12 13 01 ? 2023', '3', '1', '0', 'admin', '2022-12-29 13:16:49', '', '2023-01-13 10:17:59', '');
INSERT INTO `sys_job` VALUES (102, '#6充电机定时充电', 'DEFAULT', 'ryTask.charger6', '06 20 10 13 01 ? 2023', '3', '1', '0', 'admin', '2022-12-29 13:17:48', '', '2023-01-13 10:18:13', '');
INSERT INTO `sys_job` VALUES (103, '#7充电机定时充电', 'DEFAULT', 'ryTask.charger7', '17 22 10 13 01 ? 2023', '3', '1', '0', 'admin', '2022-12-29 13:16:48', '', '2023-01-13 10:18:19', '');
INSERT INTO `sys_job` VALUES (104, '#8充电机定时充电', 'DEFAULT', 'ryTask.charger8', '23 19 10 13 01 ? 2023', '3', '1', '0', 'admin', '2022-12-29 13:16:48', '', '2023-01-13 10:18:25', '');

-- ----------------------------
-- Table structure for sys_job_log
-- ----------------------------
DROP TABLE IF EXISTS `sys_job_log`;
CREATE TABLE `sys_job_log`  (
  `job_log_id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '任务日志ID',
  `job_name` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '任务名称',
  `job_group` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '任务组名',
  `invoke_target` varchar(500) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '调用目标字符串',
  `job_message` varchar(500) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '日志信息',
  `status` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '0' COMMENT '执行状态（0正常 1失败）',
  `exception_info` varchar(2000) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '异常信息',
  `create_time` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  PRIMARY KEY (`job_log_id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 33 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '定时任务调度日志表' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of sys_job_log
-- ----------------------------
INSERT INTO `sys_job_log` VALUES (1, '#1充电机定时充电', 'DEFAULT', 'ryTask.charger1', '#1充电机定时充电 总共耗时：3毫秒', '0', '', '2022-12-29 13:48:06');
INSERT INTO `sys_job_log` VALUES (2, '#2充电机定时充电', 'DEFAULT', 'ryTask.charger2', '#2充电机定时充电 总共耗时：0毫秒', '0', '', '2022-12-29 13:48:09');
INSERT INTO `sys_job_log` VALUES (3, '#7充电机定时充电', 'DEFAULT', 'ryTask.charger7', '#7充电机定时充电 总共耗时：0毫秒', '0', '', '2022-12-29 13:48:14');
INSERT INTO `sys_job_log` VALUES (4, '#5充电机定时充电', 'DEFAULT', 'ryTask.charger5', '#5充电机定时充电 总共耗时：0毫秒', '0', '', '2022-12-29 13:48:14');
INSERT INTO `sys_job_log` VALUES (5, '#4充电机定时充电', 'DEFAULT', 'ryTask.charger4', '#4充电机定时充电 总共耗时：1毫秒', '0', '', '2022-12-29 13:48:14');
INSERT INTO `sys_job_log` VALUES (6, '#1充电机定时充电', 'DEFAULT', 'ryTask.charger1', '#1充电机定时充电 总共耗时：1毫秒', '0', '', '2022-12-29 13:48:14');
INSERT INTO `sys_job_log` VALUES (7, '#6充电机定时充电', 'DEFAULT', 'ryTask.charger6', '#6充电机定时充电 总共耗时：0毫秒', '0', '', '2022-12-29 13:48:14');
INSERT INTO `sys_job_log` VALUES (8, '#8充电机定时充电', 'DEFAULT', 'ryTask.charger8', '#8充电机定时充电 总共耗时：0毫秒', '0', '', '2022-12-29 13:48:14');
INSERT INTO `sys_job_log` VALUES (9, '#3充电机定时充电', 'DEFAULT', 'ryTask.charger3', '#3充电机定时充电 总共耗时：0毫秒', '0', '', '2022-12-29 13:48:14');
INSERT INTO `sys_job_log` VALUES (10, '#1充电机定时充电', 'DEFAULT', 'ryTask.charger1', '#1充电机定时充电 总共耗时：0毫秒', '0', '', '2022-12-29 13:48:24');
INSERT INTO `sys_job_log` VALUES (11, '#2充电机定时充电', 'DEFAULT', 'ryTask.charger2', '#2充电机定时充电 总共耗时：0毫秒', '0', '', '2022-12-29 13:48:24');
INSERT INTO `sys_job_log` VALUES (12, '#6充电机定时充电', 'DEFAULT', 'ryTask.charger6', '#6充电机定时充电 总共耗时：0毫秒', '0', '', '2022-12-29 13:48:34');
INSERT INTO `sys_job_log` VALUES (13, '#4充电机定时充电', 'DEFAULT', 'ryTask.charger4', '#4充电机定时充电 总共耗时：0毫秒', '0', '', '2022-12-29 13:48:34');
INSERT INTO `sys_job_log` VALUES (14, '#1充电机定时充电', 'DEFAULT', 'ryTask.charger1', '#1充电机定时充电 总共耗时：0毫秒', '0', '', '2022-12-29 13:48:34');
INSERT INTO `sys_job_log` VALUES (15, '#8充电机定时充电', 'DEFAULT', 'ryTask.charger8', '#8充电机定时充电 总共耗时：0毫秒', '0', '', '2022-12-29 13:48:34');
INSERT INTO `sys_job_log` VALUES (16, '#7充电机定时充电', 'DEFAULT', 'ryTask.charger7', '#7充电机定时充电 总共耗时：0毫秒', '0', '', '2022-12-29 13:48:34');
INSERT INTO `sys_job_log` VALUES (17, '#5充电机定时充电', 'DEFAULT', 'ryTask.charger5', '#5充电机定时充电 总共耗时：0毫秒', '0', '', '2022-12-29 13:48:34');
INSERT INTO `sys_job_log` VALUES (18, '#3充电机定时充电', 'DEFAULT', 'ryTask.charger3', '#3充电机定时充电 总共耗时：0毫秒', '0', '', '2022-12-29 13:48:34');
INSERT INTO `sys_job_log` VALUES (19, '#2充电机定时充电', 'DEFAULT', 'ryTask.charger2', '#2充电机定时充电 总共耗时：0毫秒', '0', '', '2022-12-29 13:48:39');
INSERT INTO `sys_job_log` VALUES (20, '#1充电机定时充电', 'DEFAULT', 'ryTask.charger1', '#1充电机定时充电 总共耗时：0毫秒', '0', '', '2022-12-29 13:48:44');
INSERT INTO `sys_job_log` VALUES (21, '#1充电机定时充电', 'DEFAULT', 'ryTask.charger1', '#1充电机定时充电 总共耗时：2毫秒', '0', '', '2023-01-11 18:05:59');
INSERT INTO `sys_job_log` VALUES (22, '#3充电机定时充电', 'DEFAULT', 'ryTask.charger3', '#3充电机定时充电 总共耗时：1毫秒', '0', '', '2023-01-13 10:17:57');
INSERT INTO `sys_job_log` VALUES (23, '#1充电机定时充电', 'DEFAULT', 'ryTask.charger1', '#1充电机定时充电 总共耗时：6毫秒', '0', '', '2023-01-13 10:17:57');
INSERT INTO `sys_job_log` VALUES (24, '#8充电机定时充电', 'DEFAULT', 'ryTask.charger8', '#8充电机定时充电 总共耗时：0毫秒', '0', '', '2023-01-13 10:19:20');
INSERT INTO `sys_job_log` VALUES (25, '#6充电机定时充电', 'DEFAULT', 'ryTask.charger6', '#6充电机定时充电 总共耗时：0毫秒', '0', '', '2023-01-13 10:20:03');
INSERT INTO `sys_job_log` VALUES (26, '#7充电机定时充电', 'DEFAULT', 'ryTask.charger7', '#7充电机定时充电 总共耗时：0毫秒', '0', '', '2023-01-13 10:22:14');
INSERT INTO `sys_job_log` VALUES (27, '#5充电机定时充电', 'DEFAULT', 'ryTask.charger5', '#5充电机定时充电 总共耗时：4毫秒', '0', '', '2023-01-13 11:59:58');
INSERT INTO `sys_job_log` VALUES (28, '#1充电机定时充电', 'DEFAULT', 'ryTask.charger1', '#1充电机定时充电 总共耗时：8毫秒', '0', '', '2023-02-11 09:49:55');
INSERT INTO `sys_job_log` VALUES (29, '#1充电机定时充电', 'DEFAULT', 'ryTask.charger1', '#1充电机定时充电 总共耗时：14049毫秒', '0', '', '2023-07-19 15:35:34');
INSERT INTO `sys_job_log` VALUES (30, '#3充电机定时充电', 'DEFAULT', 'ryTask.charger3', '#3充电机定时充电 总共耗时：0毫秒', '0', '', '2023-07-31 11:10:16');
INSERT INTO `sys_job_log` VALUES (31, '#3充电机定时充电', 'DEFAULT', 'ryTask.charger3', '#3充电机定时充电 总共耗时：7259毫秒', '0', '', '2023-07-31 11:12:36');
INSERT INTO `sys_job_log` VALUES (32, '#3充电机定时充电', 'DEFAULT', 'ryTask.charger3', '#3充电机定时充电 总共耗时：7643毫秒', '0', '', '2023-08-02 14:51:34');
INSERT INTO `sys_job_log` VALUES (33, '#1充电机定时充电', 'DEFAULT', 'ryTask.charger1', '#1充电机定时充电 总共耗时：1074毫秒', '0', '', '2023-08-04 11:00:02');

-- ----------------------------
-- Table structure for sys_logininfor
-- ----------------------------
DROP TABLE IF EXISTS `sys_logininfor`;
CREATE TABLE `sys_logininfor`  (
  `info_id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '访问ID',
  `user_name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '用户账号',
  `ipaddr` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '登录IP地址',
  `login_location` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '登录地点',
  `browser` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '浏览器类型',
  `os` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '操作系统',
  `status` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '0' COMMENT '登录状态（0成功 1失败）',
  `msg` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '提示消息',
  `login_time` datetime(0) NULL DEFAULT NULL COMMENT '访问时间',
  PRIMARY KEY (`info_id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 127 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '系统访问记录' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of sys_logininfor
-- ----------------------------
INSERT INTO `sys_logininfor` VALUES (1, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-10-23 12:33:30');
INSERT INTO `sys_logininfor` VALUES (2, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-10-23 12:38:03');
INSERT INTO `sys_logininfor` VALUES (3, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-10-23 12:39:24');
INSERT INTO `sys_logininfor` VALUES (4, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-10-23 12:40:12');
INSERT INTO `sys_logininfor` VALUES (5, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-04 16:19:08');
INSERT INTO `sys_logininfor` VALUES (6, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-04 16:22:50');
INSERT INTO `sys_logininfor` VALUES (7, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-04 16:27:07');
INSERT INTO `sys_logininfor` VALUES (8, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-04 16:31:21');
INSERT INTO `sys_logininfor` VALUES (9, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-04 16:50:27');
INSERT INTO `sys_logininfor` VALUES (10, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-04 17:13:17');
INSERT INTO `sys_logininfor` VALUES (11, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-04 17:44:05');
INSERT INTO `sys_logininfor` VALUES (12, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-04 17:54:01');
INSERT INTO `sys_logininfor` VALUES (13, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-04 18:03:49');
INSERT INTO `sys_logininfor` VALUES (14, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-04 18:07:53');
INSERT INTO `sys_logininfor` VALUES (15, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-04 18:12:03');
INSERT INTO `sys_logininfor` VALUES (16, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-04 18:27:16');
INSERT INTO `sys_logininfor` VALUES (17, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-04 19:04:15');
INSERT INTO `sys_logininfor` VALUES (18, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-04 19:23:18');
INSERT INTO `sys_logininfor` VALUES (19, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-04 19:29:53');
INSERT INTO `sys_logininfor` VALUES (20, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-05 08:14:00');
INSERT INTO `sys_logininfor` VALUES (21, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-05 08:16:28');
INSERT INTO `sys_logininfor` VALUES (22, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-06 14:57:22');
INSERT INTO `sys_logininfor` VALUES (23, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-06 15:03:31');
INSERT INTO `sys_logininfor` VALUES (24, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-06 15:16:47');
INSERT INTO `sys_logininfor` VALUES (25, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-06 16:09:00');
INSERT INTO `sys_logininfor` VALUES (26, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-06 16:57:32');
INSERT INTO `sys_logininfor` VALUES (27, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-06 17:16:03');
INSERT INTO `sys_logininfor` VALUES (28, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-06 17:27:47');
INSERT INTO `sys_logininfor` VALUES (29, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-06 17:40:03');
INSERT INTO `sys_logininfor` VALUES (30, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-07 07:44:58');
INSERT INTO `sys_logininfor` VALUES (31, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-07 08:00:22');
INSERT INTO `sys_logininfor` VALUES (32, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-07 08:37:54');
INSERT INTO `sys_logininfor` VALUES (33, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-07 08:52:30');
INSERT INTO `sys_logininfor` VALUES (34, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-07 09:16:41');
INSERT INTO `sys_logininfor` VALUES (35, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-07 11:23:17');
INSERT INTO `sys_logininfor` VALUES (36, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-07 11:33:27');
INSERT INTO `sys_logininfor` VALUES (37, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-07 11:40:21');
INSERT INTO `sys_logininfor` VALUES (38, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-07 12:57:59');
INSERT INTO `sys_logininfor` VALUES (39, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-07 15:17:16');
INSERT INTO `sys_logininfor` VALUES (40, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-09 11:54:38');
INSERT INTO `sys_logininfor` VALUES (41, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-09 12:17:22');
INSERT INTO `sys_logininfor` VALUES (42, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-09 15:49:40');
INSERT INTO `sys_logininfor` VALUES (43, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-10 11:58:05');
INSERT INTO `sys_logininfor` VALUES (44, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-10 15:04:30');
INSERT INTO `sys_logininfor` VALUES (45, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-10 15:11:19');
INSERT INTO `sys_logininfor` VALUES (46, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-10 16:47:56');
INSERT INTO `sys_logininfor` VALUES (47, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-10 16:58:42');
INSERT INTO `sys_logininfor` VALUES (48, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-10 17:23:04');
INSERT INTO `sys_logininfor` VALUES (49, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-11 08:13:47');
INSERT INTO `sys_logininfor` VALUES (50, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-12 09:25:29');
INSERT INTO `sys_logininfor` VALUES (51, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-12 10:11:20');
INSERT INTO `sys_logininfor` VALUES (52, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-12 15:28:16');
INSERT INTO `sys_logininfor` VALUES (53, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-13 10:33:14');
INSERT INTO `sys_logininfor` VALUES (54, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-13 12:43:03');
INSERT INTO `sys_logininfor` VALUES (55, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-13 13:45:12');
INSERT INTO `sys_logininfor` VALUES (56, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-14 12:36:23');
INSERT INTO `sys_logininfor` VALUES (57, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-14 13:24:16');
INSERT INTO `sys_logininfor` VALUES (58, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-14 13:25:57');
INSERT INTO `sys_logininfor` VALUES (59, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-14 13:45:29');
INSERT INTO `sys_logininfor` VALUES (60, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-15 12:21:42');
INSERT INTO `sys_logininfor` VALUES (61, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-15 13:36:27');
INSERT INTO `sys_logininfor` VALUES (62, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-15 13:52:30');
INSERT INTO `sys_logininfor` VALUES (63, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-15 14:07:11');
INSERT INTO `sys_logininfor` VALUES (64, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-15 14:08:18');
INSERT INTO `sys_logininfor` VALUES (65, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-15 17:52:14');
INSERT INTO `sys_logininfor` VALUES (66, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-16 10:50:43');
INSERT INTO `sys_logininfor` VALUES (67, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-16 13:43:01');
INSERT INTO `sys_logininfor` VALUES (68, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-16 15:52:23');
INSERT INTO `sys_logininfor` VALUES (69, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-16 16:22:42');
INSERT INTO `sys_logininfor` VALUES (70, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-17 08:59:39');
INSERT INTO `sys_logininfor` VALUES (71, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-17 10:53:57');
INSERT INTO `sys_logininfor` VALUES (72, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-17 12:30:42');
INSERT INTO `sys_logininfor` VALUES (73, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-17 12:33:27');
INSERT INTO `sys_logininfor` VALUES (74, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-17 13:52:30');
INSERT INTO `sys_logininfor` VALUES (75, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-17 15:00:01');
INSERT INTO `sys_logininfor` VALUES (76, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-17 15:10:57');
INSERT INTO `sys_logininfor` VALUES (77, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-17 15:47:15');
INSERT INTO `sys_logininfor` VALUES (78, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-17 16:39:46');
INSERT INTO `sys_logininfor` VALUES (79, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-17 22:48:56');
INSERT INTO `sys_logininfor` VALUES (80, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-18 08:21:36');
INSERT INTO `sys_logininfor` VALUES (81, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-18 10:50:12');
INSERT INTO `sys_logininfor` VALUES (82, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-19 08:04:11');
INSERT INTO `sys_logininfor` VALUES (83, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-19 11:16:00');
INSERT INTO `sys_logininfor` VALUES (84, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-19 11:20:34');
INSERT INTO `sys_logininfor` VALUES (85, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-19 11:36:41');
INSERT INTO `sys_logininfor` VALUES (86, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-19 15:18:49');
INSERT INTO `sys_logininfor` VALUES (87, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-20 11:54:05');
INSERT INTO `sys_logininfor` VALUES (88, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-20 13:19:19');
INSERT INTO `sys_logininfor` VALUES (89, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-20 16:27:35');
INSERT INTO `sys_logininfor` VALUES (90, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-21 10:34:23');
INSERT INTO `sys_logininfor` VALUES (91, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-21 10:44:07');
INSERT INTO `sys_logininfor` VALUES (92, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-21 10:47:48');
INSERT INTO `sys_logininfor` VALUES (93, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-21 10:53:48');
INSERT INTO `sys_logininfor` VALUES (94, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-21 10:58:31');
INSERT INTO `sys_logininfor` VALUES (95, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-21 11:35:35');
INSERT INTO `sys_logininfor` VALUES (96, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-21 14:02:57');
INSERT INTO `sys_logininfor` VALUES (97, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-21 14:05:22');
INSERT INTO `sys_logininfor` VALUES (98, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-21 14:06:08');
INSERT INTO `sys_logininfor` VALUES (99, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-21 14:16:09');
INSERT INTO `sys_logininfor` VALUES (100, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-21 14:18:10');
INSERT INTO `sys_logininfor` VALUES (101, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-21 16:04:10');
INSERT INTO `sys_logininfor` VALUES (102, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-21 16:54:10');
INSERT INTO `sys_logininfor` VALUES (103, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-23 12:31:17');
INSERT INTO `sys_logininfor` VALUES (104, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-23 13:22:52');
INSERT INTO `sys_logininfor` VALUES (105, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-23 13:58:33');
INSERT INTO `sys_logininfor` VALUES (106, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-23 17:15:08');
INSERT INTO `sys_logininfor` VALUES (107, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-25 17:51:53');
INSERT INTO `sys_logininfor` VALUES (108, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-25 17:59:27');
INSERT INTO `sys_logininfor` VALUES (109, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2023-12-26 08:27:01');
INSERT INTO `sys_logininfor` VALUES (110, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2023-12-26 08:48:29');
INSERT INTO `sys_logininfor` VALUES (111, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2023-12-26 12:22:35');
INSERT INTO `sys_logininfor` VALUES (112, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2023-12-26 12:26:55');
INSERT INTO `sys_logininfor` VALUES (113, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '1', '用户不存在/密码错误', '2023-12-26 13:56:11');
INSERT INTO `sys_logininfor` VALUES (114, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '1', '密码输入错误1次', '2023-12-26 13:56:11');
INSERT INTO `sys_logininfor` VALUES (115, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2023-12-26 13:56:20');
INSERT INTO `sys_logininfor` VALUES (116, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2023-12-28 17:57:04');
INSERT INTO `sys_logininfor` VALUES (117, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2024-01-11 14:55:46');
INSERT INTO `sys_logininfor` VALUES (118, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2024-03-23 09:23:49');
INSERT INTO `sys_logininfor` VALUES (119, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2024-03-26 08:27:51');
INSERT INTO `sys_logininfor` VALUES (120, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2024-04-08 08:24:05');
INSERT INTO `sys_logininfor` VALUES (121, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2024-04-08 08:52:04');
INSERT INTO `sys_logininfor` VALUES (122, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '1', '密码输入错误1次', '2024-04-08 08:53:56');
INSERT INTO `sys_logininfor` VALUES (123, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '1', '用户不存在/密码错误', '2024-04-08 08:53:56');
INSERT INTO `sys_logininfor` VALUES (124, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2024-04-08 08:54:03');
INSERT INTO `sys_logininfor` VALUES (125, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2024-04-17 09:38:06');
INSERT INTO `sys_logininfor` VALUES (126, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2024-04-25 16:21:00');
INSERT INTO `sys_logininfor` VALUES (127, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2024-05-10 08:43:48');

-- ----------------------------
-- Table structure for sys_menu
-- ----------------------------
DROP TABLE IF EXISTS `sys_menu`;
CREATE TABLE `sys_menu`  (
  `menu_id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '菜单ID',
  `menu_name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '菜单名称',
  `parent_id` bigint(20) NULL DEFAULT 0 COMMENT '父菜单ID',
  `order_num` int(11) NULL DEFAULT 0 COMMENT '显示顺序',
  `path` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '路由地址',
  `component` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '组件路径',
  `query` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '路由参数',
  `is_frame` int(11) NULL DEFAULT 1 COMMENT '是否为外链（0是 1否）',
  `is_cache` int(11) NULL DEFAULT 0 COMMENT '是否缓存（0缓存 1不缓存）',
  `menu_type` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '菜单类型（M目录 C菜单 F按钮）',
  `visible` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '0' COMMENT '菜单状态（0显示 1隐藏）',
  `status` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '0' COMMENT '菜单状态（0正常 1停用）',
  `perms` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '权限标识',
  `icon` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '#' COMMENT '菜单图标',
  `create_by` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '创建者',
  `create_time` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `update_by` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '更新者',
  `update_time` datetime(0) NULL DEFAULT NULL COMMENT '更新时间',
  `remark` varchar(500) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '备注',
  PRIMARY KEY (`menu_id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 2046 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '菜单权限表' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of sys_menu
-- ----------------------------
INSERT INTO `sys_menu` VALUES (1, '系统管理', 0, 13, 'system', NULL, '', 1, 0, 'M', '0', '0', '', 'system', 'admin', '2022-11-01 10:16:33', 'admin', '2022-12-05 15:52:37', '系统管理目录');
INSERT INTO `sys_menu` VALUES (100, '用户管理', 1, 1, 'user', 'system/user/index', '', 1, 0, 'C', '0', '0', 'system:user:list', 'user', 'admin', '2022-11-01 10:16:33', '', NULL, '用户管理菜单');
INSERT INTO `sys_menu` VALUES (101, '角色管理', 1, 2, 'role', 'system/role/index', '', 1, 0, 'C', '0', '0', 'system:role:list', 'peoples', 'admin', '2022-11-01 10:16:33', '', NULL, '角色管理菜单');
INSERT INTO `sys_menu` VALUES (102, '菜单管理', 1, 3, 'menu', 'system/menu/index', '', 1, 0, 'C', '0', '0', 'system:menu:list', 'tree-table', 'admin', '2022-11-01 10:16:33', '', NULL, '菜单管理菜单');
INSERT INTO `sys_menu` VALUES (108, '日志管理', 1, 9, 'log', '', '', 1, 0, 'M', '0', '0', '', 'log', 'admin', '2022-11-01 10:16:33', '', NULL, '日志管理菜单');
INSERT INTO `sys_menu` VALUES (117, '系统接口', 1, 3, 'swagger', 'system/swagger/index', '', 1, 0, 'C', '0', '0', 'system:swagger:list', 'swagger', 'admin', '2022-11-01 10:16:33', 'admin', '2022-11-21 11:41:19', '系统接口菜单');
INSERT INTO `sys_menu` VALUES (500, '操作日志', 108, 1, 'operlog', 'monitor/operlog/index', '', 1, 0, 'C', '0', '0', 'monitor:operlog:list', 'form', 'admin', '2022-11-01 10:16:33', '', NULL, '操作日志菜单');
INSERT INTO `sys_menu` VALUES (501, '登录日志', 108, 2, 'logininfor', 'monitor/logininfor/index', '', 1, 0, 'C', '0', '0', 'monitor:logininfor:list', 'logininfor', 'admin', '2022-11-01 10:16:33', '', NULL, '登录日志菜单');
INSERT INTO `sys_menu` VALUES (1000, '用户查询', 100, 1, '', '', '', 1, 0, 'F', '0', '0', 'system:user:query', '#', 'admin', '2022-11-01 10:16:34', '', NULL, '');
INSERT INTO `sys_menu` VALUES (1001, '用户新增', 100, 2, '', '', '', 1, 0, 'F', '0', '0', 'system:user:add', '#', 'admin', '2022-11-01 10:16:34', '', NULL, '');
INSERT INTO `sys_menu` VALUES (1002, '用户修改', 100, 3, '', '', '', 1, 0, 'F', '0', '0', 'system:user:edit', '#', 'admin', '2022-11-01 10:16:34', '', NULL, '');
INSERT INTO `sys_menu` VALUES (1003, '用户删除', 100, 4, '', '', '', 1, 0, 'F', '0', '0', 'system:user:remove', '#', 'admin', '2022-11-01 10:16:34', '', NULL, '');
INSERT INTO `sys_menu` VALUES (1004, '用户导出', 100, 5, '', '', '', 1, 0, 'F', '0', '0', 'system:user:export', '#', 'admin', '2022-11-01 10:16:34', '', NULL, '');
INSERT INTO `sys_menu` VALUES (1005, '用户导入', 100, 6, '', '', '', 1, 0, 'F', '0', '0', 'system:user:import', '#', 'admin', '2022-11-01 10:16:34', '', NULL, '');
INSERT INTO `sys_menu` VALUES (1006, '重置密码', 100, 7, '', '', '', 1, 0, 'F', '0', '0', 'system:user:resetPwd', '#', 'admin', '2022-11-01 10:16:34', '', NULL, '');
INSERT INTO `sys_menu` VALUES (1007, '角色查询', 101, 1, '', '', '', 1, 0, 'F', '0', '0', 'system:role:query', '#', 'admin', '2022-11-01 10:16:34', '', NULL, '');
INSERT INTO `sys_menu` VALUES (1008, '角色新增', 101, 2, '', '', '', 1, 0, 'F', '0', '0', 'system:role:add', '#', 'admin', '2022-11-01 10:16:34', '', NULL, '');
INSERT INTO `sys_menu` VALUES (1009, '角色修改', 101, 3, '', '', '', 1, 0, 'F', '0', '0', 'system:role:edit', '#', 'admin', '2022-11-01 10:16:34', '', NULL, '');
INSERT INTO `sys_menu` VALUES (1010, '角色删除', 101, 4, '', '', '', 1, 0, 'F', '0', '0', 'system:role:remove', '#', 'admin', '2022-11-01 10:16:34', '', NULL, '');
INSERT INTO `sys_menu` VALUES (1011, '角色导出', 101, 5, '', '', '', 1, 0, 'F', '0', '0', 'system:role:export', '#', 'admin', '2022-11-01 10:16:34', '', NULL, '');
INSERT INTO `sys_menu` VALUES (1012, '菜单查询', 102, 1, '', '', '', 1, 0, 'F', '0', '0', 'system:menu:query', '#', 'admin', '2022-11-01 10:16:34', '', NULL, '');
INSERT INTO `sys_menu` VALUES (1013, '菜单新增', 102, 2, '', '', '', 1, 0, 'F', '0', '0', 'system:menu:add', '#', 'admin', '2022-11-01 10:16:34', '', NULL, '');
INSERT INTO `sys_menu` VALUES (1014, '菜单修改', 102, 3, '', '', '', 1, 0, 'F', '0', '0', 'system:menu:edit', '#', 'admin', '2022-11-01 10:16:34', '', NULL, '');
INSERT INTO `sys_menu` VALUES (1015, '菜单删除', 102, 4, '', '', '', 1, 0, 'F', '0', '0', 'system:menu:remove', '#', 'admin', '2022-11-01 10:16:34', '', NULL, '');
INSERT INTO `sys_menu` VALUES (1039, '操作查询', 500, 1, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:operlog:query', '#', 'admin', '2022-11-01 10:16:34', '', NULL, '');
INSERT INTO `sys_menu` VALUES (1040, '操作删除', 500, 2, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:operlog:remove', '#', 'admin', '2022-11-01 10:16:34', '', NULL, '');
INSERT INTO `sys_menu` VALUES (1041, '日志导出', 500, 3, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:operlog:export', '#', 'admin', '2022-11-01 10:16:34', '', NULL, '');
INSERT INTO `sys_menu` VALUES (1042, '登录查询', 501, 1, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:logininfor:query', '#', 'admin', '2022-11-01 10:16:34', '', NULL, '');
INSERT INTO `sys_menu` VALUES (1043, '登录删除', 501, 2, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:logininfor:remove', '#', 'admin', '2022-11-01 10:16:34', '', NULL, '');
INSERT INTO `sys_menu` VALUES (1044, '日志导出', 501, 3, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:logininfor:export', '#', 'admin', '2022-11-01 10:16:34', '', NULL, '');
INSERT INTO `sys_menu` VALUES (1045, '账户解锁', 501, 4, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:logininfor:unlock', '#', 'admin', '2022-11-01 10:16:34', '', NULL, '');
INSERT INTO `sys_menu` VALUES (2000, '信息汇总', 0, 7, 'info', 'info/index', NULL, 1, 0, 'C', '0', '0', '', '#', 'admin', '2022-11-10 09:46:49', 'admin', '2022-12-05 15:52:04', '');
INSERT INTO `sys_menu` VALUES (2001, '充电监控', 0, 8, 'chargingMonitoring', 'chargingMonitoring/index', NULL, 1, 0, 'C', '0', '0', 'web:operation:chargerStop', '#', 'admin', '2022-11-10 09:48:11', 'thb', '2023-07-10 16:55:30', '');
INSERT INTO `sys_menu` VALUES (2002, '电池监控', 0, 9, 'batterMonitoring', 'batterMonitoring/index', NULL, 1, 0, 'C', '0', '0', '', '#', 'admin', '2022-11-10 09:49:13', 'admin', '2022-12-08 11:03:52', '');
INSERT INTO `sys_menu` VALUES (2003, '充/换电记录', 0, 10, 'impulseChange', NULL, NULL, 1, 0, 'M', '0', '0', '', '#', 'admin', '2022-11-10 09:50:32', 'admin', '2022-12-05 15:52:21', '');
INSERT INTO `sys_menu` VALUES (2004, '统计记录', 0, 11, 'statisticalRecord', 'statisticalRecord/index', NULL, 1, 0, 'C', '0', '0', '', '#', 'admin', '2022-11-10 09:51:52', 'admin', '2022-12-05 15:52:26', '');
INSERT INTO `sys_menu` VALUES (2005, '告警记录', 0, 12, 'warnningRecord', 'warnningRecord/index', NULL, 1, 0, 'C', '0', '0', '', '#', 'admin', '2022-11-10 09:52:22', 'admin', '2022-12-05 15:52:31', '');
INSERT INTO `sys_menu` VALUES (2006, '充电记录', 2003, 0, 'chargeRecord', 'impulseChange/chargeRecord/index', NULL, 1, 0, 'C', '0', '0', NULL, '#', 'admin', '2022-11-15 17:01:34', '', NULL, '');
INSERT INTO `sys_menu` VALUES (2007, '换电记录', 2003, 1, 'changeRecord', 'impulseChange/changeRecord/index', NULL, 1, 0, 'C', '0', '0', '', '#', 'admin', '2022-11-15 17:02:56', 'admin', '2022-11-15 17:04:46', '');
INSERT INTO `sys_menu` VALUES (2008, '车辆管理', 1, 10, 'car', 'system/car/index', NULL, 1, 0, 'M', '0', '0', '', '#', 'admin', '2022-11-19 10:58:43', 'admin', '2022-11-19 11:05:00', '');
INSERT INTO `sys_menu` VALUES (2009, '电池管理', 1, 3, 'battery', 'system/battery/index', NULL, 1, 0, 'M', '0', '0', '', '#', 'admin', '2022-11-19 10:59:27', 'admin', '2022-11-19 11:05:14', '');
INSERT INTO `sys_menu` VALUES (2010, '充电记录列表', 2006, 1, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:chargeRecord:list', '#', 'admin', '2022-12-05 15:22:36', '', NULL, '');
INSERT INTO `sys_menu` VALUES (2012, '应急充电新增', 2006, 2, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:chargeRecord:add', '#', 'admin', '2022-12-05 15:24:06', 'admin', '2022-12-05 15:41:20', '');
INSERT INTO `sys_menu` VALUES (2015, '充电记录导出', 2006, 3, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:chargeRecord:export', '#', 'admin', '2022-12-05 15:25:49', 'admin', '2022-12-05 15:41:25', '');
INSERT INTO `sys_menu` VALUES (2016, '换电记录列表', 2007, 1, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:changePowerRecord:list', '#', 'admin', '2022-12-05 15:30:31', '', NULL, '');
INSERT INTO `sys_menu` VALUES (2017, '换电记录新增', 2007, 2, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:changePowerRecord:add', '#', 'admin', '2022-12-05 15:31:03', '', NULL, '');
INSERT INTO `sys_menu` VALUES (2018, '换电记录导出', 2007, 3, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:changePowerRecord:export', '#', 'admin', '2022-12-05 15:31:30', '', NULL, '');
INSERT INTO `sys_menu` VALUES (2019, '统计记录导出', 2004, 1, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:chargeRecord:exportData', '#', 'admin', '2022-12-05 15:33:48', '', NULL, '');
INSERT INTO `sys_menu` VALUES (2020, '告警记录列表', 2005, 1, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:alarmRecord:list', '#', 'admin', '2022-12-05 15:35:05', '', NULL, '');
INSERT INTO `sys_menu` VALUES (2021, '告警记录导出', 2005, 2, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:alarmRecord:export', '#', 'admin', '2022-12-05 15:35:28', '', NULL, '');
INSERT INTO `sys_menu` VALUES (2022, '电池管理列表', 2009, 1, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:battery:list', '#', 'admin', '2022-12-05 15:38:04', '', NULL, '');
INSERT INTO `sys_menu` VALUES (2023, '电池管理新增', 2009, 3, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:battery:add', '#', 'admin', '2022-12-05 15:38:30', 'admin', '2022-12-05 16:10:02', '');
INSERT INTO `sys_menu` VALUES (2024, '点出管理导入', 2009, 6, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:battery:exportTemplate', '#', 'admin', '2022-12-05 15:39:25', 'admin', '2022-12-05 16:10:12', '');
INSERT INTO `sys_menu` VALUES (2025, '车辆管理列表', 2008, 1, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:vehicle:list', '#', 'admin', '2022-12-05 15:43:03', '', NULL, '');
INSERT INTO `sys_menu` VALUES (2026, '车辆管理新增', 2008, 3, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:vehicle:add', '#', 'admin', '2022-12-05 15:43:26', 'admin', '2022-12-05 16:48:21', '');
INSERT INTO `sys_menu` VALUES (2027, '车辆管理导入', 2008, 6, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:vehicle:importData', '#', 'admin', '2022-12-05 15:44:04', 'admin', '2022-12-05 16:48:16', '');
INSERT INTO `sys_menu` VALUES (2028, '首页复位', 0, 1, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:operation:reset', '#', 'admin', '2022-12-05 15:49:08', '', NULL, '');
INSERT INTO `sys_menu` VALUES (2029, '首页暂停', 0, 2, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:operation:suspend', '#', 'admin', '2022-12-05 15:49:26', '', NULL, '');
INSERT INTO `sys_menu` VALUES (2030, '首页继续', 0, 3, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:operation:continue', '#', 'admin', '2022-12-05 15:49:59', '', NULL, '');
INSERT INTO `sys_menu` VALUES (2031, '首页换仓', 0, 4, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:operation:change', '#', 'admin', '2022-12-05 15:50:18', '', NULL, '');
INSERT INTO `sys_menu` VALUES (2032, '首页急停', 0, 5, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:operation:scram', '#', 'admin', '2022-12-05 15:51:34', '', NULL, '');
INSERT INTO `sys_menu` VALUES (2033, '结束换电', 0, 6, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:operation:endChange', '#', 'admin', '2022-12-05 15:51:58', '', NULL, '');
INSERT INTO `sys_menu` VALUES (2034, '电池管理查询', 2009, 2, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:battery:query', '#', 'admin', '2022-12-05 16:09:43', 'admin', '2022-12-05 16:09:55', '');
INSERT INTO `sys_menu` VALUES (2035, '电池管理修改', 2009, 4, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:battery:edit', '#', 'admin', '2022-12-05 16:10:37', '', NULL, '');
INSERT INTO `sys_menu` VALUES (2036, '电池管理删除', 2009, 5, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:battery:remove', '#', 'admin', '2022-12-05 16:11:00', 'admin', '2022-12-05 16:11:16', '');
INSERT INTO `sys_menu` VALUES (2037, '车辆管理查询', 2008, 2, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:vehicle:query', '#', 'admin', '2022-12-05 16:49:38', '', NULL, '');
INSERT INTO `sys_menu` VALUES (2038, '车辆管理修改', 2008, 4, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:vehicle:edit', '#', 'admin', '2022-12-05 16:49:59', '', NULL, '');
INSERT INTO `sys_menu` VALUES (2039, '车辆管理删除', 2008, 5, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:vehicle:remove', '#', 'admin', '2022-12-05 16:50:22', '', NULL, '');
INSERT INTO `sys_menu` VALUES (2040, '系统设置', 1, 1, 'sys', 'system/system/index', NULL, 1, 0, 'C', '0', '0', 'system:pwtConfig:query', '#', 'admin', '2022-12-28 13:47:03', 'thb', '2023-07-10 16:45:59', '');
INSERT INTO `sys_menu` VALUES (2041, '充电监控启动', 2001, 1, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:operation:chargerStart', '#', 'admin', '2023-07-01 16:29:30', '', NULL, '');
INSERT INTO `sys_menu` VALUES (2042, '模式切换 ', 0, 0, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:operation:changeMode', '#', 'thb', '2023-07-02 20:33:59', '', NULL, '');
INSERT INTO `sys_menu` VALUES (2043, '停机', 2001, 1, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:operation:chargerStop', '#', 'thb', '2023-07-10 16:51:01', '', NULL, '');
INSERT INTO `sys_menu` VALUES (2044, '停机按钮', 2001, 1, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:operation:chargerStop', '#', 'thb', '2023-07-10 16:52:46', '', NULL, '');
INSERT INTO `sys_menu` VALUES (2045, '充电监控停机', 2001, 1, '', NULL, NULL, 1, 0, 'F', '0', '0', 'web:operation:chargerStop', '#', 'thb', '2023-07-10 16:54:35', '', NULL, '');
INSERT INTO `sys_menu` VALUES (2046, '电表监控', 0, 4, 'electronic/index', 'electronic/index', NULL, 1, 0, 'C', '0', '0', '', '#', 'admin', '2024-04-08 08:30:25', 'admin', '2024-04-08 08:56:01', '');

-- ----------------------------
-- Table structure for sys_notice
-- ----------------------------
DROP TABLE IF EXISTS `sys_notice`;
CREATE TABLE `sys_notice`  (
  `notice_id` int(11) NOT NULL AUTO_INCREMENT COMMENT '公告ID',
  `notice_title` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '公告标题',
  `notice_type` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '公告类型（1通知 2公告）',
  `notice_content` longblob NULL COMMENT '公告内容',
  `status` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '0' COMMENT '公告状态（0正常 1关闭）',
  `create_by` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '创建者',
  `create_time` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `update_by` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '更新者',
  `update_time` datetime(0) NULL DEFAULT NULL COMMENT '更新时间',
  `remark` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '备注',
  PRIMARY KEY (`notice_id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 2 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '通知公告表' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of sys_notice
-- ----------------------------
INSERT INTO `sys_notice` VALUES (1, '温馨提醒：2018-07-01 若依新版本发布啦', '2', 0xE696B0E78988E69CACE58685E5AEB9, '0', 'admin', '2022-11-01 10:16:50', '', NULL, '管理员');
INSERT INTO `sys_notice` VALUES (2, '维护通知：2018-07-01 若依系统凌晨维护', '1', 0xE7BBB4E68AA4E58685E5AEB9, '0', 'admin', '2022-11-01 10:16:50', '', NULL, '管理员');

-- ----------------------------
-- Table structure for sys_oper_log
-- ----------------------------
DROP TABLE IF EXISTS `sys_oper_log`;
CREATE TABLE `sys_oper_log`  (
  `oper_id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '日志主键',
  `title` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '模块标题',
  `business_type` int(11) NULL DEFAULT 0 COMMENT '业务类型（0其它 1新增 2修改 3删除）',
  `method` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '方法名称',
  `request_method` varchar(10) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '请求方式',
  `operator_type` int(11) NULL DEFAULT 0 COMMENT '操作类别（0其它 1后台用户 2手机端用户）',
  `oper_name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '操作人员',
  `dept_name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '部门名称',
  `oper_url` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '请求URL',
  `oper_ip` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '主机地址',
  `oper_location` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '操作地点',
  `oper_param` varchar(2000) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '请求参数',
  `json_result` varchar(2000) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '返回参数',
  `status` int(11) NULL DEFAULT 0 COMMENT '操作状态（0正常 1异常）',
  `error_msg` varchar(2000) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '错误消息',
  `oper_time` datetime(0) NULL DEFAULT NULL COMMENT '操作时间',
  PRIMARY KEY (`oper_id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 474 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '操作日志记录' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of sys_oper_log
-- ----------------------------
INSERT INTO `sys_oper_log` VALUES (1, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.edit()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig', '127.0.0.1', '内网IP', '{\"agreementType\":\"A\",\"charger1Emg\":false,\"charger1Ip\":\"192.168.3.41\",\"charger1No\":\"11111111111113\",\"charger1Port\":8080,\"charger2Emg\":false,\"charger2Ip\":\"192.168.3.42\",\"charger2No\":\"11111111111121\",\"charger2Port\":8080,\"charger3Emg\":false,\"charger3Ip\":\"192.168.3.43\",\"charger3No\":\"11111111111111\",\"charger3Port\":8088,\"charger4Emg\":true,\"charger4Ip\":\"192.168.3.44\",\"charger4No\":\"11111111111141\",\"charger4Port\":8088,\"charger5Emg\":false,\"charger5Ip\":\"192.168.3.45\",\"charger5No\":\"0\",\"charger5Port\":8088,\"charger6Emg\":false,\"charger6Ip\":\"192.168.3.46\",\"charger6No\":\"0\",\"charger6Port\":8088,\"charger7Emg\":false,\"charger7Ip\":\"192.168.3.47\",\"charger7No\":\"0\",\"charger7Port\":8088,\"charger8Emg\":false,\"charger8Ip\":\"192.168.3.48\",\"charger8No\":\"0\",\"charger8Port\":8088,\"id\":1,\"params\":{},\"rfidIp\":\"192.168.0.3\",\"rfidPort\":2000,\"robotIp\":\"19.168.0.1\",\"robotNo\":\"Robbot_001\",\"scannerIp\":\"192.168.0.2\",\"scannerPort\":3000,\"systemIp\":\"127.0.0.1\",\"systemPort\":3000,\"vehicleCidr\":\"127.0.0.1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-10-23 12:37:09');
INSERT INTO `sys_oper_log` VALUES (2, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.edit()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig', '127.0.0.1', '内网IP', '{\"agreementType\":\"A\",\"charger1Emg\":false,\"charger1Ip\":\"192.168.3.41\",\"charger1No\":\"11111111111113\",\"charger1Port\":8080,\"charger2Emg\":true,\"charger2Ip\":\"192.168.3.42\",\"charger2No\":\"11111111111121\",\"charger2Port\":8080,\"charger3Emg\":false,\"charger3Ip\":\"192.168.3.43\",\"charger3No\":\"11111111111111\",\"charger3Port\":8088,\"charger4Emg\":false,\"charger4Ip\":\"192.168.3.44\",\"charger4No\":\"11111111111141\",\"charger4Port\":8088,\"charger5Emg\":false,\"charger5Ip\":\"192.168.3.45\",\"charger5No\":\"0\",\"charger5Port\":8088,\"charger6Emg\":false,\"charger6Ip\":\"192.168.3.46\",\"charger6No\":\"0\",\"charger6Port\":8088,\"charger7Emg\":false,\"charger7Ip\":\"192.168.3.47\",\"charger7No\":\"0\",\"charger7Port\":8088,\"charger8Emg\":false,\"charger8Ip\":\"192.168.3.48\",\"charger8No\":\"0\",\"charger8Port\":8088,\"id\":1,\"params\":{},\"rfidIp\":\"192.168.0.3\",\"rfidPort\":2000,\"robotIp\":\"19.168.0.1\",\"robotNo\":\"Robbot_001\",\"scannerIp\":\"192.168.0.2\",\"scannerPort\":3000,\"systemIp\":\"127.0.0.1\",\"systemPort\":3000,\"vehicleCidr\":\"127.0.0.1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-10-23 12:39:47');
INSERT INTO `sys_oper_log` VALUES (3, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.edit()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig', '127.0.0.1', '内网IP', '{\"agreementType\":\"A\",\"charger1Emg\":false,\"charger1Ip\":\"192.168.3.41\",\"charger1No\":\"GHLN10183CDJ1\",\"charger1Port\":8080,\"charger2Emg\":true,\"charger2Ip\":\"192.168.3.42\",\"charger2No\":\"GHLN10183CDJ2\",\"charger2Port\":8080,\"charger3Emg\":false,\"charger3Ip\":\"192.168.3.43\",\"charger3No\":\"0\",\"charger3Port\":8088,\"charger4Emg\":false,\"charger4Ip\":\"192.168.3.44\",\"charger4No\":\"GHLN10183CDJ4\",\"charger4Port\":8088,\"charger5Emg\":false,\"charger5Ip\":\"192.168.3.45\",\"charger5No\":\"0\",\"charger5Port\":8088,\"charger6Emg\":false,\"charger6Ip\":\"192.168.3.46\",\"charger6No\":\"0\",\"charger6Port\":8088,\"charger7Emg\":false,\"charger7Ip\":\"192.168.3.47\",\"charger7No\":\"0\",\"charger7Port\":8088,\"charger8Emg\":false,\"charger8Ip\":\"192.168.3.48\",\"charger8No\":\"0\",\"charger8Port\":8088,\"id\":1,\"params\":{},\"rfidIp\":\"192.168.0.3\",\"rfidPort\":2000,\"robotIp\":\"19.168.0.1\",\"robotNo\":\"Robbot_001\",\"scannerIp\":\"192.168.0.2\",\"scannerPort\":3000,\"systemIp\":\"127.0.0.1\",\"systemPort\":3000,\"vehicleCidr\":\"127.0.0.1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-04 16:18:21');
INSERT INTO `sys_oper_log` VALUES (4, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.edit()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig', '127.0.0.1', '内网IP', '{\"agreementType\":\"A\",\"charger1Emg\":false,\"charger1Ip\":\"192.168.3.41\",\"charger1No\":\"GHLN10183CDJ1\",\"charger1Port\":8080,\"charger2Emg\":true,\"charger2Ip\":\"192.168.3.42\",\"charger2No\":\"GHLN10183CDJ2\",\"charger2Port\":8080,\"charger3Emg\":false,\"charger3Ip\":\"192.168.3.43\",\"charger3No\":\"0\",\"charger3Port\":8088,\"charger4Emg\":false,\"charger4Ip\":\"192.168.3.44\",\"charger4No\":\"GHLN10183CDJ4\",\"charger4Port\":8088,\"charger5Emg\":false,\"charger5Ip\":\"192.168.3.45\",\"charger5No\":\"0\",\"charger5Port\":8088,\"charger6Emg\":false,\"charger6Ip\":\"192.168.3.46\",\"charger6No\":\"0\",\"charger6Port\":8088,\"charger7Emg\":false,\"charger7Ip\":\"192.168.3.47\",\"charger7No\":\"0\",\"charger7Port\":8088,\"charger8Emg\":false,\"charger8Ip\":\"192.168.3.48\",\"charger8No\":\"0\",\"charger8Port\":8088,\"id\":1,\"params\":{},\"rfidIp\":\"192.168.0.3\",\"rfidPort\":2000,\"robotIp\":\"19.168.0.1\",\"robotNo\":\"Robbot_001\",\"scannerIp\":\"192.168.0.2\",\"scannerPort\":3000,\"systemIp\":\"127.0.0.1\",\"systemPort\":3000,\"vehicleCidr\":\"127.0.0.1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-04 16:20:21');
INSERT INTO `sys_oper_log` VALUES (5, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.edit()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig', '127.0.0.1', '内网IP', '{\"agreementType\":\"A\",\"charger1Emg\":false,\"charger1Ip\":\"192.168.3.41\",\"charger1No\":\"GHLN10183CDJ1\",\"charger1Port\":8080,\"charger2Emg\":true,\"charger2Ip\":\"192.168.3.42\",\"charger2No\":\"GHLN10183CDJ2\",\"charger2Port\":8080,\"charger3Emg\":false,\"charger3Ip\":\"192.168.3.43\",\"charger3No\":\"0\",\"charger3Port\":8088,\"charger4Emg\":false,\"charger4Ip\":\"192.168.3.44\",\"charger4No\":\"GHLN10183CDJ4\",\"charger4Port\":8088,\"charger5Emg\":false,\"charger5Ip\":\"192.168.3.45\",\"charger5No\":\"0\",\"charger5Port\":8088,\"charger6Emg\":false,\"charger6Ip\":\"192.168.3.46\",\"charger6No\":\"0\",\"charger6Port\":8088,\"charger7Emg\":false,\"charger7Ip\":\"192.168.3.47\",\"charger7No\":\"0\",\"charger7Port\":8088,\"charger8Emg\":false,\"charger8Ip\":\"192.168.3.48\",\"charger8No\":\"0\",\"charger8Port\":8088,\"id\":1,\"params\":{},\"rfidIp\":\"192.168.0.3\",\"rfidPort\":2000,\"robotIp\":\"19.168.0.1\",\"robotNo\":\"Robbot_001\",\"scannerIp\":\"192.168.0.2\",\"scannerPort\":3000,\"systemIp\":\"127.0.0.1\",\"systemPort\":3000,\"vehicleCidr\":\"127.0.0.1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-04 16:21:01');
INSERT INTO `sys_oper_log` VALUES (6, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.edit()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig', '127.0.0.1', '内网IP', '{\"agreementType\":\"A\",\"charger1Emg\":false,\"charger1Ip\":\"192.168.3.41\",\"charger1No\":\"GHLN10183CDJ1\",\"charger1Port\":8080,\"charger2Emg\":true,\"charger2Ip\":\"192.168.3.42\",\"charger2No\":\"GHLN10183CDJ2\",\"charger2Port\":8080,\"charger3Emg\":false,\"charger3Ip\":\"192.168.3.43\",\"charger3No\":\"0\",\"charger3Port\":8088,\"charger4Emg\":false,\"charger4Ip\":\"192.168.3.44\",\"charger4No\":\"GHLN10183CDJ4\",\"charger4Port\":8088,\"charger5Emg\":false,\"charger5Ip\":\"192.168.3.45\",\"charger5No\":\"0\",\"charger5Port\":8088,\"charger6Emg\":false,\"charger6Ip\":\"192.168.3.46\",\"charger6No\":\"0\",\"charger6Port\":8088,\"charger7Emg\":false,\"charger7Ip\":\"192.168.3.47\",\"charger7No\":\"0\",\"charger7Port\":8088,\"charger8Emg\":false,\"charger8Ip\":\"192.168.3.48\",\"charger8No\":\"0\",\"charger8Port\":8088,\"id\":1,\"params\":{},\"rfidIp\":\"192.168.0.3\",\"rfidPort\":2000,\"robotIp\":\"19.168.0.1\",\"robotNo\":\"Robbot_001\",\"scannerIp\":\"192.168.0.2\",\"scannerPort\":3000,\"systemIp\":\"127.0.0.1\",\"systemPort\":3000,\"vehicleCidr\":\"127.0.0.1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-04 16:24:11');
INSERT INTO `sys_oper_log` VALUES (7, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.edit()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig', '127.0.0.1', '内网IP', '{\"agreementType\":\"A\",\"charger1Emg\":false,\"charger1Ip\":\"192.168.3.41\",\"charger1No\":\"GHLN10183CDJ1\",\"charger1Port\":8080,\"charger2Emg\":true,\"charger2Ip\":\"192.168.3.42\",\"charger2No\":\"GHLN10183CDJ2\",\"charger2Port\":8080,\"charger3Emg\":false,\"charger3Ip\":\"192.168.3.43\",\"charger3No\":\"GHLN10183CDJ1\",\"charger3Port\":8088,\"charger4Emg\":false,\"charger4Ip\":\"192.168.3.44\",\"charger4No\":\"GHLN10183CDJ4\",\"charger4Port\":8088,\"charger5Emg\":false,\"charger5Ip\":\"192.168.3.45\",\"charger5No\":\"0\",\"charger5Port\":8088,\"charger6Emg\":false,\"charger6Ip\":\"192.168.3.46\",\"charger6No\":\"0\",\"charger6Port\":8088,\"charger7Emg\":false,\"charger7Ip\":\"192.168.3.47\",\"charger7No\":\"0\",\"charger7Port\":8088,\"charger8Emg\":false,\"charger8Ip\":\"192.168.3.48\",\"charger8No\":\"0\",\"charger8Port\":8088,\"id\":1,\"params\":{},\"rfidIp\":\"192.168.0.3\",\"rfidPort\":2000,\"robotIp\":\"19.168.0.1\",\"robotNo\":\"Robbot_001\",\"scannerIp\":\"192.168.0.2\",\"scannerPort\":3000,\"systemIp\":\"127.0.0.1\",\"systemPort\":3000,\"vehicleCidr\":\"127.0.0.1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-04 16:29:28');
INSERT INTO `sys_oper_log` VALUES (8, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.edit()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig', '127.0.0.1', '内网IP', '{\"agreementType\":\"A\",\"charger1Emg\":false,\"charger1Ip\":\"192.168.3.41\",\"charger1No\":\"GHLN10183CDJ1\",\"charger1Port\":8080,\"charger2Emg\":true,\"charger2Ip\":\"192.168.3.42\",\"charger2No\":\"GHLN10183CDJ2\",\"charger2Port\":8080,\"charger3Emg\":false,\"charger3Ip\":\"192.168.3.43\",\"charger3No\":\"GHLN10183CDJ1\",\"charger3Port\":8088,\"charger4Emg\":false,\"charger4Ip\":\"192.168.3.44\",\"charger4No\":\"GHLN10183CDJ4\",\"charger4Port\":8088,\"charger5Emg\":false,\"charger5Ip\":\"192.168.3.45\",\"charger5No\":\"0\",\"charger5Port\":8088,\"charger6Emg\":false,\"charger6Ip\":\"192.168.3.46\",\"charger6No\":\"0\",\"charger6Port\":8088,\"charger7Emg\":false,\"charger7Ip\":\"192.168.3.47\",\"charger7No\":\"0\",\"charger7Port\":8088,\"charger8Emg\":false,\"charger8Ip\":\"192.168.3.48\",\"charger8No\":\"0\",\"charger8Port\":8088,\"id\":1,\"params\":{},\"rfidIp\":\"192.168.0.3\",\"rfidPort\":2000,\"robotIp\":\"19.168.0.1\",\"robotNo\":\"Robbot_001\",\"scannerIp\":\"192.168.0.2\",\"scannerPort\":3000,\"systemIp\":\"127.0.0.1\",\"systemPort\":3000,\"vehicleCidr\":\"127.0.0.1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-04 16:29:44');
INSERT INTO `sys_oper_log` VALUES (9, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.edit()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig', '127.0.0.1', '内网IP', '{\"agreementType\":\"A\",\"charger1Emg\":false,\"charger1Ip\":\"192.168.3.41\",\"charger1No\":\"GHLN10183CDJ1\",\"charger1Port\":8080,\"charger2Emg\":true,\"charger2Ip\":\"192.168.3.42\",\"charger2No\":\"GHLN10183CDJ2\",\"charger2Port\":8080,\"charger3Emg\":false,\"charger3Ip\":\"192.168.3.43\",\"charger3No\":\"0\",\"charger3Port\":8088,\"charger4Emg\":false,\"charger4Ip\":\"192.168.3.44\",\"charger4No\":\"GHLN10183CDJ4\",\"charger4Port\":8088,\"charger5Emg\":false,\"charger5Ip\":\"192.168.3.45\",\"charger5No\":\"0\",\"charger5Port\":8088,\"charger6Emg\":false,\"charger6Ip\":\"192.168.3.46\",\"charger6No\":\"0\",\"charger6Port\":8088,\"charger7Emg\":false,\"charger7Ip\":\"192.168.3.47\",\"charger7No\":\"0\",\"charger7Port\":8088,\"charger8Emg\":false,\"charger8Ip\":\"192.168.3.48\",\"charger8No\":\"0\",\"charger8Port\":8088,\"id\":1,\"params\":{},\"rfidIp\":\"192.168.0.3\",\"rfidPort\":2000,\"robotIp\":\"19.168.0.1\",\"robotNo\":\"Robbot_001\",\"scannerIp\":\"192.168.0.2\",\"scannerPort\":3000,\"systemIp\":\"127.0.0.1\",\"systemPort\":3000,\"vehicleCidr\":\"127.0.0.1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-04 16:51:48');
INSERT INTO `sys_oper_log` VALUES (10, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.edit()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig', '127.0.0.1', '内网IP', '{\"agreementType\":\"A\",\"charger1Emg\":false,\"charger1Ip\":\"192.168.3.41\",\"charger1No\":\"GHLN10183CDJ1\",\"charger1Port\":8080,\"charger2Emg\":true,\"charger2Ip\":\"192.168.3.42\",\"charger2No\":\"GHLN10183CDJ2\",\"charger2Port\":8080,\"charger3Emg\":false,\"charger3Ip\":\"192.168.3.43\",\"charger3No\":\"0\",\"charger3Port\":8088,\"charger4Emg\":false,\"charger4Ip\":\"192.168.3.44\",\"charger4No\":\"GHLN10183CDJ4\",\"charger4Port\":8088,\"charger5Emg\":false,\"charger5Ip\":\"192.168.3.45\",\"charger5No\":\"0\",\"charger5Port\":8088,\"charger6Emg\":false,\"charger6Ip\":\"192.168.3.46\",\"charger6No\":\"0\",\"charger6Port\":8088,\"charger7Emg\":false,\"charger7Ip\":\"192.168.3.47\",\"charger7No\":\"0\",\"charger7Port\":8088,\"charger8Emg\":false,\"charger8Ip\":\"192.168.3.48\",\"charger8No\":\"0\",\"charger8Port\":8088,\"id\":1,\"params\":{},\"rfidIp\":\"192.168.0.3\",\"rfidPort\":2000,\"robotIp\":\"19.168.0.1\",\"robotNo\":\"Robbot_001\",\"scannerIp\":\"192.168.0.2\",\"scannerPort\":3000,\"systemIp\":\"127.0.0.1\",\"systemPort\":3000,\"vehicleCidr\":\"127.0.0.1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-04 16:51:59');
INSERT INTO `sys_oper_log` VALUES (11, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.edit()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig', '127.0.0.1', '内网IP', '{\"agreementType\":\"A\",\"charger1Emg\":false,\"charger1Ip\":\"192.168.3.41\",\"charger1No\":\"GHLN10183CDJ11\",\"charger1Port\":8080,\"charger2Emg\":true,\"charger2Ip\":\"192.168.3.42\",\"charger2No\":\"GHLN10183CDJ21\",\"charger2Port\":8080,\"charger3Emg\":false,\"charger3Ip\":\"192.168.3.43\",\"charger3No\":\"GHLN10183CDJ13\",\"charger3Port\":8088,\"charger4Emg\":false,\"charger4Ip\":\"192.168.3.44\",\"charger4No\":\"GHLN10183CDJ41\",\"charger4Port\":8088,\"charger5Emg\":false,\"charger5Ip\":\"192.168.3.45\",\"charger5No\":\"0\",\"charger5Port\":8088,\"charger6Emg\":false,\"charger6Ip\":\"192.168.3.46\",\"charger6No\":\"0\",\"charger6Port\":8088,\"charger7Emg\":false,\"charger7Ip\":\"192.168.3.47\",\"charger7No\":\"0\",\"charger7Port\":8088,\"charger8Emg\":false,\"charger8Ip\":\"192.168.3.48\",\"charger8No\":\"0\",\"charger8Port\":8088,\"id\":1,\"params\":{},\"rfidIp\":\"192.168.0.3\",\"rfidPort\":2000,\"robotIp\":\"19.168.0.1\",\"robotNo\":\"Robbot_001\",\"scannerIp\":\"192.168.0.2\",\"scannerPort\":3000,\"systemIp\":\"127.0.0.1\",\"systemPort\":3000,\"vehicleCidr\":\"127.0.0.1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-04 18:10:25');
INSERT INTO `sys_oper_log` VALUES (12, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.edit()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig', '127.0.0.1', '内网IP', '{\"agreementType\":\"A\",\"charger1Emg\":false,\"charger1Ip\":\"192.168.3.41\",\"charger1No\":\"GHLN10183CDJ11\",\"charger1Port\":8080,\"charger2Emg\":true,\"charger2Ip\":\"192.168.3.42\",\"charger2No\":\"GHLN10183CDJ21\",\"charger2Port\":8080,\"charger3Emg\":false,\"charger3Ip\":\"192.168.3.43\",\"charger3No\":\"GHLN10183CDJ13\",\"charger3Port\":8088,\"charger4Emg\":false,\"charger4Ip\":\"192.168.3.44\",\"charger4No\":\"GHLN10183CDJ41\",\"charger4Port\":8088,\"charger5Emg\":false,\"charger5Ip\":\"192.168.3.45\",\"charger5No\":\"0\",\"charger5Port\":8088,\"charger6Emg\":false,\"charger6Ip\":\"192.168.3.46\",\"charger6No\":\"0\",\"charger6Port\":8088,\"charger7Emg\":false,\"charger7Ip\":\"192.168.3.47\",\"charger7No\":\"0\",\"charger7Port\":8088,\"charger8Emg\":false,\"charger8Ip\":\"192.168.3.48\",\"charger8No\":\"0\",\"charger8Port\":8088,\"id\":1,\"params\":{},\"rfidIp\":\"192.168.0.3\",\"rfidPort\":2000,\"robotIp\":\"19.168.0.1\",\"robotNo\":\"Robbot_001\",\"scannerIp\":\"192.168.0.2\",\"scannerPort\":3000,\"systemIp\":\"127.0.0.1\",\"systemPort\":3000,\"vehicleCidr\":\"127.0.0.1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-04 18:10:30');
INSERT INTO `sys_oper_log` VALUES (13, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-04 18:14:25');
INSERT INTO `sys_oper_log` VALUES (14, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-04 18:14:38');
INSERT INTO `sys_oper_log` VALUES (15, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-04 18:14:53');
INSERT INTO `sys_oper_log` VALUES (16, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-04 18:15:18');
INSERT INTO `sys_oper_log` VALUES (17, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-04 18:16:19');
INSERT INTO `sys_oper_log` VALUES (18, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-04 18:17:14');
INSERT INTO `sys_oper_log` VALUES (19, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-04 18:19:00');
INSERT INTO `sys_oper_log` VALUES (20, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-04 18:19:11');
INSERT INTO `sys_oper_log` VALUES (21, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-04 18:21:49');
INSERT INTO `sys_oper_log` VALUES (22, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-04 18:27:29');
INSERT INTO `sys_oper_log` VALUES (23, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-04 18:57:04');
INSERT INTO `sys_oper_log` VALUES (24, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-04 18:59:07');
INSERT INTO `sys_oper_log` VALUES (25, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ41\",\"chargerId\":\"GHLN10183CDJ4\",\"emergency\":false}', '{\"msg\":\"发送充电指令超时\",\"code\":500}', 0, NULL, '2023-12-04 19:04:48');
INSERT INTO `sys_oper_log` VALUES (26, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ41\",\"chargerId\":\"GHLN10183CDJ4\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-04 19:04:54');
INSERT INTO `sys_oper_log` VALUES (27, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ41\",\"chargerId\":\"GHLN10183CDJ4\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-04 19:05:13');
INSERT INTO `sys_oper_log` VALUES (28, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ41\",\"chargerId\":\"GHLN10183CDJ4\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-04 19:07:34');
INSERT INTO `sys_oper_log` VALUES (29, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ41\",\"chargerId\":\"GHLN10183CDJ4\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-04 19:09:03');
INSERT INTO `sys_oper_log` VALUES (30, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ41\",\"chargerId\":\"GHLN10183CDJ4\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-05 08:20:06');
INSERT INTO `sys_oper_log` VALUES (31, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"ftjhgf\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"ftjhgf\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-05 09:21:35');
INSERT INTO `sys_oper_log` VALUES (32, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ41\",\"chargerId\":\"GHLN10183CDJ4\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-05 09:30:48');
INSERT INTO `sys_oper_log` VALUES (33, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"15214841\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"15214841\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-05 15:52:14');
INSERT INTO `sys_oper_log` VALUES (34, '开启应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.addCharging()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/addCharging', '127.0.0.1', '内网IP', '{\"carNo\":\"15214841\",\"chargerGunId\":\"GHLN10183CDJ23\",\"chargerId\":\"GHLN10183CDJ2\",\"params\":{}}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-05 15:52:22');
INSERT INTO `sys_oper_log` VALUES (35, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"454841\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"454841\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-05 15:53:40');
INSERT INTO `sys_oper_log` VALUES (36, '开启应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.addCharging()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/addCharging', '127.0.0.1', '内网IP', '{\"carNo\":\"454841\",\"chargerGunId\":\"GHLN10183CDJ23\",\"chargerId\":\"GHLN10183CDJ2\",\"params\":{}}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-05 15:53:47');
INSERT INTO `sys_oper_log` VALUES (37, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"15415\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"15415\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-05 15:58:29');
INSERT INTO `sys_oper_log` VALUES (38, '开启应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.addCharging()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/addCharging', '127.0.0.1', '内网IP', '{\"carNo\":\"15415\",\"chargerGunId\":\"GHLN10183CDJ24\",\"chargerId\":\"GHLN10183CDJ2\",\"params\":{}}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-05 15:58:36');
INSERT INTO `sys_oper_log` VALUES (39, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ24\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-05 15:59:34');
INSERT INTO `sys_oper_log` VALUES (40, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"571054\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"571054\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-05 16:00:48');
INSERT INTO `sys_oper_log` VALUES (41, '开启应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.addCharging()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/addCharging', '127.0.0.1', '内网IP', '{\"carNo\":\"571054\",\"chargerGunId\":\"GHLN10183CDJ23\",\"chargerId\":\"GHLN10183CDJ2\",\"params\":{}}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-05 16:00:53');
INSERT INTO `sys_oper_log` VALUES (42, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"10841\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"10841\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-06 14:09:08');
INSERT INTO `sys_oper_log` VALUES (43, '开启应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.addCharging()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/addCharging', '127.0.0.1', '内网IP', '{\"carNo\":\"10841\",\"chargerGunId\":\"GHLN10183CDJ23\",\"chargerId\":\"GHLN10183CDJ2\",\"params\":{}}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-06 14:09:15');
INSERT INTO `sys_oper_log` VALUES (44, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"05841\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"05841\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-06 14:10:41');
INSERT INTO `sys_oper_log` VALUES (45, '开启应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.addCharging()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/addCharging', '127.0.0.1', '内网IP', '{\"carNo\":\"05841\",\"chargerGunId\":\"GHLN10183CDJ23\",\"chargerId\":\"GHLN10183CDJ2\",\"params\":{}}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-06 14:10:46');
INSERT INTO `sys_oper_log` VALUES (46, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"251\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"251\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-06 14:11:21');
INSERT INTO `sys_oper_log` VALUES (47, '开启应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.addCharging()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/addCharging', '127.0.0.1', '内网IP', '{\"carNo\":\"251\",\"chargerGunId\":\"GHLN10183CDJ23\",\"chargerId\":\"GHLN10183CDJ2\",\"params\":{}}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-06 14:11:26');
INSERT INTO `sys_oper_log` VALUES (48, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"25252\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"25252\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-06 14:11:45');
INSERT INTO `sys_oper_log` VALUES (49, '开启应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.addCharging()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/addCharging', '127.0.0.1', '内网IP', '{\"carNo\":\"25252\",\"chargerGunId\":\"GHLN10183CDJ24\",\"chargerId\":\"GHLN10183CDJ2\",\"params\":{}}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-06 14:11:53');
INSERT INTO `sys_oper_log` VALUES (50, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"4814\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"4814\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-06 14:12:42');
INSERT INTO `sys_oper_log` VALUES (51, '开启应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.addCharging()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/addCharging', '127.0.0.1', '内网IP', '{\"carNo\":\"4814\",\"chargerGunId\":\"GHLN10183CDJ23\",\"chargerId\":\"GHLN10183CDJ2\",\"params\":{}}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-06 14:12:49');
INSERT INTO `sys_oper_log` VALUES (52, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ23\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-06 14:58:08');
INSERT INTO `sys_oper_log` VALUES (53, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"2562541\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"2562541\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-06 15:03:40');
INSERT INTO `sys_oper_log` VALUES (54, '开启应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.addCharging()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/addCharging', '127.0.0.1', '内网IP', '{\"carNo\":\"2562541\",\"chargerGunId\":\"GHLN10183CDJ23\",\"chargerId\":\"GHLN10183CDJ2\",\"params\":{}}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-06 15:03:45');
INSERT INTO `sys_oper_log` VALUES (55, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\".352\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\".352\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-06 15:04:03');
INSERT INTO `sys_oper_log` VALUES (56, '开启应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.addCharging()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/addCharging', '127.0.0.1', '内网IP', '{\"carNo\":\".352\",\"chargerGunId\":\"GHLN10183CDJ24\",\"chargerId\":\"GHLN10183CDJ2\",\"params\":{}}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-06 15:04:08');
INSERT INTO `sys_oper_log` VALUES (57, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"4515\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"4515\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-06 15:05:38');
INSERT INTO `sys_oper_log` VALUES (58, '开启应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.addCharging()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/addCharging', '127.0.0.1', '内网IP', '{\"carNo\":\"4515\",\"chargerGunId\":\"GHLN10183CDJ24\",\"chargerId\":\"GHLN10183CDJ2\",\"params\":{}}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-06 15:05:45');
INSERT INTO `sys_oper_log` VALUES (59, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"发送充电指令超时\",\"code\":500}', 0, NULL, '2023-12-06 16:09:25');
INSERT INTO `sys_oper_log` VALUES (60, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-06 16:09:31');
INSERT INTO `sys_oper_log` VALUES (61, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ41\",\"chargerId\":\"GHLN10183CDJ4\",\"emergency\":false}', '{\"msg\":\"发送充电指令超时\",\"code\":500}', 0, NULL, '2023-12-06 16:09:58');
INSERT INTO `sys_oper_log` VALUES (62, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ41\",\"chargerId\":\"GHLN10183CDJ4\",\"emergency\":false}', '{\"msg\":\"发送充电指令超时\",\"code\":500}', 0, NULL, '2023-12-06 16:10:03');
INSERT INTO `sys_oper_log` VALUES (63, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-06 16:11:01');
INSERT INTO `sys_oper_log` VALUES (64, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ41\",\"chargerId\":\"GHLN10183CDJ4\",\"emergency\":false}', '{\"msg\":\"该充电机未连接\",\"code\":500}', 0, NULL, '2023-12-06 16:11:20');
INSERT INTO `sys_oper_log` VALUES (65, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ41\",\"chargerId\":\"GHLN10183CDJ4\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-06 16:11:55');
INSERT INTO `sys_oper_log` VALUES (66, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"发送充电指令超时\",\"code\":500}', 0, NULL, '2023-12-06 16:57:44');
INSERT INTO `sys_oper_log` VALUES (67, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-06 16:57:48');
INSERT INTO `sys_oper_log` VALUES (68, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-06 16:58:03');
INSERT INTO `sys_oper_log` VALUES (69, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-06 16:58:23');
INSERT INTO `sys_oper_log` VALUES (70, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-06 16:58:51');
INSERT INTO `sys_oper_log` VALUES (71, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ41\",\"chargerId\":\"GHLN10183CDJ4\",\"emergency\":false}', '{\"msg\":\"发送充电指令超时\",\"code\":500}', 0, NULL, '2023-12-06 17:03:06');
INSERT INTO `sys_oper_log` VALUES (72, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ41\",\"chargerId\":\"GHLN10183CDJ4\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-06 17:03:10');
INSERT INTO `sys_oper_log` VALUES (73, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ41\",\"chargerId\":\"GHLN10183CDJ4\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-06 17:16:16');
INSERT INTO `sys_oper_log` VALUES (74, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"发送充电指令超时\",\"code\":500}', 0, NULL, '2023-12-06 17:17:27');
INSERT INTO `sys_oper_log` VALUES (75, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-06 17:17:29');
INSERT INTO `sys_oper_log` VALUES (76, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-06 17:17:38');
INSERT INTO `sys_oper_log` VALUES (77, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-06 17:17:39');
INSERT INTO `sys_oper_log` VALUES (78, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-06 17:30:00');
INSERT INTO `sys_oper_log` VALUES (79, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-06 17:30:16');
INSERT INTO `sys_oper_log` VALUES (80, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"28441\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"28441\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-06 17:30:54');
INSERT INTO `sys_oper_log` VALUES (81, '开启应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.addCharging()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/addCharging', '127.0.0.1', '内网IP', '{\"carNo\":\"28441\",\"chargerGunId\":\"GHLN10183CDJ24\",\"chargerId\":\"GHLN10183CDJ2\",\"params\":{}}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-06 17:30:59');
INSERT INTO `sys_oper_log` VALUES (82, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ24\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-07 07:45:08');
INSERT INTO `sys_oper_log` VALUES (83, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ24\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-07 07:45:27');
INSERT INTO `sys_oper_log` VALUES (84, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-07 07:48:57');
INSERT INTO `sys_oper_log` VALUES (85, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-07 08:52:39');
INSERT INTO `sys_oper_log` VALUES (86, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-07 09:17:01');
INSERT INTO `sys_oper_log` VALUES (87, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-07 09:17:20');
INSERT INTO `sys_oper_log` VALUES (88, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-07 11:23:30');
INSERT INTO `sys_oper_log` VALUES (89, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:0\",\"code\":200}', 0, NULL, '2023-12-07 11:24:17');
INSERT INTO `sys_oper_log` VALUES (90, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-07 11:26:23');
INSERT INTO `sys_oper_log` VALUES (91, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:0\",\"code\":200}', 0, NULL, '2023-12-07 11:26:35');
INSERT INTO `sys_oper_log` VALUES (92, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-07 11:33:37');
INSERT INTO `sys_oper_log` VALUES (93, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-07 11:33:45');
INSERT INTO `sys_oper_log` VALUES (94, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ41\",\"chargerId\":\"GHLN10183CDJ4\",\"emergency\":false}', '{\"msg\":\"发送充电指令超时\",\"code\":500}', 0, NULL, '2023-12-07 11:34:54');
INSERT INTO `sys_oper_log` VALUES (95, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ41\",\"chargerId\":\"GHLN10183CDJ4\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-07 11:34:59');
INSERT INTO `sys_oper_log` VALUES (96, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ41\",\"chargerId\":\"GHLN10183CDJ4\",\"emergency\":false}', '{\"msg\":\"resp status:0\",\"code\":200}', 0, NULL, '2023-12-07 11:35:00');
INSERT INTO `sys_oper_log` VALUES (97, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-07 12:47:05');
INSERT INTO `sys_oper_log` VALUES (98, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ41\",\"chargerId\":\"GHLN10183CDJ4\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-07 12:47:09');
INSERT INTO `sys_oper_log` VALUES (99, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"1452\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"1452\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-09 11:38:33');
INSERT INTO `sys_oper_log` VALUES (100, '开启应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.addCharging()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/addCharging', '127.0.0.1', '内网IP', '{\"carNo\":\"1452\",\"chargerGunId\":\"GHLN10183CDJ23\",\"chargerId\":\"GHLN10183CDJ2\",\"params\":{}}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-09 11:38:43');
INSERT INTO `sys_oper_log` VALUES (101, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"25\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"25\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-09 11:39:06');
INSERT INTO `sys_oper_log` VALUES (102, '开启应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.addCharging()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/addCharging', '127.0.0.1', '内网IP', '{\"carNo\":\"25\",\"chargerGunId\":\"GHLN10183CDJ24\",\"chargerId\":\"GHLN10183CDJ2\",\"params\":{}}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-09 11:39:14');
INSERT INTO `sys_oper_log` VALUES (103, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"285\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"285\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-09 11:45:17');
INSERT INTO `sys_oper_log` VALUES (104, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-10 11:46:04');
INSERT INTO `sys_oper_log` VALUES (105, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"52\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"52\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-10 14:05:52');
INSERT INTO `sys_oper_log` VALUES (106, '开启应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.addCharging()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/addCharging', '127.0.0.1', '内网IP', '{\"carNo\":\"52\",\"chargerGunId\":\"GHLN10183CDJ24\",\"chargerId\":\"GHLN10183CDJ2\",\"params\":{}}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-10 14:06:01');
INSERT INTO `sys_oper_log` VALUES (107, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ24\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-10 16:48:07');
INSERT INTO `sys_oper_log` VALUES (108, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-10 16:48:25');
INSERT INTO `sys_oper_log` VALUES (109, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-10 16:48:34');
INSERT INTO `sys_oper_log` VALUES (110, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-10 16:48:40');
INSERT INTO `sys_oper_log` VALUES (111, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-10 16:48:42');
INSERT INTO `sys_oper_log` VALUES (112, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ41\",\"chargerId\":\"GHLN10183CDJ4\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-10 16:48:46');
INSERT INTO `sys_oper_log` VALUES (113, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"2\"}', '{\"msg\":\"正在换电中，请在换电前设置取电仓位！\",\"code\":500}', 0, NULL, '2023-12-10 16:49:03');
INSERT INTO `sys_oper_log` VALUES (114, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-10 16:49:13');
INSERT INTO `sys_oper_log` VALUES (115, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-10 16:50:07');
INSERT INTO `sys_oper_log` VALUES (116, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-10 17:50:23');
INSERT INTO `sys_oper_log` VALUES (117, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-10 17:59:59');
INSERT INTO `sys_oper_log` VALUES (118, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"55\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"55\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-12 09:24:34');
INSERT INTO `sys_oper_log` VALUES (119, '开启应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.addCharging()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/addCharging', '127.0.0.1', '内网IP', '{\"carNo\":\"55\",\"chargerGunId\":\"GHLN10183CDJ24\",\"chargerId\":\"GHLN10183CDJ2\",\"params\":{}}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-12 09:24:44');
INSERT INTO `sys_oper_log` VALUES (120, '结束换电', 2, 'com.pwt.web.controller.PwtOperationController.endChange()', 'POST', 1, 'admin', NULL, '/web/operation/endChange', '127.0.0.1', '内网IP', '', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-12 15:24:20');
INSERT INTO `sys_oper_log` VALUES (121, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"255\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"255\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-13 10:33:24');
INSERT INTO `sys_oper_log` VALUES (122, '开启应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.addCharging()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/addCharging', '127.0.0.1', '内网IP', '{\"carNo\":\"255\",\"chargerGunId\":\"GHLN10183CDJ24\",\"chargerId\":\"GHLN10183CDJ2\",\"params\":{}}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-13 10:33:31');
INSERT INTO `sys_oper_log` VALUES (123, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-13 13:31:39');
INSERT INTO `sys_oper_log` VALUES (124, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-13 13:31:41');
INSERT INTO `sys_oper_log` VALUES (125, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-13 13:31:43');
INSERT INTO `sys_oper_log` VALUES (126, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-13 13:32:28');
INSERT INTO `sys_oper_log` VALUES (127, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-13 13:32:33');
INSERT INTO `sys_oper_log` VALUES (128, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-13 13:32:34');
INSERT INTO `sys_oper_log` VALUES (129, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-13 13:45:26');
INSERT INTO `sys_oper_log` VALUES (130, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-13 14:56:00');
INSERT INTO `sys_oper_log` VALUES (131, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-13 14:56:03');
INSERT INTO `sys_oper_log` VALUES (132, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-13 14:56:10');
INSERT INTO `sys_oper_log` VALUES (133, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-13 14:56:12');
INSERT INTO `sys_oper_log` VALUES (134, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-13 14:56:50');
INSERT INTO `sys_oper_log` VALUES (135, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-13 14:56:52');
INSERT INTO `sys_oper_log` VALUES (136, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"发送充电指令超时\",\"code\":500}', 0, NULL, '2023-12-13 14:56:52');
INSERT INTO `sys_oper_log` VALUES (137, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-13 14:56:54');
INSERT INTO `sys_oper_log` VALUES (138, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"正在换电中，请在换电前设置取电仓位！\",\"code\":500}', 0, NULL, '2023-12-13 17:16:29');
INSERT INTO `sys_oper_log` VALUES (139, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"5\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"5\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-14 10:06:10');
INSERT INTO `sys_oper_log` VALUES (140, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ41\",\"chargerId\":\"GHLN10183CDJ4\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-14 12:36:36');
INSERT INTO `sys_oper_log` VALUES (141, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-14 13:23:49');
INSERT INTO `sys_oper_log` VALUES (142, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-14 13:24:07');
INSERT INTO `sys_oper_log` VALUES (143, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"发送充电指令超时\",\"code\":500}', 0, NULL, '2023-12-14 13:24:09');
INSERT INTO `sys_oper_log` VALUES (144, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-14 13:24:12');
INSERT INTO `sys_oper_log` VALUES (145, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-14 13:24:22');
INSERT INTO `sys_oper_log` VALUES (146, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-14 13:25:35');
INSERT INTO `sys_oper_log` VALUES (147, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-14 13:26:18');
INSERT INTO `sys_oper_log` VALUES (148, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-14 13:44:42');
INSERT INTO `sys_oper_log` VALUES (149, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-14 13:45:45');
INSERT INTO `sys_oper_log` VALUES (150, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ41\",\"chargerId\":\"GHLN10183CDJ4\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-14 13:48:18');
INSERT INTO `sys_oper_log` VALUES (151, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"6\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"6\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-14 15:56:42');
INSERT INTO `sys_oper_log` VALUES (152, '开启应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.addCharging()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/addCharging', '127.0.0.1', '内网IP', '{\"carNo\":\"6\",\"chargerGunId\":\"GHLN10183CDJ24\",\"chargerId\":\"GHLN10183CDJ2\",\"params\":{}}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-14 15:56:52');
INSERT INTO `sys_oper_log` VALUES (153, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-15 12:25:12');
INSERT INTO `sys_oper_log` VALUES (154, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.changeAutoChangeWarehouse()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig/changeAutoChangeWarehouse/1', '127.0.0.1', '内网IP', '1 true', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-15 14:07:26');
INSERT INTO `sys_oper_log` VALUES (155, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.changeAutoChangeWarehouse()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig/changeAutoChangeWarehouse/1', '127.0.0.1', '内网IP', '1 false', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-15 14:07:26');
INSERT INTO `sys_oper_log` VALUES (156, '告警记录', 3, 'com.pwt.web.controller.PwtAlarmRecordController.remove()', 'DELETE', 1, 'admin', NULL, '/web/alarmRecord/242,241,244,243,237,240,238,239,234,233', '127.0.0.1', '内网IP', '{recordIds=242,241,244,243,237,240,238,239,234,233}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-15 14:07:47');
INSERT INTO `sys_oper_log` VALUES (157, '告警记录', 3, 'com.pwt.web.controller.PwtAlarmRecordController.remove()', 'DELETE', 1, 'admin', NULL, '/web/alarmRecord/242,241,244,243,237,240,238,239,234,233', '127.0.0.1', '内网IP', '{recordIds=242,241,244,243,237,240,238,239,234,233}', '{\"msg\":\"操作失败\",\"code\":500}', 0, NULL, '2023-12-15 14:07:50');
INSERT INTO `sys_oper_log` VALUES (158, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.changeAutoChangeWarehouse()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig/changeAutoChangeWarehouse/1', '127.0.0.1', '内网IP', '1 true', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-15 14:08:28');
INSERT INTO `sys_oper_log` VALUES (159, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.changeAutoChangeWarehouse()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig/changeAutoChangeWarehouse/1', '127.0.0.1', '内网IP', '1 false', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-15 14:08:28');
INSERT INTO `sys_oper_log` VALUES (160, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.changeAutoChangeWarehouse()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig/changeAutoChangeWarehouse/1', '127.0.0.1', '内网IP', '1 true', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-15 14:08:30');
INSERT INTO `sys_oper_log` VALUES (161, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.changeAutoChangeWarehouse()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig/changeAutoChangeWarehouse/1', '127.0.0.1', '内网IP', '1 false', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-15 14:08:31');
INSERT INTO `sys_oper_log` VALUES (162, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.changeAutoChangeWarehouse()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig/changeAutoChangeWarehouse/1', '127.0.0.1', '内网IP', '1 true', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-15 14:08:38');
INSERT INTO `sys_oper_log` VALUES (163, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.changeAutoChangeWarehouse()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig/changeAutoChangeWarehouse/1', '127.0.0.1', '内网IP', '1 false', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-15 14:08:39');
INSERT INTO `sys_oper_log` VALUES (164, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.changeAutoChangeWarehouse()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig/changeAutoChangeWarehouse/1', '127.0.0.1', '内网IP', '1 true', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-15 14:08:41');
INSERT INTO `sys_oper_log` VALUES (165, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.changeAutoChangeWarehouse()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig/changeAutoChangeWarehouse/1', '127.0.0.1', '内网IP', '1 false', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-15 14:08:42');
INSERT INTO `sys_oper_log` VALUES (166, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.changeAutoChangeWarehouse()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig/changeAutoChangeWarehouse/1', '127.0.0.1', '内网IP', '1 true', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-15 14:08:43');
INSERT INTO `sys_oper_log` VALUES (167, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.changeAutoChangeWarehouse()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig/changeAutoChangeWarehouse/1', '127.0.0.1', '内网IP', '1 false', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-15 14:08:43');
INSERT INTO `sys_oper_log` VALUES (168, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.changeAutoChangeWarehouse()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig/changeAutoChangeWarehouse/1', '127.0.0.1', '内网IP', '1 true', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-15 14:08:44');
INSERT INTO `sys_oper_log` VALUES (169, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.changeAutoChangeWarehouse()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig/changeAutoChangeWarehouse/1', '127.0.0.1', '内网IP', '1 false', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-15 14:08:45');
INSERT INTO `sys_oper_log` VALUES (170, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.changeAutoChangeWarehouse()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig/changeAutoChangeWarehouse/1', '127.0.0.1', '内网IP', '1 true', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-15 14:08:46');
INSERT INTO `sys_oper_log` VALUES (171, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-15 15:42:11');
INSERT INTO `sys_oper_log` VALUES (172, '车辆管理', 1, 'com.pwt.web.controller.PwtVehicleController.add()', 'POST', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-15 17:24:24.742\",\"params\":{},\"rfid\":\"E2806995000050037517F27E\",\"vehicleId\":1,\"vehicleName\":\"56680D\",\"vehicleNo\":\"鲁B56680D\",\"vin\":\"LZ5NB6D37PB005283\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-15 17:24:24');
INSERT INTO `sys_oper_log` VALUES (173, '车辆管理', 1, 'com.pwt.web.controller.PwtVehicleController.add()', 'POST', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"params\":{},\"rfid\":\"E2806995000050037517F27E\",\"vehicleName\":\"56680D\",\"vehicleNo\":\"鲁B56680D\",\"vin\":\"LZ5NB6D37PB005283\"}', NULL, 1, '车牌号已存在,不允许操作', '2023-12-15 17:24:24');
INSERT INTO `sys_oper_log` VALUES (174, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-15 17:44:54');
INSERT INTO `sys_oper_log` VALUES (175, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-15 17:45:21');
INSERT INTO `sys_oper_log` VALUES (176, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-15 17:45:26');
INSERT INTO `sys_oper_log` VALUES (177, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ41\",\"chargerId\":\"GHLN10183CDJ4\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-15 17:56:25');
INSERT INTO `sys_oper_log` VALUES (178, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"00\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"00\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-16 09:05:09');
INSERT INTO `sys_oper_log` VALUES (179, '开启应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.addCharging()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/addCharging', '127.0.0.1', '内网IP', '{\"carNo\":\"00\",\"chargerGunId\":\"GHLN10183CDJ24\",\"chargerId\":\"GHLN10183CDJ2\",\"params\":{}}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-16 09:05:32');
INSERT INTO `sys_oper_log` VALUES (180, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"11\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"11\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-16 09:06:58');
INSERT INTO `sys_oper_log` VALUES (181, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"44\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"44\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-16 09:10:23');
INSERT INTO `sys_oper_log` VALUES (182, '开启应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.addCharging()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/addCharging', '127.0.0.1', '内网IP', '{\"carNo\":\"44\",\"chargerGunId\":\"GHLN10183CDJ24\",\"chargerId\":\"GHLN10183CDJ2\",\"params\":{}}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-16 09:10:52');
INSERT INTO `sys_oper_log` VALUES (183, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"22\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"22\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-16 09:12:33');
INSERT INTO `sys_oper_log` VALUES (184, '开启应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.addCharging()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/addCharging', '127.0.0.1', '内网IP', '{\"carNo\":\"22\",\"chargerGunId\":\"GHLN10183CDJ23\",\"chargerId\":\"GHLN10183CDJ2\",\"params\":{}}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-16 09:12:40');
INSERT INTO `sys_oper_log` VALUES (185, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"充电机目前正在应急充电，无法启用充电机！\",\"code\":500}', 0, NULL, '2023-12-16 10:11:03');
INSERT INTO `sys_oper_log` VALUES (186, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ41\",\"chargerId\":\"GHLN10183CDJ4\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-16 10:11:15');
INSERT INTO `sys_oper_log` VALUES (187, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"充电机目前正在应急充电，无法启用充电机！\",\"code\":500}', 0, NULL, '2023-12-16 10:12:27');
INSERT INTO `sys_oper_log` VALUES (188, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-16 10:57:22');
INSERT INTO `sys_oper_log` VALUES (189, '车辆管理', 1, 'com.pwt.web.controller.PwtVehicleController.add()', 'POST', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-16 11:04:26.555\",\"params\":{},\"rfid\":\"E2806995000050037517A0A1\",\"vehicleId\":2,\"vehicleName\":\"69277\",\"vehicleNo\":\"鲁B69277D\",\"vin\":\"LZ5NB6D39PB005298\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-16 11:04:26');
INSERT INTO `sys_oper_log` VALUES (190, '车辆管理', 2, 'com.pwt.web.controller.PwtVehicleController.edit()', 'PUT', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-16 11:04:27\",\"params\":{},\"rfid\":\"E2806995000050037517A0A1\",\"vehicleId\":2,\"vehicleName\":\"69277D\",\"vehicleNo\":\"鲁B69277D\",\"vin\":\"LZ5NB6D39PB005298\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-16 11:05:31');
INSERT INTO `sys_oper_log` VALUES (191, '车辆管理', 1, 'com.pwt.web.controller.PwtVehicleController.add()', 'POST', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-16 11:58:42.402\",\"params\":{},\"rfid\":\"E2806995000040037517919B\",\"vehicleId\":3,\"vehicleName\":\"05085D\",\"vehicleNo\":\"鲁B05085D\",\"vin\":\"LZ5NB6D34PB005290\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-16 11:58:42');
INSERT INTO `sys_oper_log` VALUES (192, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-16 12:16:02');
INSERT INTO `sys_oper_log` VALUES (193, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"4\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"4\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-16 12:29:45');
INSERT INTO `sys_oper_log` VALUES (194, '开启应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.addCharging()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/addCharging', '127.0.0.1', '内网IP', '{\"carNo\":\"4\",\"chargerGunId\":\"GHLN10183CDJ23\",\"chargerId\":\"GHLN10183CDJ2\",\"params\":{}}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-16 12:29:55');
INSERT INTO `sys_oper_log` VALUES (195, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-16 15:40:26');
INSERT INTO `sys_oper_log` VALUES (196, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-16 15:40:33');
INSERT INTO `sys_oper_log` VALUES (197, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-16 15:40:37');
INSERT INTO `sys_oper_log` VALUES (198, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ41\",\"chargerId\":\"GHLN10183CDJ4\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-16 15:41:23');
INSERT INTO `sys_oper_log` VALUES (199, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-16 16:04:53');
INSERT INTO `sys_oper_log` VALUES (200, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-16 18:10:54');
INSERT INTO `sys_oper_log` VALUES (201, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-16 18:17:58');
INSERT INTO `sys_oper_log` VALUES (202, '车辆管理', 1, 'com.pwt.web.controller.PwtVehicleController.add()', 'POST', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-16 18:26:17.287\",\"params\":{},\"rfid\":\"E2806995000040037517E943\",\"vehicleId\":4,\"vehicleName\":\"88991D\",\"vehicleNo\":\"鲁B88991D\",\"vin\":\"LZ5NB6D3XPB005262\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-16 18:26:17');
INSERT INTO `sys_oper_log` VALUES (203, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-16 19:38:04');
INSERT INTO `sys_oper_log` VALUES (204, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:0\",\"code\":200}', 0, NULL, '2023-12-16 19:38:08');
INSERT INTO `sys_oper_log` VALUES (205, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"2\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-16 19:45:25');
INSERT INTO `sys_oper_log` VALUES (206, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ41\",\"chargerId\":\"GHLN10183CDJ4\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-16 19:48:00');
INSERT INTO `sys_oper_log` VALUES (207, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-16 20:04:05');
INSERT INTO `sys_oper_log` VALUES (208, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:0\",\"code\":200}', 0, NULL, '2023-12-16 20:04:07');
INSERT INTO `sys_oper_log` VALUES (209, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-16 20:05:06');
INSERT INTO `sys_oper_log` VALUES (210, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-16 20:26:36');
INSERT INTO `sys_oper_log` VALUES (211, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-16 20:26:43');
INSERT INTO `sys_oper_log` VALUES (212, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-16 20:27:56');
INSERT INTO `sys_oper_log` VALUES (213, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-16 20:28:05');
INSERT INTO `sys_oper_log` VALUES (214, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"发送充电指令超时\",\"code\":500}', 0, NULL, '2023-12-16 20:28:07');
INSERT INTO `sys_oper_log` VALUES (215, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-16 21:37:13');
INSERT INTO `sys_oper_log` VALUES (216, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-16 21:37:18');
INSERT INTO `sys_oper_log` VALUES (217, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-16 21:37:20');
INSERT INTO `sys_oper_log` VALUES (218, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-16 21:37:34');
INSERT INTO `sys_oper_log` VALUES (219, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-16 21:37:35');
INSERT INTO `sys_oper_log` VALUES (220, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-16 22:03:48');
INSERT INTO `sys_oper_log` VALUES (221, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"发送充电指令超时\",\"code\":500}', 0, NULL, '2023-12-16 22:03:50');
INSERT INTO `sys_oper_log` VALUES (222, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-16 22:03:59');
INSERT INTO `sys_oper_log` VALUES (223, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-16 22:04:11');
INSERT INTO `sys_oper_log` VALUES (224, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-16 22:04:53');
INSERT INTO `sys_oper_log` VALUES (225, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-16 22:05:01');
INSERT INTO `sys_oper_log` VALUES (226, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-16 22:05:12');
INSERT INTO `sys_oper_log` VALUES (227, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-16 22:05:48');
INSERT INTO `sys_oper_log` VALUES (228, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-16 22:07:01');
INSERT INTO `sys_oper_log` VALUES (229, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-16 22:11:05');
INSERT INTO `sys_oper_log` VALUES (230, '车辆管理', 1, 'com.pwt.web.controller.PwtVehicleController.add()', 'POST', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-17 08:34:12.606\",\"params\":{},\"rfid\":\"E2806995000050037517F281\",\"vehicleId\":5,\"vehicleName\":\"05297D\",\"vehicleNo\":\"鲁B05297D\",\"vin\":\"LZ5NB6D36PB005274\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-17 08:34:12');
INSERT INTO `sys_oper_log` VALUES (231, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-17 08:54:06');
INSERT INTO `sys_oper_log` VALUES (232, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"1\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"1\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-17 08:56:42');
INSERT INTO `sys_oper_log` VALUES (233, '开启应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.addCharging()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/addCharging', '127.0.0.1', '内网IP', '{\"carNo\":\"1\",\"chargerGunId\":\"GHLN10183CDJ23\",\"chargerId\":\"GHLN10183CDJ2\",\"params\":{}}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-17 08:56:49');
INSERT INTO `sys_oper_log` VALUES (234, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ23\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-17 10:09:06');
INSERT INTO `sys_oper_log` VALUES (235, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"2\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-17 11:56:34');
INSERT INTO `sys_oper_log` VALUES (236, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"2\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-17 11:56:40');
INSERT INTO `sys_oper_log` VALUES (237, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-17 12:02:31');
INSERT INTO `sys_oper_log` VALUES (238, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-17 12:02:36');
INSERT INTO `sys_oper_log` VALUES (239, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-17 12:03:36');
INSERT INTO `sys_oper_log` VALUES (240, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-17 12:03:40');
INSERT INTO `sys_oper_log` VALUES (241, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-17 12:05:15');
INSERT INTO `sys_oper_log` VALUES (242, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-17 12:05:18');
INSERT INTO `sys_oper_log` VALUES (243, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-17 12:05:18');
INSERT INTO `sys_oper_log` VALUES (244, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-17 12:15:21');
INSERT INTO `sys_oper_log` VALUES (245, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-17 12:15:26');
INSERT INTO `sys_oper_log` VALUES (246, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"4\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-17 12:20:10');
INSERT INTO `sys_oper_log` VALUES (247, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"4\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-17 12:20:12');
INSERT INTO `sys_oper_log` VALUES (248, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"4\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-17 12:20:15');
INSERT INTO `sys_oper_log` VALUES (249, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-17 12:23:25');
INSERT INTO `sys_oper_log` VALUES (250, '换仓', 2, 'com.pwt.web.controller.PwtOperationController.moveBattery()', 'POST', 1, 'admin', NULL, '/web/operation/moveBattery', '127.0.0.1', '内网IP', '{\"source\":3,\"target\":4}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-17 12:30:55');
INSERT INTO `sys_oper_log` VALUES (251, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.edit()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig', '127.0.0.1', '内网IP', '{\"agreementType\":\"A\",\"charger1Emg\":false,\"charger1Ip\":\"192.168.3.41\",\"charger1No\":\"GHLN10183CDJ13\",\"charger1Port\":8080,\"charger2Emg\":true,\"charger2Ip\":\"192.168.3.42\",\"charger2No\":\"GHLN10183CDJ21\",\"charger2Port\":8080,\"charger3Emg\":false,\"charger3Ip\":\"192.168.3.43\",\"charger3No\":\"GHLN10183CDJ11\",\"charger3Port\":8088,\"charger4Emg\":false,\"charger4Ip\":\"192.168.3.44\",\"charger4No\":\"GHLN10183CDJ41\",\"charger4Port\":8088,\"charger5Emg\":false,\"charger5Ip\":\"192.168.3.45\",\"charger5No\":\"0\",\"charger5Port\":8088,\"charger6Emg\":false,\"charger6Ip\":\"192.168.3.46\",\"charger6No\":\"0\",\"charger6Port\":8088,\"charger7Emg\":false,\"charger7Ip\":\"192.168.3.47\",\"charger7No\":\"0\",\"charger7Port\":8088,\"charger8Emg\":false,\"charger8Ip\":\"192.168.3.48\",\"charger8No\":\"0\",\"charger8Port\":8088,\"id\":1,\"params\":{},\"rfidIp\":\"192.168.0.3\",\"rfidPort\":2000,\"robotIp\":\"19.168.0.1\",\"robotNo\":\"Robbot_001\",\"scannerIp\":\"192.168.0.2\",\"scannerPort\":3000,\"systemIp\":\"127.0.0.1\",\"systemPort\":3000,\"vehicleCidr\":\"127.0.0.1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-17 12:32:26');
INSERT INTO `sys_oper_log` VALUES (252, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-17 12:33:43');
INSERT INTO `sys_oper_log` VALUES (253, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ41\",\"chargerId\":\"GHLN10183CDJ4\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-17 12:33:48');
INSERT INTO `sys_oper_log` VALUES (254, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"12\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"12\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-17 14:39:29');
INSERT INTO `sys_oper_log` VALUES (255, '开启应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.addCharging()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/addCharging', '127.0.0.1', '内网IP', '{\"carNo\":\"12\",\"chargerGunId\":\"GHLN10183CDJ23\",\"chargerId\":\"GHLN10183CDJ2\",\"params\":{}}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-17 14:39:37');
INSERT INTO `sys_oper_log` VALUES (256, '复位', 2, 'com.pwt.web.controller.PwtOperationController.reset()', 'POST', 1, 'admin', NULL, '/web/operation/reset', '127.0.0.1', '内网IP', '', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-17 15:00:39');
INSERT INTO `sys_oper_log` VALUES (257, '复位', 2, 'com.pwt.web.controller.PwtOperationController.reset()', 'POST', 1, 'admin', NULL, '/web/operation/reset', '127.0.0.1', '内网IP', '', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-17 15:00:40');
INSERT INTO `sys_oper_log` VALUES (258, '换仓', 2, 'com.pwt.web.controller.PwtOperationController.moveBattery()', 'POST', 1, 'admin', NULL, '/web/operation/moveBattery', '127.0.0.1', '内网IP', '{\"source\":1,\"target\":2}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-17 15:00:46');
INSERT INTO `sys_oper_log` VALUES (259, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ23\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-17 15:53:58');
INSERT INTO `sys_oper_log` VALUES (260, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-17 16:01:52');
INSERT INTO `sys_oper_log` VALUES (261, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"4\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-17 16:02:03');
INSERT INTO `sys_oper_log` VALUES (262, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"4\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-17 16:02:08');
INSERT INTO `sys_oper_log` VALUES (263, '换仓', 2, 'com.pwt.web.controller.PwtOperationController.moveBattery()', 'POST', 1, 'admin', NULL, '/web/operation/moveBattery', '127.0.0.1', '内网IP', '{\"source\":2,\"target\":3}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-17 16:45:30');
INSERT INTO `sys_oper_log` VALUES (264, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-17 16:48:40');
INSERT INTO `sys_oper_log` VALUES (265, '换仓', 2, 'com.pwt.web.controller.PwtOperationController.moveBattery()', 'POST', 1, 'admin', NULL, '/web/operation/moveBattery', '127.0.0.1', '内网IP', '{\"source\":2,\"target\":3}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-17 16:48:58');
INSERT INTO `sys_oper_log` VALUES (266, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-17 16:53:11');
INSERT INTO `sys_oper_log` VALUES (267, '换仓', 2, 'com.pwt.web.controller.PwtOperationController.moveBattery()', 'POST', 1, 'admin', NULL, '/web/operation/moveBattery', '127.0.0.1', '内网IP', '{\"source\":2,\"target\":1}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-17 17:50:50');
INSERT INTO `sys_oper_log` VALUES (268, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-17 22:49:08');
INSERT INTO `sys_oper_log` VALUES (269, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"011212\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"011212\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-17 23:18:31');
INSERT INTO `sys_oper_log` VALUES (270, '开启应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.addCharging()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/addCharging', '127.0.0.1', '内网IP', '{\"carNo\":\"011212\",\"chargerGunId\":\"GHLN10183CDJ23\",\"chargerId\":\"GHLN10183CDJ2\",\"params\":{}}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-18 03:30:37');
INSERT INTO `sys_oper_log` VALUES (271, '换仓', 2, 'com.pwt.web.controller.PwtOperationController.moveBattery()', 'POST', 1, 'admin', NULL, '/web/operation/moveBattery', '127.0.0.1', '内网IP', '{\"source\":2,\"target\":3}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-18 08:01:39');
INSERT INTO `sys_oper_log` VALUES (272, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"该充电枪正在充电或电池已充满\",\"code\":500}', 0, NULL, '2023-12-18 08:04:54');
INSERT INTO `sys_oper_log` VALUES (273, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"2\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"2\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-18 08:12:52');
INSERT INTO `sys_oper_log` VALUES (274, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-18 08:21:53');
INSERT INTO `sys_oper_log` VALUES (275, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-18 09:15:12');
INSERT INTO `sys_oper_log` VALUES (276, '换仓', 2, 'com.pwt.web.controller.PwtOperationController.moveBattery()', 'POST', 1, 'admin', NULL, '/web/operation/moveBattery', '127.0.0.1', '内网IP', '{\"source\":3,\"target\":2}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-18 09:15:32');
INSERT INTO `sys_oper_log` VALUES (277, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-18 09:19:31');
INSERT INTO `sys_oper_log` VALUES (278, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-18 09:20:19');
INSERT INTO `sys_oper_log` VALUES (279, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-18 09:21:03');
INSERT INTO `sys_oper_log` VALUES (280, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-18 09:22:15');
INSERT INTO `sys_oper_log` VALUES (281, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-18 09:22:26');
INSERT INTO `sys_oper_log` VALUES (282, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-18 09:25:33');
INSERT INTO `sys_oper_log` VALUES (283, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.edit()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig', '127.0.0.1', '内网IP', '{\"agreementType\":\"A\",\"charger1Emg\":false,\"charger1Ip\":\"192.168.3.41\",\"charger1No\":\"GHLN10183CDJ13\",\"charger1Port\":8080,\"charger2Emg\":false,\"charger2Ip\":\"192.168.3.42\",\"charger2No\":\"GHLN10183CDJ21\",\"charger2Port\":8080,\"charger3Emg\":false,\"charger3Ip\":\"192.168.3.43\",\"charger3No\":\"GHLN10183CDJ11\",\"charger3Port\":8088,\"charger4Emg\":false,\"charger4Ip\":\"192.168.3.44\",\"charger4No\":\"GHLN10183CDJ41\",\"charger4Port\":8088,\"charger5Emg\":false,\"charger5Ip\":\"192.168.3.45\",\"charger5No\":\"0\",\"charger5Port\":8088,\"charger6Emg\":false,\"charger6Ip\":\"192.168.3.46\",\"charger6No\":\"0\",\"charger6Port\":8088,\"charger7Emg\":false,\"charger7Ip\":\"192.168.3.47\",\"charger7No\":\"0\",\"charger7Port\":8088,\"charger8Emg\":false,\"charger8Ip\":\"192.168.3.48\",\"charger8No\":\"0\",\"charger8Port\":8088,\"id\":1,\"params\":{},\"rfidIp\":\"192.168.0.3\",\"rfidPort\":2000,\"robotIp\":\"19.168.0.1\",\"robotNo\":\"Robbot_001\",\"scannerIp\":\"192.168.0.2\",\"scannerPort\":3000,\"systemIp\":\"127.0.0.1\",\"systemPort\":3000,\"vehicleCidr\":\"127.0.0.1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-18 09:26:11');
INSERT INTO `sys_oper_log` VALUES (284, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-18 09:26:49');
INSERT INTO `sys_oper_log` VALUES (285, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.edit()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig', '127.0.0.1', '内网IP', '{\"agreementType\":\"A\",\"charger1Emg\":false,\"charger1Ip\":\"192.168.3.41\",\"charger1No\":\"GHLN10183CDJ13\",\"charger1Port\":8080,\"charger2Emg\":true,\"charger2Ip\":\"192.168.3.42\",\"charger2No\":\"GHLN10183CDJ21\",\"charger2Port\":8080,\"charger3Emg\":false,\"charger3Ip\":\"192.168.3.43\",\"charger3No\":\"GHLN10183CDJ11\",\"charger3Port\":8088,\"charger4Emg\":false,\"charger4Ip\":\"192.168.3.44\",\"charger4No\":\"GHLN10183CDJ41\",\"charger4Port\":8088,\"charger5Emg\":false,\"charger5Ip\":\"192.168.3.45\",\"charger5No\":\"0\",\"charger5Port\":8088,\"charger6Emg\":false,\"charger6Ip\":\"192.168.3.46\",\"charger6No\":\"0\",\"charger6Port\":8088,\"charger7Emg\":false,\"charger7Ip\":\"192.168.3.47\",\"charger7No\":\"0\",\"charger7Port\":8088,\"charger8Emg\":false,\"charger8Ip\":\"192.168.3.48\",\"charger8No\":\"0\",\"charger8Port\":8088,\"id\":1,\"params\":{},\"rfidIp\":\"192.168.0.3\",\"rfidPort\":2000,\"robotIp\":\"19.168.0.1\",\"robotNo\":\"Robbot_001\",\"scannerIp\":\"192.168.0.2\",\"scannerPort\":3000,\"systemIp\":\"127.0.0.1\",\"systemPort\":3000,\"vehicleCidr\":\"127.0.0.1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-18 09:27:21');
INSERT INTO `sys_oper_log` VALUES (286, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-18 09:32:54');
INSERT INTO `sys_oper_log` VALUES (287, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"2\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-18 12:17:53');
INSERT INTO `sys_oper_log` VALUES (288, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"2\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-18 12:18:11');
INSERT INTO `sys_oper_log` VALUES (289, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"2\"}', '{\"msg\":\"正在换电中，请在换电前设置取电仓位！\",\"code\":500}', 0, NULL, '2023-12-18 12:19:11');
INSERT INTO `sys_oper_log` VALUES (290, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"2\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-18 12:19:32');
INSERT INTO `sys_oper_log` VALUES (291, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"2\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-18 12:19:34');
INSERT INTO `sys_oper_log` VALUES (292, '继续', 2, 'com.pwt.web.controller.PwtOperationController.continue1()', 'POST', 1, 'admin', NULL, '/web/operation/continue', '127.0.0.1', '内网IP', '', '{\"msg\":\"发送指令失败！换电机器人当前禁止远程操作\",\"code\":500}', 0, NULL, '2023-12-19 05:38:16');
INSERT INTO `sys_oper_log` VALUES (293, '继续', 2, 'com.pwt.web.controller.PwtOperationController.continue1()', 'POST', 1, 'admin', NULL, '/web/operation/continue', '127.0.0.1', '内网IP', '', '{\"msg\":\"发送指令失败！换电机器人当前禁止远程操作\",\"code\":500}', 0, NULL, '2023-12-19 05:38:19');
INSERT INTO `sys_oper_log` VALUES (294, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-19 06:26:22');
INSERT INTO `sys_oper_log` VALUES (295, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"发送充电指令超时\",\"code\":500}', 0, NULL, '2023-12-19 06:26:24');
INSERT INTO `sys_oper_log` VALUES (296, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"41\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"41\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-19 08:23:42');
INSERT INTO `sys_oper_log` VALUES (297, '开启应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.addCharging()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/addCharging', '127.0.0.1', '内网IP', '{\"carNo\":\"41\",\"chargerGunId\":\"GHLN10183CDJ23\",\"chargerId\":\"GHLN10183CDJ2\",\"params\":{}}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-19 08:23:48');
INSERT INTO `sys_oper_log` VALUES (298, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"13\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"13\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-19 08:25:25');
INSERT INTO `sys_oper_log` VALUES (299, '开启应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.addCharging()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/addCharging', '127.0.0.1', '内网IP', '{\"carNo\":\"13\",\"chargerGunId\":\"GHLN10183CDJ23\",\"chargerId\":\"GHLN10183CDJ2\",\"params\":{}}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-19 08:25:41');
INSERT INTO `sys_oper_log` VALUES (300, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"52\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"操作成功\",\"code\":200,\"data\":{\"carNo\":\"52\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}}', 0, NULL, '2023-12-19 09:53:14');
INSERT INTO `sys_oper_log` VALUES (301, '开启应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.addCharging()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/addCharging', '127.0.0.1', '内网IP', '{\"carNo\":\"52\",\"chargerGunId\":\"GHLN10183CDJ23\",\"chargerId\":\"GHLN10183CDJ2\",\"params\":{}}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-19 09:53:22');
INSERT INTO `sys_oper_log` VALUES (302, '换仓', 2, 'com.pwt.web.controller.PwtOperationController.moveBattery()', 'POST', 1, 'admin', NULL, '/web/operation/moveBattery', '127.0.0.1', '内网IP', '{\"source\":4,\"target\":1}', '{\"msg\":\"发送指令失败！换电机器人当前禁止远程操作\",\"code\":500}', 0, NULL, '2023-12-19 10:57:10');
INSERT INTO `sys_oper_log` VALUES (303, '换仓', 2, 'com.pwt.web.controller.PwtOperationController.moveBattery()', 'POST', 1, 'admin', NULL, '/web/operation/moveBattery', '127.0.0.1', '内网IP', '{\"source\":4,\"target\":1}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-19 10:58:01');
INSERT INTO `sys_oper_log` VALUES (304, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-19 11:03:00');
INSERT INTO `sys_oper_log` VALUES (305, '车辆管理', 1, 'com.pwt.web.controller.PwtVehicleController.add()', 'POST', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-19 11:17:29.052\",\"params\":{},\"rfid\":\"E280699500005001BE2758C6\",\"vehicleId\":6,\"vehicleName\":\"11\",\"vehicleNo\":\"11\",\"vin\":\"LZ5NB6D34PB006066\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-19 11:17:29');
INSERT INTO `sys_oper_log` VALUES (306, '结束换电', 2, 'com.pwt.web.controller.PwtOperationController.endChange()', 'POST', 1, 'admin', NULL, '/web/operation/endChange', '127.0.0.1', '内网IP', '', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-19 11:20:08');
INSERT INTO `sys_oper_log` VALUES (307, '车辆管理', 1, 'com.pwt.web.controller.PwtVehicleController.add()', 'POST', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-19 11:25:35.414\",\"params\":{},\"rfid\":\"E2806995000040037517FE3B\",\"vehicleId\":7,\"vehicleName\":\"12\",\"vehicleNo\":\"12\",\"vin\":\"LZ5NB6D37PB006062\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-19 11:25:35');
INSERT INTO `sys_oper_log` VALUES (308, '结束换电', 2, 'com.pwt.web.controller.PwtOperationController.endChange()', 'POST', 1, 'admin', NULL, '/web/operation/endChange', '127.0.0.1', '内网IP', '', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-19 11:25:59');
INSERT INTO `sys_oper_log` VALUES (309, '复位', 2, 'com.pwt.web.controller.PwtOperationController.reset()', 'POST', 1, 'admin', NULL, '/web/operation/reset', '127.0.0.1', '内网IP', '', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-19 11:36:47');
INSERT INTO `sys_oper_log` VALUES (310, '换仓', 2, 'com.pwt.web.controller.PwtOperationController.moveBattery()', 'POST', 1, 'admin', NULL, '/web/operation/moveBattery', '127.0.0.1', '内网IP', '{\"source\":3,\"target\":2}', '{\"msg\":\"发送指令失败！换电机器人当前禁止远程操作\",\"code\":500}', 0, NULL, '2023-12-19 11:36:58');
INSERT INTO `sys_oper_log` VALUES (311, '换仓', 2, 'com.pwt.web.controller.PwtOperationController.moveBattery()', 'POST', 1, 'admin', NULL, '/web/operation/moveBattery', '127.0.0.1', '内网IP', '{\"source\":3,\"target\":2}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-19 11:38:21');
INSERT INTO `sys_oper_log` VALUES (312, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-19 11:42:00');
INSERT INTO `sys_oper_log` VALUES (313, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-19 16:18:52');
INSERT INTO `sys_oper_log` VALUES (314, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-19 17:23:48');
INSERT INTO `sys_oper_log` VALUES (315, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-19 17:46:41');
INSERT INTO `sys_oper_log` VALUES (316, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-20 05:57:28');
INSERT INTO `sys_oper_log` VALUES (317, '车辆管理', 1, 'com.pwt.web.controller.PwtVehicleController.add()', 'POST', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-20 10:07:42.8\",\"params\":{},\"rfid\":\"E28069950000400375179C65\",\"vehicleId\":8,\"vehicleName\":\"14\",\"vehicleNo\":\"14\",\"vin\":\"LZ5NB6D32PB006065\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-20 10:07:42');
INSERT INTO `sys_oper_log` VALUES (318, '车辆管理', 1, 'com.pwt.web.controller.PwtVehicleController.add()', 'POST', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-20 10:10:50.597\",\"params\":{},\"rfid\":\"E280699500004001BE2744C5\",\"vehicleId\":9,\"vehicleName\":\"13\",\"vehicleNo\":\"13\",\"vin\":\"LZ5NB6D37PB006059\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-20 10:10:50');
INSERT INTO `sys_oper_log` VALUES (319, '车辆管理', 1, 'com.pwt.web.controller.PwtVehicleController.add()', 'POST', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"params\":{},\"rfid\":\"E2806995000040037517F249\\t\",\"vehicleName\":\"14\",\"vehicleNo\":\"14\",\"vin\":\"LZ5NB6D36PB0060\"}', NULL, 1, '车牌号已存在,不允许操作', '2023-12-20 10:39:32');
INSERT INTO `sys_oper_log` VALUES (320, '车辆管理', 1, 'com.pwt.web.controller.PwtVehicleController.add()', 'POST', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-20 10:40:21.484\",\"params\":{},\"rfid\":\"E2806995000040037517F249\\t\",\"vehicleId\":10,\"vehicleName\":\"15\",\"vehicleNo\":\"15\",\"vin\":\"LZ5NB6D36PB006070\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-20 10:40:21');
INSERT INTO `sys_oper_log` VALUES (321, '车辆管理', 1, 'com.pwt.web.controller.PwtVehicleController.add()', 'POST', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-20 10:41:22.033\",\"params\":{},\"rfid\":\"E2806995000050037517A112\\t\",\"vehicleId\":11,\"vehicleName\":\"16\",\"vehicleNo\":\"16\",\"vin\":\"LZ5NB6D55PB006075\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-20 10:41:22');
INSERT INTO `sys_oper_log` VALUES (322, '车辆管理', 1, 'com.pwt.web.controller.PwtVehicleController.add()', 'POST', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-20 10:42:39.063\",\"params\":{},\"rfid\":\"E2806995000050037517A130\",\"vehicleId\":12,\"vehicleName\":\"17\",\"vehicleNo\":\"17\",\"vin\":\"LZ5NB6D39PB006063\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-20 10:42:39');
INSERT INTO `sys_oper_log` VALUES (323, '车辆管理', 2, 'com.pwt.web.controller.PwtVehicleController.edit()', 'PUT', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-20 10:41:22\",\"params\":{},\"rfid\":\"E2806995000050037517A112\\t\",\"vehicleId\":11,\"vehicleName\":\"16\",\"vehicleNo\":\"16\",\"vin\":\"LZ5NB6D35PB006075\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-20 10:42:51');
INSERT INTO `sys_oper_log` VALUES (324, '车辆管理', 1, 'com.pwt.web.controller.PwtVehicleController.add()', 'POST', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-20 10:44:57.757\",\"params\":{},\"rfid\":\"E2806995000050037517A106\",\"vehicleId\":13,\"vehicleName\":\"18\",\"vehicleNo\":\"18\",\"vin\":\"LZ5NB6D3XPB006072\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-20 10:44:57');
INSERT INTO `sys_oper_log` VALUES (325, '车辆管理', 2, 'com.pwt.web.controller.PwtVehicleController.edit()', 'PUT', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-20 10:41:22\",\"params\":{},\"rfid\":\"E2806995000050037517A112\\t\",\"vehicleId\":11,\"vehicleName\":\"16\",\"vehicleNo\":\"16\",\"vin\":\"LZ5NB6D35PB006075\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-20 10:45:36');
INSERT INTO `sys_oper_log` VALUES (326, '结束换电', 2, 'com.pwt.web.controller.PwtOperationController.endChange()', 'POST', 1, 'admin', NULL, '/web/operation/endChange', '127.0.0.1', '内网IP', '', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-20 11:53:26');
INSERT INTO `sys_oper_log` VALUES (327, '车辆管理', 1, 'com.pwt.web.controller.PwtVehicleController.add()', 'POST', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-21 08:46:32.926\",\"params\":{},\"rfid\":\"E28069950000400375179E4F\\t\",\"vehicleId\":14,\"vehicleName\":\"19\",\"vehicleNo\":\"19\",\"vin\":\"LZ5NB6D33PB006060\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 08:46:32');
INSERT INTO `sys_oper_log` VALUES (328, '车辆管理', 1, 'com.pwt.web.controller.PwtVehicleController.add()', 'POST', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-21 08:47:24.803\",\"params\":{},\"rfid\":\"E2806995000040037517A16D\",\"vehicleId\":15,\"vehicleName\":\"20\",\"vehicleNo\":\"20\",\"vin\":\"LZ5NB6D33PB006057\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 08:47:24');
INSERT INTO `sys_oper_log` VALUES (329, '车辆管理', 2, 'com.pwt.web.controller.PwtVehicleController.edit()', 'PUT', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-21 08:46:33\",\"params\":{},\"rfid\":\"E28069950000400375179E4F\\t\",\"vehicleId\":14,\"vehicleName\":\"19\",\"vehicleNo\":\"19\",\"vin\":\"LZ5NB6D33PB006060\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 08:47:32');
INSERT INTO `sys_oper_log` VALUES (330, '车辆管理', 2, 'com.pwt.web.controller.PwtVehicleController.edit()', 'PUT', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-20 10:44:58\",\"params\":{},\"rfid\":\"E2806995000050037517A106\",\"vehicleId\":13,\"vehicleName\":\"18\",\"vehicleNo\":\"18\",\"vin\":\"LZ5NB6D3XPB006072\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 08:47:36');
INSERT INTO `sys_oper_log` VALUES (331, '车辆管理', 2, 'com.pwt.web.controller.PwtVehicleController.edit()', 'PUT', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-20 10:41:22\",\"params\":{},\"rfid\":\"E2806995000050037517A112\\t\",\"vehicleId\":11,\"vehicleName\":\"16\",\"vehicleNo\":\"16\",\"vin\":\"LZ5NB6D35PB006075\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 08:47:45');
INSERT INTO `sys_oper_log` VALUES (332, '车辆管理', 1, 'com.pwt.web.controller.PwtVehicleController.add()', 'POST', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-21 08:48:47.879\",\"params\":{},\"rfid\":\"E2806995000050037517E917\",\"vehicleId\":16,\"vehicleName\":\"21\",\"vehicleNo\":\"21\",\"vin\":\"LZ5NB6D33PB006074\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 08:48:47');
INSERT INTO `sys_oper_log` VALUES (333, '车辆管理', 1, 'com.pwt.web.controller.PwtVehicleController.add()', 'POST', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-21 08:49:29.982\",\"params\":{},\"rfid\":\"E2806995000050037517A15C\",\"vehicleId\":17,\"vehicleName\":\"22\",\"vehicleNo\":\"22\",\"vin\":\"LZ5NB6D35PB006058\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 08:49:30');
INSERT INTO `sys_oper_log` VALUES (334, '车辆管理', 1, 'com.pwt.web.controller.PwtVehicleController.add()', 'POST', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-21 09:00:58.1\",\"params\":{},\"rfid\":\"E2806995000050037517F53E\\t\",\"vehicleId\":18,\"vehicleName\":\"23\",\"vehicleNo\":\"23\",\"vin\":\"LZ5NB6D38PB006068\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 09:00:58');
INSERT INTO `sys_oper_log` VALUES (335, '车辆管理', 1, 'com.pwt.web.controller.PwtVehicleController.add()', 'POST', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-21 09:02:16.335\",\"params\":{},\"rfid\":\"E2806995000050037517F5C1\",\"vehicleId\":19,\"vehicleName\":\"24\",\"vehicleNo\":\"24\",\"vin\":\"LZ5NB6D37PB006076\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 09:02:16');
INSERT INTO `sys_oper_log` VALUES (336, '车辆管理', 2, 'com.pwt.web.controller.PwtVehicleController.edit()', 'PUT', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-21 09:00:58\",\"params\":{},\"rfid\":\"E2806995000050037517F53E\\t\",\"vehicleId\":18,\"vehicleName\":\"23\",\"vehicleNo\":\"23\",\"vin\":\"LZ5NB6D38PB006068\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 10:31:56');
INSERT INTO `sys_oper_log` VALUES (337, '结束换电', 2, 'com.pwt.web.controller.PwtOperationController.endChange()', 'POST', 1, 'admin', NULL, '/web/operation/endChange', '127.0.0.1', '内网IP', '', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 10:33:56');
INSERT INTO `sys_oper_log` VALUES (338, '车辆管理', 2, 'com.pwt.web.controller.PwtVehicleController.edit()', 'PUT', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-21 09:00:58\",\"params\":{},\"rfid\":\"E2806995000050037517F53E\\t\",\"vehicleId\":18,\"vehicleName\":\"23\",\"vehicleNo\":\"23\",\"vin\":\"LZ5NB6D39PB006063\"}', NULL, 1, '车牌vin编码已存在,不允许操作', '2023-12-21 10:44:20');
INSERT INTO `sys_oper_log` VALUES (339, '车辆管理', 2, 'com.pwt.web.controller.PwtVehicleController.edit()', 'PUT', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-20 10:42:39\",\"params\":{},\"rfid\":\"E2806995000050037517A130\",\"vehicleId\":12,\"vehicleName\":\"17\",\"vehicleNo\":\"17\",\"vin\":\"LZ5NB6D39PB006063123456\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 10:51:37');
INSERT INTO `sys_oper_log` VALUES (340, '车辆管理', 2, 'com.pwt.web.controller.PwtVehicleController.edit()', 'PUT', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-21 09:00:58\",\"params\":{},\"rfid\":\"E2806995000050037517F53E\\t\",\"vehicleId\":18,\"vehicleName\":\"23\",\"vehicleNo\":\"23\",\"vin\":\"LZ5NB6D39PB006063\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 10:51:48');
INSERT INTO `sys_oper_log` VALUES (341, '车辆管理', 2, 'com.pwt.web.controller.PwtVehicleController.edit()', 'PUT', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-21 09:00:58\",\"params\":{},\"rfid\":\"E2806995000050037517F53E\\t\",\"vehicleId\":18,\"vehicleName\":\"23\",\"vehicleNo\":\"23\",\"vin\":\"LZ5NB6D38PB006068\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 10:54:16');
INSERT INTO `sys_oper_log` VALUES (342, '车辆管理', 2, 'com.pwt.web.controller.PwtVehicleController.edit()', 'PUT', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-20 10:42:39\",\"params\":{},\"rfid\":\"E2806995000050037517A130\",\"vehicleId\":12,\"vehicleName\":\"17\",\"vehicleNo\":\"17\",\"vin\":\"LZ5NB6D39PB006063\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 10:56:09');
INSERT INTO `sys_oper_log` VALUES (343, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-21 11:22:35');
INSERT INTO `sys_oper_log` VALUES (344, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-21 11:27:42');
INSERT INTO `sys_oper_log` VALUES (345, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-21 11:28:15');
INSERT INTO `sys_oper_log` VALUES (346, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 11:35:07');
INSERT INTO `sys_oper_log` VALUES (347, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"1\"}', '{\"msg\":\"正在换电中，请在换电前设置取电仓位！\",\"code\":500}', 0, NULL, '2023-12-21 11:35:42');
INSERT INTO `sys_oper_log` VALUES (348, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 11:41:48');
INSERT INTO `sys_oper_log` VALUES (349, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"正在换电中，请在换电前设置取电仓位！\",\"code\":500}', 0, NULL, '2023-12-21 13:57:31');
INSERT INTO `sys_oper_log` VALUES (350, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 13:57:48');
INSERT INTO `sys_oper_log` VALUES (351, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 13:57:53');
INSERT INTO `sys_oper_log` VALUES (352, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 13:57:53');
INSERT INTO `sys_oper_log` VALUES (353, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 13:57:55');
INSERT INTO `sys_oper_log` VALUES (354, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 13:58:15');
INSERT INTO `sys_oper_log` VALUES (355, '结束换电', 2, 'com.pwt.web.controller.PwtOperationController.endChange()', 'POST', 1, 'admin', NULL, '/web/operation/endChange', '127.0.0.1', '内网IP', '', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 14:01:53');
INSERT INTO `sys_oper_log` VALUES (356, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"正在换电中，请在换电前设置取电仓位！\",\"code\":500}', 0, NULL, '2023-12-21 14:01:58');
INSERT INTO `sys_oper_log` VALUES (357, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"正在换电中，请在换电前设置取电仓位！\",\"code\":500}', 0, NULL, '2023-12-21 14:01:59');
INSERT INTO `sys_oper_log` VALUES (358, '结束换电', 2, 'com.pwt.web.controller.PwtOperationController.endChange()', 'POST', 1, 'admin', NULL, '/web/operation/endChange', '127.0.0.1', '内网IP', '', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 14:02:06');
INSERT INTO `sys_oper_log` VALUES (359, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"正在换电中，请在换电前设置取电仓位！\",\"code\":500}', 0, NULL, '2023-12-21 14:02:09');
INSERT INTO `sys_oper_log` VALUES (360, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"正在换电中，请在换电前设置取电仓位！\",\"code\":500}', 0, NULL, '2023-12-21 14:02:12');
INSERT INTO `sys_oper_log` VALUES (361, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"正在换电中，请在换电前设置取电仓位！\",\"code\":500}', 0, NULL, '2023-12-21 14:02:13');
INSERT INTO `sys_oper_log` VALUES (362, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"正在换电中，请在换电前设置取电仓位！\",\"code\":500}', 0, NULL, '2023-12-21 14:02:34');
INSERT INTO `sys_oper_log` VALUES (363, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"正在换电中，请在换电前设置取电仓位！\",\"code\":500}', 0, NULL, '2023-12-21 14:02:35');
INSERT INTO `sys_oper_log` VALUES (364, '结束换电', 2, 'com.pwt.web.controller.PwtOperationController.endChange()', 'POST', 1, 'admin', NULL, '/web/operation/endChange', '127.0.0.1', '内网IP', '', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 14:02:37');
INSERT INTO `sys_oper_log` VALUES (365, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"正在换电中，请在换电前设置取电仓位！\",\"code\":500}', 0, NULL, '2023-12-21 14:02:40');
INSERT INTO `sys_oper_log` VALUES (366, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 14:03:03');
INSERT INTO `sys_oper_log` VALUES (367, '车辆管理', 2, 'com.pwt.web.controller.PwtVehicleController.edit()', 'PUT', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-20 10:40:21\",\"params\":{},\"rfid\":\"E2806995000040037517F249\",\"vehicleId\":10,\"vehicleName\":\"15\",\"vehicleNo\":\"15\",\"vin\":\"LZ5NB6D36PB006070\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 14:04:45');
INSERT INTO `sys_oper_log` VALUES (368, '车辆管理', 2, 'com.pwt.web.controller.PwtVehicleController.edit()', 'PUT', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-20 10:40:21\",\"params\":{},\"rfid\":\"E2806995000040037517F249\",\"vehicleId\":10,\"vehicleName\":\"15\",\"vehicleNo\":\"15\",\"vin\":\"LZ5NB6D36PB006070\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 14:04:57');
INSERT INTO `sys_oper_log` VALUES (369, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"正在换电中，请在换电前设置取电仓位！\",\"code\":500}', 0, NULL, '2023-12-21 14:05:01');
INSERT INTO `sys_oper_log` VALUES (370, '结束换电', 2, 'com.pwt.web.controller.PwtOperationController.endChange()', 'POST', 1, 'admin', NULL, '/web/operation/endChange', '127.0.0.1', '内网IP', '', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 14:05:05');
INSERT INTO `sys_oper_log` VALUES (371, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"正在换电中，请在换电前设置取电仓位！\",\"code\":500}', 0, NULL, '2023-12-21 14:05:10');
INSERT INTO `sys_oper_log` VALUES (372, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"正在换电中，请在换电前设置取电仓位！\",\"code\":500}', 0, NULL, '2023-12-21 14:05:11');
INSERT INTO `sys_oper_log` VALUES (373, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"正在换电中，请在换电前设置取电仓位！\",\"code\":500}', 0, NULL, '2023-12-21 14:05:27');
INSERT INTO `sys_oper_log` VALUES (374, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 14:06:14');
INSERT INTO `sys_oper_log` VALUES (375, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 14:06:19');
INSERT INTO `sys_oper_log` VALUES (376, '车辆管理', 2, 'com.pwt.web.controller.PwtVehicleController.edit()', 'PUT', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-21 09:00:58\",\"params\":{},\"rfid\":\"E2806995000050037517F53E\",\"vehicleId\":18,\"vehicleName\":\"23\",\"vehicleNo\":\"23\",\"vin\":\"LZ5NB6D38PB006068\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 14:08:05');
INSERT INTO `sys_oper_log` VALUES (377, '车辆管理', 2, 'com.pwt.web.controller.PwtVehicleController.edit()', 'PUT', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-21 08:46:33\",\"params\":{},\"rfid\":\"E28069950000400375179E4F\",\"vehicleId\":14,\"vehicleName\":\"19\",\"vehicleNo\":\"19\",\"vin\":\"LZ5NB6D33PB006060\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 14:11:24');
INSERT INTO `sys_oper_log` VALUES (378, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 14:12:16');
INSERT INTO `sys_oper_log` VALUES (379, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 14:12:18');
INSERT INTO `sys_oper_log` VALUES (380, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 14:16:13');
INSERT INTO `sys_oper_log` VALUES (381, '车辆管理', 2, 'com.pwt.web.controller.PwtVehicleController.edit()', 'PUT', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-20 10:07:43\",\"params\":{},\"rfid\":\"E280699500004001BE2744C5\",\"vehicleId\":8,\"vehicleName\":\"14\",\"vehicleNo\":\"14\",\"vin\":\"LZ5NB6D32PB006065\"}', NULL, 1, 'rfid已存在,不允许操作', '2023-12-21 14:27:52');
INSERT INTO `sys_oper_log` VALUES (382, '车辆管理', 2, 'com.pwt.web.controller.PwtVehicleController.edit()', 'PUT', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-20 10:10:51\",\"params\":{},\"rfid\":\"E28069950000400375179C6500\",\"vehicleId\":9,\"vehicleName\":\"13\",\"vehicleNo\":\"13\",\"vin\":\"LZ5NB6D37PB006059\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 14:28:10');
INSERT INTO `sys_oper_log` VALUES (383, '车辆管理', 2, 'com.pwt.web.controller.PwtVehicleController.edit()', 'PUT', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-20 10:07:43\",\"params\":{},\"rfid\":\"E280699500004001BE2744C5\",\"vehicleId\":8,\"vehicleName\":\"14\",\"vehicleNo\":\"14\",\"vin\":\"LZ5NB6D32PB006065\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 14:28:17');
INSERT INTO `sys_oper_log` VALUES (384, '车辆管理', 2, 'com.pwt.web.controller.PwtVehicleController.edit()', 'PUT', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-20 10:10:51\",\"params\":{},\"rfid\":\"E28069950000400375179C65\",\"vehicleId\":9,\"vehicleName\":\"13\",\"vehicleNo\":\"13\",\"vin\":\"LZ5NB6D37PB006059\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 14:28:22');
INSERT INTO `sys_oper_log` VALUES (385, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.changeAutoChangeWarehouse()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig/changeAutoChangeWarehouse/1', '127.0.0.1', '内网IP', '1 false', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 14:29:31');
INSERT INTO `sys_oper_log` VALUES (386, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"4\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 14:37:21');
INSERT INTO `sys_oper_log` VALUES (387, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 14:43:07');
INSERT INTO `sys_oper_log` VALUES (388, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 14:43:08');
INSERT INTO `sys_oper_log` VALUES (389, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"2\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 14:56:12');
INSERT INTO `sys_oper_log` VALUES (390, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"2\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 14:56:18');
INSERT INTO `sys_oper_log` VALUES (391, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 15:03:59');
INSERT INTO `sys_oper_log` VALUES (392, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 15:04:01');
INSERT INTO `sys_oper_log` VALUES (393, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.changeAutoChangeWarehouse()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig/changeAutoChangeWarehouse/1', '127.0.0.1', '内网IP', '1 true', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 15:11:24');
INSERT INTO `sys_oper_log` VALUES (394, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.changeAutoChangeWarehouse()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig/changeAutoChangeWarehouse/1', '127.0.0.1', '内网IP', '1 false', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 15:19:48');
INSERT INTO `sys_oper_log` VALUES (395, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"2\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 15:20:33');
INSERT INTO `sys_oper_log` VALUES (396, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"2\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 15:20:34');
INSERT INTO `sys_oper_log` VALUES (397, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"2\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 15:25:44');
INSERT INTO `sys_oper_log` VALUES (398, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"2\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 15:25:44');
INSERT INTO `sys_oper_log` VALUES (399, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 15:32:43');
INSERT INTO `sys_oper_log` VALUES (400, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 15:32:43');
INSERT INTO `sys_oper_log` VALUES (401, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 15:39:00');
INSERT INTO `sys_oper_log` VALUES (402, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 15:39:01');
INSERT INTO `sys_oper_log` VALUES (403, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 15:41:17');
INSERT INTO `sys_oper_log` VALUES (404, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 15:41:18');
INSERT INTO `sys_oper_log` VALUES (405, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 15:53:10');
INSERT INTO `sys_oper_log` VALUES (406, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 15:53:10');
INSERT INTO `sys_oper_log` VALUES (407, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-21 16:00:28');
INSERT INTO `sys_oper_log` VALUES (408, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-21 16:04:25');
INSERT INTO `sys_oper_log` VALUES (409, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.changeAutoChangeWarehouse()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig/changeAutoChangeWarehouse/1', '127.0.0.1', '内网IP', '1 true', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 16:09:23');
INSERT INTO `sys_oper_log` VALUES (410, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.changeAutoChangeWarehouse()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig/changeAutoChangeWarehouse/1', '127.0.0.1', '内网IP', '1 false', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 16:25:02');
INSERT INTO `sys_oper_log` VALUES (411, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"2\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 16:25:22');
INSERT INTO `sys_oper_log` VALUES (412, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"2\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 16:25:25');
INSERT INTO `sys_oper_log` VALUES (413, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.changeAutoChangeWarehouse()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig/changeAutoChangeWarehouse/1', '127.0.0.1', '内网IP', '1 true', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 16:42:43');
INSERT INTO `sys_oper_log` VALUES (414, '车辆管理', 2, 'com.pwt.web.controller.PwtVehicleController.edit()', 'PUT', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-20 10:41:22\",\"params\":{},\"rfid\":\"E2806995000050037517A112\",\"vehicleId\":11,\"vehicleName\":\"16\",\"vehicleNo\":\"16\",\"vin\":\"LZ5NB6D35PB006075\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 16:52:39');
INSERT INTO `sys_oper_log` VALUES (415, '结束换电', 2, 'com.pwt.web.controller.PwtOperationController.endChange()', 'POST', 1, 'admin', NULL, '/web/operation/endChange', '127.0.0.1', '内网IP', '', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 16:52:45');
INSERT INTO `sys_oper_log` VALUES (416, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.changeAutoChangeWarehouse()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig/changeAutoChangeWarehouse/1', '127.0.0.1', '内网IP', '1 false', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 17:49:30');
INSERT INTO `sys_oper_log` VALUES (417, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.changeAutoChangeWarehouse()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig/changeAutoChangeWarehouse/1', '127.0.0.1', '内网IP', '1 true', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 17:49:52');
INSERT INTO `sys_oper_log` VALUES (418, '车辆管理', 1, 'com.pwt.web.controller.PwtVehicleController.add()', 'POST', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-21 17:57:30.063\",\"params\":{},\"rfid\":\"E2806995000040037517A0AC\",\"vehicleId\":20,\"vehicleName\":\"25\",\"vehicleNo\":\"25\",\"vin\":\"LZ5NB6D3XPB006069\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 17:57:30');
INSERT INTO `sys_oper_log` VALUES (419, '车辆管理', 1, 'com.pwt.web.controller.PwtVehicleController.add()', 'POST', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-21 17:58:27.9\",\"params\":{},\"rfid\":\"E28069950000400375179C96\",\"vehicleId\":21,\"vehicleName\":\"26\",\"vehicleNo\":\"26\",\"vin\":\"LZ5NB6D31PB006073\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 17:58:27');
INSERT INTO `sys_oper_log` VALUES (420, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.changeAutoChangeWarehouse()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig/changeAutoChangeWarehouse/1', '127.0.0.1', '内网IP', '1 false', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 18:45:17');
INSERT INTO `sys_oper_log` VALUES (421, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"正在换电中，请在换电前设置取电仓位！\",\"code\":500}', 0, NULL, '2023-12-21 18:50:30');
INSERT INTO `sys_oper_log` VALUES (422, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"正在换电中，请在换电前设置取电仓位！\",\"code\":500}', 0, NULL, '2023-12-21 18:50:40');
INSERT INTO `sys_oper_log` VALUES (423, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 18:50:51');
INSERT INTO `sys_oper_log` VALUES (424, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 18:50:51');
INSERT INTO `sys_oper_log` VALUES (425, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 18:50:53');
INSERT INTO `sys_oper_log` VALUES (426, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 18:50:54');
INSERT INTO `sys_oper_log` VALUES (427, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ13\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-21 18:54:39');
INSERT INTO `sys_oper_log` VALUES (428, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 18:59:06');
INSERT INTO `sys_oper_log` VALUES (429, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-21 19:03:26');
INSERT INTO `sys_oper_log` VALUES (430, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 19:05:53');
INSERT INTO `sys_oper_log` VALUES (431, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 19:05:56');
INSERT INTO `sys_oper_log` VALUES (432, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.changeAutoChangeWarehouse()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig/changeAutoChangeWarehouse/1', '127.0.0.1', '内网IP', '1 true', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-21 19:11:57');
INSERT INTO `sys_oper_log` VALUES (433, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-22 08:35:15');
INSERT INTO `sys_oper_log` VALUES (434, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-22 08:35:15');
INSERT INTO `sys_oper_log` VALUES (435, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-22 08:39:31');
INSERT INTO `sys_oper_log` VALUES (436, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-22 08:39:31');
INSERT INTO `sys_oper_log` VALUES (437, '充电机停止', 2, 'com.pwt.web.controller.PwtOperationController.stopCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStop', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-22 08:51:47');
INSERT INTO `sys_oper_log` VALUES (438, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ21\",\"chargerId\":\"GHLN10183CDJ2\",\"emergency\":false}', '{\"msg\":\"resp status:1\",\"code\":200}', 0, NULL, '2023-12-22 08:58:51');
INSERT INTO `sys_oper_log` VALUES (439, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-22 09:10:15');
INSERT INTO `sys_oper_log` VALUES (440, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-22 09:10:16');
INSERT INTO `sys_oper_log` VALUES (441, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-22 09:16:44');
INSERT INTO `sys_oper_log` VALUES (442, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-22 09:16:44');
INSERT INTO `sys_oper_log` VALUES (443, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-22 09:22:37');
INSERT INTO `sys_oper_log` VALUES (444, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-22 09:22:38');
INSERT INTO `sys_oper_log` VALUES (445, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-22 09:22:41');
INSERT INTO `sys_oper_log` VALUES (446, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-22 09:28:38');
INSERT INTO `sys_oper_log` VALUES (447, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-22 09:28:38');
INSERT INTO `sys_oper_log` VALUES (448, '车辆管理', 1, 'com.pwt.web.controller.PwtVehicleController.add()', 'POST', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-22 09:47:51.384\",\"params\":{},\"rfid\":\"E2806995000040037517A0B2\",\"vehicleId\":22,\"vehicleName\":\"27\",\"vehicleNo\":\"27\",\"vin\":\"LZ5NB6D36PB006067\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-22 09:47:51');
INSERT INTO `sys_oper_log` VALUES (449, '车辆管理', 1, 'com.pwt.web.controller.PwtVehicleController.add()', 'POST', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-22 09:48:35.834\",\"params\":{},\"rfid\":\"E2806995000050037517F872\",\"vehicleId\":23,\"vehicleName\":\"28\",\"vehicleNo\":\"28\",\"vin\":\"LZ5NB6D35PB006061\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-22 09:48:35');
INSERT INTO `sys_oper_log` VALUES (450, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"4\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-22 09:49:06');
INSERT INTO `sys_oper_log` VALUES (451, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"4\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-22 10:04:58');
INSERT INTO `sys_oper_log` VALUES (452, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"4\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-22 10:04:58');
INSERT INTO `sys_oper_log` VALUES (453, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-22 10:55:32');
INSERT INTO `sys_oper_log` VALUES (454, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-22 10:55:33');
INSERT INTO `sys_oper_log` VALUES (455, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-22 11:05:19');
INSERT INTO `sys_oper_log` VALUES (456, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-22 11:05:21');
INSERT INTO `sys_oper_log` VALUES (457, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"3\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-22 11:22:32');
INSERT INTO `sys_oper_log` VALUES (458, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"2\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-22 11:23:42');
INSERT INTO `sys_oper_log` VALUES (459, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"2\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-22 11:23:44');
INSERT INTO `sys_oper_log` VALUES (460, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"4\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-22 11:45:05');
INSERT INTO `sys_oper_log` VALUES (461, '车辆管理', 1, 'com.pwt.web.controller.PwtVehicleController.add()', 'POST', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-22 13:50:07.75\",\"params\":{},\"rfid\":\"E2806995000050037517FA76\",\"vehicleId\":24,\"vehicleName\":\"29\",\"vehicleNo\":\"29\",\"vin\":\"LZ5NB6D30PB006064\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-22 13:50:07');
INSERT INTO `sys_oper_log` VALUES (462, '车辆管理', 1, 'com.pwt.web.controller.PwtVehicleController.add()', 'POST', 1, 'admin', NULL, '/web/vehicle', '127.0.0.1', '内网IP', '{\"createTime\":\"2023-12-22 13:50:53.805\",\"params\":{},\"rfid\":\"E2806995000040037517F5E7\",\"vehicleId\":25,\"vehicleName\":\"30\",\"vehicleNo\":\"30\",\"vin\":\"LZ5NB6D38PB006071\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-22 13:50:53');
INSERT INTO `sys_oper_log` VALUES (463, '设置下一次换电', 2, 'com.pwt.web.controller.PwtOperationController.setNextChargingGetBattery()', 'POST', 1, 'admin', NULL, '/web/operation/setNextChargingGetBattery', '127.0.0.1', '内网IP', '{\"holderId\":\"1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-22 14:18:01');
INSERT INTO `sys_oper_log` VALUES (464, '复位', 2, 'com.pwt.web.controller.PwtOperationController.reset()', 'POST', 1, 'admin', NULL, '/web/operation/reset', '127.0.0.1', '内网IP', '', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2023-12-23 13:58:43');
INSERT INTO `sys_oper_log` VALUES (465, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"23\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"充电机目前正在充电，无法启用应急充电！\",\"code\":500}', 0, NULL, '2023-12-23 17:11:28');
INSERT INTO `sys_oper_log` VALUES (466, '应急充电', 5, 'com.pwt.web.controller.PwtChargeRecordController.valid()', 'POST', 1, 'admin', NULL, '/web/chargeRecord/valid', '127.0.0.1', '内网IP', '{\"carNo\":\"23\",\"chargerGunId\":\"\",\"chargerId\":\"\",\"params\":{}}', '{\"msg\":\"充电机目前正在充电，无法启用应急充电！\",\"code\":500}', 0, NULL, '2023-12-23 17:11:39');
INSERT INTO `sys_oper_log` VALUES (467, '充电机启动', 2, 'com.pwt.web.controller.PwtOperationController.startCharge()', 'POST', 1, 'admin', NULL, '/web/operation/chargerStart', '127.0.0.1', '内网IP', '{\"chargerGunId\":\"GHLN10183CDJ11\",\"chargerId\":\"GHLN10183CDJ1\",\"emergency\":false}', '{\"msg\":\"该充电机未连接\",\"code\":500}', 0, NULL, '2024-03-26 08:33:54');
INSERT INTO `sys_oper_log` VALUES (468, '菜单管理', 1, 'com.pwt.web.controller.system.SysMenuController.add()', 'POST', 1, 'admin', NULL, '/system/menu', '127.0.0.1', '内网IP', '{\"children\":[],\"createBy\":\"admin\",\"isCache\":\"0\",\"isFrame\":\"1\",\"menuName\":\"电表监控\",\"menuType\":\"M\",\"orderNum\":4,\"params\":{},\"parentId\":0,\"path\":\"system/electronic/index\",\"status\":\"0\",\"visible\":\"0\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2024-04-08 08:30:25');
INSERT INTO `sys_oper_log` VALUES (469, '菜单管理', 2, 'com.pwt.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', NULL, '/system/menu', '127.0.0.1', '内网IP', '{\"children\":[],\"createTime\":\"2024-04-08 08:30:25\",\"icon\":\"#\",\"isCache\":\"0\",\"isFrame\":\"1\",\"menuId\":2046,\"menuName\":\"电表监控\",\"menuType\":\"M\",\"orderNum\":4,\"params\":{},\"parentId\":0,\"path\":\"electronic/index\",\"perms\":\"\",\"status\":\"0\",\"updateBy\":\"admin\",\"visible\":\"0\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2024-04-08 08:31:32');
INSERT INTO `sys_oper_log` VALUES (470, '菜单管理', 2, 'com.pwt.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', NULL, '/system/menu', '127.0.0.1', '内网IP', '{\"children\":[],\"createTime\":\"2024-04-08 08:30:25\",\"icon\":\"#\",\"isCache\":\"0\",\"isFrame\":\"1\",\"menuId\":2046,\"menuName\":\"电表监控\",\"menuType\":\"C\",\"orderNum\":4,\"params\":{},\"parentId\":0,\"path\":\"electronic/index\",\"perms\":\"\",\"status\":\"0\",\"updateBy\":\"admin\",\"visible\":\"0\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2024-04-08 08:33:51');
INSERT INTO `sys_oper_log` VALUES (471, '菜单管理', 2, 'com.pwt.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', NULL, '/system/menu', '127.0.0.1', '内网IP', '{\"children\":[],\"createTime\":\"2024-04-08 08:30:25\",\"icon\":\"#\",\"isCache\":\"0\",\"isFrame\":\"1\",\"menuId\":2046,\"menuName\":\"电表监控\",\"menuType\":\"M\",\"orderNum\":4,\"params\":{},\"parentId\":0,\"path\":\"electronic/index\",\"perms\":\"\",\"status\":\"0\",\"updateBy\":\"admin\",\"visible\":\"0\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2024-04-08 08:36:29');
INSERT INTO `sys_oper_log` VALUES (472, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.edit()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig', '127.0.0.1', '内网IP', '{\"agreementType\":\"A\",\"charger1Emg\":false,\"charger1Ip\":\"192.168.3.41\",\"charger1No\":\"11111111111111\",\"charger1Port\":8080,\"charger2Emg\":true,\"charger2Ip\":\"192.168.3.42\",\"charger2No\":\"11111111111113\",\"charger2Port\":8080,\"charger3Emg\":false,\"charger3Ip\":\"192.168.3.43\",\"charger3No\":\"22222222222221\",\"charger3Port\":8088,\"charger4Emg\":false,\"charger4Ip\":\"192.168.3.44\",\"charger4No\":\"0\",\"charger4Port\":8088,\"charger5Emg\":false,\"charger5Ip\":\"192.168.3.45\",\"charger5No\":\"0\",\"charger5Port\":8088,\"charger6Emg\":false,\"charger6Ip\":\"192.168.3.46\",\"charger6No\":\"0\",\"charger6Port\":8088,\"charger7Emg\":false,\"charger7Ip\":\"192.168.3.47\",\"charger7No\":\"0\",\"charger7Port\":8088,\"charger8Emg\":false,\"charger8Ip\":\"192.168.3.48\",\"charger8No\":\"0\",\"charger8Port\":8088,\"id\":1,\"params\":{},\"rfidIp\":\"192.168.0.3\",\"rfidPort\":2000,\"robotIp\":\"19.168.0.1\",\"robotNo\":\"Robbot_001\",\"scannerIp\":\"192.168.0.2\",\"scannerPort\":3000,\"systemIp\":\"127.0.0.1\",\"systemPort\":3000,\"vehicleCidr\":\"127.0.0.1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2024-04-08 08:51:24');
INSERT INTO `sys_oper_log` VALUES (473, '系统配置', 2, 'com.pwt.web.controller.system.PwtConfigController.edit()', 'PUT', 1, 'admin', NULL, '/system/pwtConfig', '127.0.0.1', '内网IP', '{\"agreementType\":\"A\",\"charger1Emg\":false,\"charger1Ip\":\"192.168.3.41\",\"charger1No\":\"11111111111113\",\"charger1Port\":8080,\"charger2Emg\":true,\"charger2Ip\":\"192.168.3.42\",\"charger2No\":\"22222222222221\",\"charger2Port\":8080,\"charger3Emg\":false,\"charger3Ip\":\"192.168.3.43\",\"charger3No\":\"11111111111111\",\"charger3Port\":8088,\"charger4Emg\":false,\"charger4Ip\":\"192.168.3.44\",\"charger4No\":\"0\",\"charger4Port\":8088,\"charger5Emg\":false,\"charger5Ip\":\"192.168.3.45\",\"charger5No\":\"0\",\"charger5Port\":8088,\"charger6Emg\":false,\"charger6Ip\":\"192.168.3.46\",\"charger6No\":\"0\",\"charger6Port\":8088,\"charger7Emg\":false,\"charger7Ip\":\"192.168.3.47\",\"charger7No\":\"0\",\"charger7Port\":8088,\"charger8Emg\":false,\"charger8Ip\":\"192.168.3.48\",\"charger8No\":\"0\",\"charger8Port\":8088,\"id\":1,\"params\":{},\"rfidIp\":\"192.168.0.3\",\"rfidPort\":2000,\"robotIp\":\"19.168.0.1\",\"robotNo\":\"Robbot_001\",\"scannerIp\":\"192.168.0.2\",\"scannerPort\":3000,\"systemIp\":\"127.0.0.1\",\"systemPort\":3000,\"vehicleCidr\":\"127.0.0.1\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2024-04-08 08:53:11');
INSERT INTO `sys_oper_log` VALUES (474, '菜单管理', 2, 'com.pwt.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', NULL, '/system/menu', '127.0.0.1', '内网IP', '{\"children\":[],\"component\":\"electronic/index\",\"createTime\":\"2024-04-08 08:30:25\",\"icon\":\"#\",\"isCache\":\"0\",\"isFrame\":\"1\",\"menuId\":2046,\"menuName\":\"电表监控\",\"menuType\":\"C\",\"orderNum\":4,\"params\":{},\"parentId\":0,\"path\":\"electronic/index\",\"perms\":\"\",\"status\":\"0\",\"updateBy\":\"admin\",\"visible\":\"0\"}', '{\"msg\":\"操作成功\",\"code\":200}', 0, NULL, '2024-04-08 08:56:01');

-- ----------------------------
-- Table structure for sys_role
-- ----------------------------
DROP TABLE IF EXISTS `sys_role`;
CREATE TABLE `sys_role`  (
  `role_id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '角色ID',
  `role_name` varchar(30) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '角色名称',
  `role_key` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '角色权限字符串',
  `role_sort` int(11) NOT NULL COMMENT '显示顺序',
  `data_scope` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '1' COMMENT '数据范围（1：全部数据权限 2：自定数据权限 3：本部门数据权限 4：本部门及以下数据权限）',
  `menu_check_strictly` tinyint(1) NULL DEFAULT 1 COMMENT '菜单树选择项是否关联显示',
  `status` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '角色状态（0正常 1停用）',
  `del_flag` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '0' COMMENT '删除标志（0代表存在 2代表删除）',
  `create_by` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '创建者',
  `create_time` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `update_by` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '更新者',
  `update_time` datetime(0) NULL DEFAULT NULL COMMENT '更新时间',
  `remark` varchar(500) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '备注',
  PRIMARY KEY (`role_id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 100 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '角色信息表' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of sys_role
-- ----------------------------
INSERT INTO `sys_role` VALUES (1, '管理员', 'admin', 1, '1', 1, '0', '0', 'admin', '2022-11-01 10:16:32', '', NULL, '管理员');
INSERT INTO `sys_role` VALUES (2, '操作员', 'operator', 2, '2', 1, '0', '0', 'admin', '2022-11-01 10:16:32', 'admin', '2023-08-25 09:16:04', '监控员');
INSERT INTO `sys_role` VALUES (100, '监控员', 'monitor', 3, '1', 0, '0', '0', 'admin', '2022-12-05 15:36:29', 'admin', '2023-01-13 09:39:20', '监控员');

-- ----------------------------
-- Table structure for sys_role_menu
-- ----------------------------
DROP TABLE IF EXISTS `sys_role_menu`;
CREATE TABLE `sys_role_menu`  (
  `role_id` bigint(20) NOT NULL COMMENT '角色ID',
  `menu_id` bigint(20) NOT NULL COMMENT '菜单ID',
  PRIMARY KEY (`role_id`, `menu_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci COMMENT = '角色和菜单关联表' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of sys_role_menu
-- ----------------------------
INSERT INTO `sys_role_menu` VALUES (1, 1);
INSERT INTO `sys_role_menu` VALUES (1, 100);
INSERT INTO `sys_role_menu` VALUES (1, 101);
INSERT INTO `sys_role_menu` VALUES (1, 102);
INSERT INTO `sys_role_menu` VALUES (1, 108);
INSERT INTO `sys_role_menu` VALUES (1, 117);
INSERT INTO `sys_role_menu` VALUES (1, 500);
INSERT INTO `sys_role_menu` VALUES (1, 501);
INSERT INTO `sys_role_menu` VALUES (1, 1000);
INSERT INTO `sys_role_menu` VALUES (1, 1001);
INSERT INTO `sys_role_menu` VALUES (1, 1002);
INSERT INTO `sys_role_menu` VALUES (1, 1003);
INSERT INTO `sys_role_menu` VALUES (1, 1004);
INSERT INTO `sys_role_menu` VALUES (1, 1005);
INSERT INTO `sys_role_menu` VALUES (1, 1006);
INSERT INTO `sys_role_menu` VALUES (1, 1007);
INSERT INTO `sys_role_menu` VALUES (1, 1008);
INSERT INTO `sys_role_menu` VALUES (1, 1009);
INSERT INTO `sys_role_menu` VALUES (1, 1010);
INSERT INTO `sys_role_menu` VALUES (1, 1011);
INSERT INTO `sys_role_menu` VALUES (1, 1012);
INSERT INTO `sys_role_menu` VALUES (1, 1013);
INSERT INTO `sys_role_menu` VALUES (1, 1014);
INSERT INTO `sys_role_menu` VALUES (1, 1015);
INSERT INTO `sys_role_menu` VALUES (1, 1039);
INSERT INTO `sys_role_menu` VALUES (1, 1040);
INSERT INTO `sys_role_menu` VALUES (1, 1041);
INSERT INTO `sys_role_menu` VALUES (1, 1042);
INSERT INTO `sys_role_menu` VALUES (1, 1043);
INSERT INTO `sys_role_menu` VALUES (1, 1044);
INSERT INTO `sys_role_menu` VALUES (1, 1045);
INSERT INTO `sys_role_menu` VALUES (1, 2000);
INSERT INTO `sys_role_menu` VALUES (1, 2001);
INSERT INTO `sys_role_menu` VALUES (1, 2002);
INSERT INTO `sys_role_menu` VALUES (1, 2003);
INSERT INTO `sys_role_menu` VALUES (1, 2004);
INSERT INTO `sys_role_menu` VALUES (1, 2005);
INSERT INTO `sys_role_menu` VALUES (1, 2006);
INSERT INTO `sys_role_menu` VALUES (1, 2007);
INSERT INTO `sys_role_menu` VALUES (1, 2008);
INSERT INTO `sys_role_menu` VALUES (1, 2009);
INSERT INTO `sys_role_menu` VALUES (1, 2010);
INSERT INTO `sys_role_menu` VALUES (1, 2012);
INSERT INTO `sys_role_menu` VALUES (1, 2015);
INSERT INTO `sys_role_menu` VALUES (1, 2016);
INSERT INTO `sys_role_menu` VALUES (1, 2017);
INSERT INTO `sys_role_menu` VALUES (1, 2018);
INSERT INTO `sys_role_menu` VALUES (1, 2019);
INSERT INTO `sys_role_menu` VALUES (1, 2020);
INSERT INTO `sys_role_menu` VALUES (1, 2021);
INSERT INTO `sys_role_menu` VALUES (1, 2022);
INSERT INTO `sys_role_menu` VALUES (1, 2023);
INSERT INTO `sys_role_menu` VALUES (1, 2024);
INSERT INTO `sys_role_menu` VALUES (1, 2025);
INSERT INTO `sys_role_menu` VALUES (1, 2026);
INSERT INTO `sys_role_menu` VALUES (1, 2027);
INSERT INTO `sys_role_menu` VALUES (1, 2028);
INSERT INTO `sys_role_menu` VALUES (1, 2029);
INSERT INTO `sys_role_menu` VALUES (1, 2030);
INSERT INTO `sys_role_menu` VALUES (1, 2031);
INSERT INTO `sys_role_menu` VALUES (1, 2032);
INSERT INTO `sys_role_menu` VALUES (1, 2033);
INSERT INTO `sys_role_menu` VALUES (1, 2034);
INSERT INTO `sys_role_menu` VALUES (1, 2035);
INSERT INTO `sys_role_menu` VALUES (1, 2036);
INSERT INTO `sys_role_menu` VALUES (1, 2037);
INSERT INTO `sys_role_menu` VALUES (1, 2038);
INSERT INTO `sys_role_menu` VALUES (1, 2039);
INSERT INTO `sys_role_menu` VALUES (1, 2040);
INSERT INTO `sys_role_menu` VALUES (1, 2041);
INSERT INTO `sys_role_menu` VALUES (1, 2042);
INSERT INTO `sys_role_menu` VALUES (2, 2000);
INSERT INTO `sys_role_menu` VALUES (2, 2001);
INSERT INTO `sys_role_menu` VALUES (2, 2002);
INSERT INTO `sys_role_menu` VALUES (2, 2003);
INSERT INTO `sys_role_menu` VALUES (2, 2004);
INSERT INTO `sys_role_menu` VALUES (2, 2005);
INSERT INTO `sys_role_menu` VALUES (2, 2006);
INSERT INTO `sys_role_menu` VALUES (2, 2007);
INSERT INTO `sys_role_menu` VALUES (2, 2019);
INSERT INTO `sys_role_menu` VALUES (2, 2020);
INSERT INTO `sys_role_menu` VALUES (2, 2021);
INSERT INTO `sys_role_menu` VALUES (2, 2028);
INSERT INTO `sys_role_menu` VALUES (2, 2029);
INSERT INTO `sys_role_menu` VALUES (2, 2030);
INSERT INTO `sys_role_menu` VALUES (2, 2031);
INSERT INTO `sys_role_menu` VALUES (2, 2032);
INSERT INTO `sys_role_menu` VALUES (2, 2033);
INSERT INTO `sys_role_menu` VALUES (2, 2041);
INSERT INTO `sys_role_menu` VALUES (2, 2043);
INSERT INTO `sys_role_menu` VALUES (2, 2044);
INSERT INTO `sys_role_menu` VALUES (2, 2045);
INSERT INTO `sys_role_menu` VALUES (100, 2000);
INSERT INTO `sys_role_menu` VALUES (100, 2001);
INSERT INTO `sys_role_menu` VALUES (100, 2002);
INSERT INTO `sys_role_menu` VALUES (100, 2003);
INSERT INTO `sys_role_menu` VALUES (100, 2004);
INSERT INTO `sys_role_menu` VALUES (100, 2005);
INSERT INTO `sys_role_menu` VALUES (100, 2006);
INSERT INTO `sys_role_menu` VALUES (100, 2007);
INSERT INTO `sys_role_menu` VALUES (100, 2010);
INSERT INTO `sys_role_menu` VALUES (100, 2016);
INSERT INTO `sys_role_menu` VALUES (100, 2020);

-- ----------------------------
-- Table structure for sys_user
-- ----------------------------
DROP TABLE IF EXISTS `sys_user`;
CREATE TABLE `sys_user`  (
  `user_id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '用户ID',
  `user_name` varchar(30) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '用户账号',
  `nick_name` varchar(30) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '用户昵称',
  `user_type` varchar(2) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '00' COMMENT '用户类型（00系统用户）',
  `name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '用户姓名',
  `phonenumber` varchar(11) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '手机号码',
  `sex` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '0' COMMENT '用户性别（0男 1女 2未知）',
  `avatar` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '头像地址',
  `password` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '密码',
  `status` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '0' COMMENT '帐号状态（0正常 1停用）',
  `del_flag` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '0' COMMENT '删除标志（0代表存在 2代表删除）',
  `login_ip` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '最后登录IP',
  `login_date` datetime(0) NULL DEFAULT NULL COMMENT '最后登录时间',
  `create_by` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '创建者',
  `create_time` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `update_by` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '更新者',
  `update_time` datetime(0) NULL DEFAULT NULL COMMENT '更新时间',
  `remark` varchar(500) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '备注',
  PRIMARY KEY (`user_id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci COMMENT = '用户信息表' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of sys_user
-- ----------------------------
INSERT INTO `sys_user` VALUES (1, 'admin', '管理员', '00', '840618902@qq.com', '18505107840', '0', '', '$2a$10$7JB720yubVSZvUI0rEqK/.VqGOZTH.ulu33dHOiBE8ByOhJIrdAu2', '0', '0', '127.0.0.1', '2024-05-10 08:43:48', 'admin', '2022-11-01 10:16:30', '', '2024-05-10 08:43:48', '管理员');

-- ----------------------------
-- Table structure for sys_user_role
-- ----------------------------
DROP TABLE IF EXISTS `sys_user_role`;
CREATE TABLE `sys_user_role`  (
  `user_id` bigint(20) NOT NULL COMMENT '用户ID',
  `role_id` bigint(20) NOT NULL COMMENT '角色ID',
  PRIMARY KEY (`user_id`, `role_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci COMMENT = '用户和角色关联表' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of sys_user_role
-- ----------------------------
INSERT INTO `sys_user_role` VALUES (1, 1);

SET FOREIGN_KEY_CHECKS = 1;
